/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _213MP7JRSAUDIOVISUALSEGMENTMEDIASOURCEDECOMPOSITIONTYPE_LOCALTYPE_H
#define _213MP7JRSAUDIOVISUALSEGMENTMEDIASOURCEDECOMPOSITIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType_ExtInclude.h


class IMp7JrsAudioSegmentType;
class IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType;
class IMp7JrsAudioVisualSegmentType;
class IMp7JrsReferenceType;
class IMp7JrsStillRegionType;
class IMp7JrsVideoSegmentType;
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType > Mp7JrsAudioSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType> Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentType > Mp7JrsAudioVisualSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsStillRegionType > Mp7JrsStillRegionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType > Mp7JrsVideoSegmentPtr;

/** 
 * Generated interface IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType for class Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType();
    virtual ~IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get AudioVisualSegment element.
     * @return Mp7JrsAudioVisualSegmentPtr
     */
    virtual Mp7JrsAudioVisualSegmentPtr GetAudioVisualSegment() const = 0;

    /**
     * Set AudioVisualSegment element.
     * @param item const Mp7JrsAudioVisualSegmentPtr &
     */
    // Mandatory			
    virtual void SetAudioVisualSegment(const Mp7JrsAudioVisualSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioVisualSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioVisualSegmentRef() const = 0;

    /**
     * Set AudioVisualSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetAudioVisualSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get VideoSegment element.
     * @return Mp7JrsVideoSegmentPtr
     */
    virtual Mp7JrsVideoSegmentPtr GetVideoSegment() const = 0;

    /**
     * Set VideoSegment element.
     * @param item const Mp7JrsVideoSegmentPtr &
     */
    // Mandatory			
    virtual void SetVideoSegment(const Mp7JrsVideoSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get VideoSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetVideoSegmentRef() const = 0;

    /**
     * Set VideoSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetVideoSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get StillRegion element.
     * @return Mp7JrsStillRegionPtr
     */
    virtual Mp7JrsStillRegionPtr GetStillRegion() const = 0;

    /**
     * Set StillRegion element.
     * @param item const Mp7JrsStillRegionPtr &
     */
    // Mandatory			
    virtual void SetStillRegion(const Mp7JrsStillRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get StillRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetStillRegionRef() const = 0;

    /**
     * Set StillRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetStillRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioSegment element.
     * @return Mp7JrsAudioSegmentPtr
     */
    virtual Mp7JrsAudioSegmentPtr GetAudioSegment() const = 0;

    /**
     * Set AudioSegment element.
     * @param item const Mp7JrsAudioSegmentPtr &
     */
    // Mandatory			
    virtual void SetAudioSegment(const Mp7JrsAudioSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioSegmentRef() const = 0;

    /**
     * Set AudioSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetAudioSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 6138.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType :
        public IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType
{
    friend class Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get AudioVisualSegment element.
     * @return Mp7JrsAudioVisualSegmentPtr
     */
    virtual Mp7JrsAudioVisualSegmentPtr GetAudioVisualSegment() const;

    /*
     * Set AudioVisualSegment element.
     * @param item const Mp7JrsAudioVisualSegmentPtr &
     */
    // Mandatory			
    virtual void SetAudioVisualSegment(const Mp7JrsAudioVisualSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioVisualSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioVisualSegmentRef() const;

    /*
     * Set AudioVisualSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetAudioVisualSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get VideoSegment element.
     * @return Mp7JrsVideoSegmentPtr
     */
    virtual Mp7JrsVideoSegmentPtr GetVideoSegment() const;

    /*
     * Set VideoSegment element.
     * @param item const Mp7JrsVideoSegmentPtr &
     */
    // Mandatory			
    virtual void SetVideoSegment(const Mp7JrsVideoSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get VideoSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetVideoSegmentRef() const;

    /*
     * Set VideoSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetVideoSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get StillRegion element.
     * @return Mp7JrsStillRegionPtr
     */
    virtual Mp7JrsStillRegionPtr GetStillRegion() const;

    /*
     * Set StillRegion element.
     * @param item const Mp7JrsStillRegionPtr &
     */
    // Mandatory			
    virtual void SetStillRegion(const Mp7JrsStillRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get StillRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetStillRegionRef() const;

    /*
     * Set StillRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetStillRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioSegment element.
     * @return Mp7JrsAudioSegmentPtr
     */
    virtual Mp7JrsAudioSegmentPtr GetAudioSegment() const;

    /*
     * Set AudioSegment element.
     * @param item const Mp7JrsAudioSegmentPtr &
     */
    // Mandatory			
    virtual void SetAudioSegment(const Mp7JrsAudioSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioSegmentRef() const;

    /*
     * Set AudioSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetAudioSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType();

protected:
    Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsAudioVisualSegmentPtr m_AudioVisualSegment;
    Mp7JrsReferencePtr m_AudioVisualSegmentRef;
    Mp7JrsVideoSegmentPtr m_VideoSegment;
    Mp7JrsReferencePtr m_VideoSegmentRef;
    Mp7JrsStillRegionPtr m_StillRegion;
    Mp7JrsReferencePtr m_StillRegionRef;
    Mp7JrsAudioSegmentPtr m_AudioSegment;
    Mp7JrsReferencePtr m_AudioSegmentRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _213MP7JRSAUDIOVISUALSEGMENTMEDIASOURCEDECOMPOSITIONTYPE_LOCALTYPE_H

