/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef MP7JRS_CONVERT_H
#define MP7JRS_CONVERT_H

#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

/** Type conversions. */
class MP7JRS_EXPORT Mp7JrsConvert
{
public:
	static XMLCh * BinToText(int src);
	static XMLCh * BinToText(unsigned int src);
	static XMLCh * BinToText(float src);
	static XMLCh * BinToText(double src);

	static int TextToInt(const XMLCh* text);
	static unsigned int TextToUnsignedInt(const XMLCh * text);
	static bool TextToBool(const XMLCh* text);
	static XMLCh * TextToString(const XMLCh * text);
	static float TextToFloat(const XMLCh * text);
	static double TextToDouble(const XMLCh * text);

	// Convert "-" or "+" to -1 or +1, must be able to deal with strings like "-123"
	static int TextToSign(const XMLCh * text);


private:
	Mp7JrsConvert();
	~Mp7JrsConvert();
};



#endif // MP7JRS_CONVERT_H
