/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _737MP7JRSDESCRIPTIONMETADATATYPE_H
#define _737MP7JRSDESCRIPTIONMETADATATYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDescriptionMetadataTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDescriptionMetadataType;
class IMp7JrsDescriptionMetadataType_Creator_CollectionType;
class IMp7JrsDescriptionMetadataType_Instrument_CollectionType;
class IMp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType;
class IMp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType;
class IMp7JrsHeaderType;
class IMp7JrsPackageType;
class IMp7JrsPlaceType;
class IMp7JrsRightsType;
class IMp7JrsTextAnnotationType;
class IMp7JrstimePointType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_Creator_CollectionType > Mp7JrsDescriptionMetadataType_Creator_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_Instrument_CollectionType > Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType > Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType > Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType> Mp7JrsDescriptionMetadataPtr;
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;
typedef Mp7JrsPtr< IMp7JrsPackageType > Mp7JrsPackagePtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsRightsType > Mp7JrsRightsPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsDescriptionMetadataType for class Mp7JrsDescriptionMetadataType<br>
 * Located at: mpeg7-2004.xsd, line 2964<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsDescriptionMetadataType 
 :
        public IMp7JrsHeaderType
{
public:
    // TODO: make these protected?
    IMp7JrsDescriptionMetadataType();
    virtual ~IMp7JrsDescriptionMetadataType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Confidence element.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr GetConfidence() const = 0;

    virtual bool IsValidConfidence() const = 0;

    /**
     * Set Confidence element.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void SetConfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Confidence element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateConfidence() = 0;

    /**
     * Get Version element.
     * @return XMLCh *
     */
    virtual XMLCh * GetVersion() const = 0;

    virtual bool IsValidVersion() const = 0;

    /**
     * Set Version element.
     * @param item XMLCh *
     */
    virtual void SetVersion(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Version element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVersion() = 0;

    /**
     * Get LastUpdate element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetLastUpdate() const = 0;

    virtual bool IsValidLastUpdate() const = 0;

    /**
     * Set LastUpdate element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetLastUpdate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate LastUpdate element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLastUpdate() = 0;

    /**
     * Get Comment element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetComment() const = 0;

    virtual bool IsValidComment() const = 0;

    /**
     * Set Comment element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetComment(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Comment element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateComment() = 0;

    /**
     * Get PublicIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr GetPublicIdentifier() const = 0;

    /**
     * Set PublicIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetPublicIdentifier(const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PrivateIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr GetPrivateIdentifier() const = 0;

    /**
     * Set PrivateIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetPrivateIdentifier(const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Creator element.
     * @return Mp7JrsDescriptionMetadataType_Creator_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Creator_CollectionPtr GetCreator() const = 0;

    /**
     * Set Creator element.
     * @param item const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetCreator(const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CreationLocation element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetCreationLocation() const = 0;

    virtual bool IsValidCreationLocation() const = 0;

    /**
     * Set CreationLocation element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetCreationLocation(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate CreationLocation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationLocation() = 0;

    /**
     * Get CreationTime element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetCreationTime() const = 0;

    virtual bool IsValidCreationTime() const = 0;

    /**
     * Set CreationTime element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetCreationTime(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate CreationTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationTime() = 0;

    /**
     * Get Instrument element.
     * @return Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr GetInstrument() const = 0;

    /**
     * Set Instrument element.
     * @param item const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetInstrument(const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Rights element.
     * @return Mp7JrsRightsPtr
     */
    virtual Mp7JrsRightsPtr GetRights() const = 0;

    virtual bool IsValidRights() const = 0;

    /**
     * Set Rights element.
     * @param item const Mp7JrsRightsPtr &
     */
    virtual void SetRights(const Mp7JrsRightsPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Rights element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRights() = 0;

    /**
     * Get Package element.
     * @return Mp7JrsPackagePtr
     */
    virtual Mp7JrsPackagePtr GetPackage() const = 0;

    virtual bool IsValidPackage() const = 0;

    /**
     * Set Package element.
     * @param item const Mp7JrsPackagePtr &
     */
    virtual void SetPackage(const Mp7JrsPackagePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Package element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePackage() = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of DescriptionMetadataType.
     * Currently this type contains 11 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>Confidence</li>
     * <li>LastUpdate</li>
     * <li>Comment</li>
     * <li>urn:mpeg:mpeg7:schema:2004:PublicIdentifier</li>
     * <li>urn:mpeg:mpeg7:schema:2004:PrivateIdentifier</li>
     * <li>urn:mpeg:mpeg7:schema:2004:Creator</li>
     * <li>CreationLocation</li>
     * <li>CreationTime</li>
     * <li>urn:mpeg:mpeg7:schema:2004:Instrument</li>
     * <li>Rights</li>
     * <li>Package</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDescriptionMetadataType<br>
 * Located at: mpeg7-2004.xsd, line 2964<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Defined in mpeg7-2004.xsd, line 2964.<br>
 */
class MP7JRS_EXPORT Mp7JrsDescriptionMetadataType :
        public IMp7JrsDescriptionMetadataType
{
    friend class Mp7JrsDescriptionMetadataTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsDescriptionMetadataType
     
     * @return Mp7JrsPtr< Mp7JrsHeaderType >
     */
    virtual Mp7JrsPtr< Mp7JrsHeaderType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Confidence element.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr GetConfidence() const;

    virtual bool IsValidConfidence() const;

    /*
     * Set Confidence element.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void SetConfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Confidence element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateConfidence();

    /*
     * Get Version element.
     * @return XMLCh *
     */
    virtual XMLCh * GetVersion() const;

    virtual bool IsValidVersion() const;

    /*
     * Set Version element.
     * @param item XMLCh *
     */
    virtual void SetVersion(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Version element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVersion();

    /*
     * Get LastUpdate element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetLastUpdate() const;

    virtual bool IsValidLastUpdate() const;

    /*
     * Set LastUpdate element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetLastUpdate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate LastUpdate element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLastUpdate();

    /*
     * Get Comment element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetComment() const;

    virtual bool IsValidComment() const;

    /*
     * Set Comment element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetComment(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Comment element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateComment();

    /*
     * Get PublicIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr GetPublicIdentifier() const;

    /*
     * Set PublicIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetPublicIdentifier(const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PrivateIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr GetPrivateIdentifier() const;

    /*
     * Set PrivateIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetPrivateIdentifier(const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Creator element.
     * @return Mp7JrsDescriptionMetadataType_Creator_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Creator_CollectionPtr GetCreator() const;

    /*
     * Set Creator element.
     * @param item const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetCreator(const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CreationLocation element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetCreationLocation() const;

    virtual bool IsValidCreationLocation() const;

    /*
     * Set CreationLocation element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetCreationLocation(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate CreationLocation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationLocation();

    /*
     * Get CreationTime element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetCreationTime() const;

    virtual bool IsValidCreationTime() const;

    /*
     * Set CreationTime element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetCreationTime(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate CreationTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationTime();

    /*
     * Get Instrument element.
     * @return Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr GetInstrument() const;

    /*
     * Set Instrument element.
     * @param item const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetInstrument(const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Rights element.
     * @return Mp7JrsRightsPtr
     */
    virtual Mp7JrsRightsPtr GetRights() const;

    virtual bool IsValidRights() const;

    /*
     * Set Rights element.
     * @param item const Mp7JrsRightsPtr &
     */
    virtual void SetRights(const Mp7JrsRightsPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Rights element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRights();

    /*
     * Get Package element.
     * @return Mp7JrsPackagePtr
     */
    virtual Mp7JrsPackagePtr GetPackage() const;

    virtual bool IsValidPackage() const;

    /*
     * Set Package element.
     * @param item const Mp7JrsPackagePtr &
     */
    virtual void SetPackage(const Mp7JrsPackagePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Package element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePackage();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of DescriptionMetadataType.
     * Currently this type contains 11 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>Confidence</li>
     * <li>LastUpdate</li>
     * <li>Comment</li>
     * <li>urn:mpeg:mpeg7:schema:2004:PublicIdentifier</li>
     * <li>urn:mpeg:mpeg7:schema:2004:PrivateIdentifier</li>
     * <li>urn:mpeg:mpeg7:schema:2004:Creator</li>
     * <li>CreationLocation</li>
     * <li>CreationTime</li>
     * <li>urn:mpeg:mpeg7:schema:2004:Instrument</li>
     * <li>Rights</li>
     * <li>Package</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
	virtual bool ContentFromString(const XMLCh * const txt);

    /* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
     * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
     */
	virtual XMLCh * ContentToString() const;


    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDescriptionMetadataType();

protected:
    Mp7JrsDescriptionMetadataType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsHeaderType > m_Base;

    Mp7JrszeroToOnePtr m_Confidence;
    bool m_Confidence_Exist; // For optional elements 
    XMLCh * m_Version;
    bool m_Version_Exist; // For optional elements 
    Mp7JrstimePointPtr m_LastUpdate;
    bool m_LastUpdate_Exist; // For optional elements 
    Mp7JrsTextAnnotationPtr m_Comment;
    bool m_Comment_Exist; // For optional elements 
    Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr m_PublicIdentifier;
    Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr m_PrivateIdentifier;
    Mp7JrsDescriptionMetadataType_Creator_CollectionPtr m_Creator;
    Mp7JrsPlacePtr m_CreationLocation;
    bool m_CreationLocation_Exist; // For optional elements 
    Mp7JrstimePointPtr m_CreationTime;
    bool m_CreationTime_Exist; // For optional elements 
    Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr m_Instrument;
    Mp7JrsRightsPtr m_Rights;
    bool m_Rights_Exist; // For optional elements 
    Mp7JrsPackagePtr m_Package;
    bool m_Package_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _737MP7JRSDESCRIPTIONMETADATATYPE_H

