/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1091MP7JRSINKSEGMENTTYPE_H
#define _1091MP7JRSINKSEGMENTTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInkSegmentTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsInkSegmentType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsInkSegmentType_type_LocalType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsSegmentType.h"
class IMp7JrsControlledTermUseType;
class IMp7JrsCreationInformationType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsInkMediaInformationType;
class IMp7JrsInkSegmentType;
class IMp7JrsInkSegmentType_CollectionType;
class IMp7JrsInkSegmentType_CollectionType0;
class IMp7JrsInkSegmentType_CollectionType1;
class IMp7JrsmediaDurationType;
class IMp7JrsMediaInformationType;
class IMp7JrsMediaLocatorType;
class IMp7JrsMediaSpaceMaskType;
class IMp7JrsMediaTimeType;
class IMp7JrsOrderedGroupDataSetMaskType;
class IMp7JrsReferenceType;
class IMp7JrsSceneGraphMaskType;
class IMp7JrsSegmentType;
class IMp7JrsSegmentType_CollectionType;
class IMp7JrsSegmentType_MatchingHint_CollectionType;
class IMp7JrsSegmentType_PointOfView_CollectionType;
class IMp7JrsSegmentType_Relation_CollectionType;
class IMp7JrsSegmentType_TextAnnotation_CollectionType;
class IMp7JrsTemporalMaskType;
class IMp7JrsUsageInformationType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsCreationInformationType > Mp7JrsCreationInformationPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType > Mp7JrsInkMediaInformationPtr;
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_CollectionType > Mp7JrsInkSegmentType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_CollectionType0 > Mp7JrsInkSegmentType_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_CollectionType1 > Mp7JrsInkSegmentType_Collection1Ptr;
typedef Mp7JrsPtr< IMp7JrsInkSegmentType> Mp7JrsInkSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsMediaInformationType > Mp7JrsMediaInformationPtr;
typedef Mp7JrsPtr< IMp7JrsMediaLocatorType > Mp7JrsMediaLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsMediaSpaceMaskType > Mp7JrsMediaSpaceMaskPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;
typedef Mp7JrsPtr< IMp7JrsOrderedGroupDataSetMaskType > Mp7JrsOrderedGroupDataSetMaskPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSceneGraphMaskType > Mp7JrsSceneGraphMaskPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType > Mp7JrsSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_CollectionType > Mp7JrsSegmentType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_MatchingHint_CollectionType > Mp7JrsSegmentType_MatchingHint_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_PointOfView_CollectionType > Mp7JrsSegmentType_PointOfView_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_Relation_CollectionType > Mp7JrsSegmentType_Relation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_CollectionType > Mp7JrsSegmentType_TextAnnotation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalMaskType > Mp7JrsTemporalMaskPtr;
typedef Mp7JrsPtr< IMp7JrsUsageInformationType > Mp7JrsUsageInformationPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsInkSegmentType for class Mp7JrsInkSegmentType<br>
 * Located at: mpeg7-2004.xsd, line 6263<br>
 * Classified: Class<br>
 * Derived from: SegmentType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsInkSegmentType 
 :
        public IMp7JrsSegmentType
{
public:
    // TODO: make these protected?
    IMp7JrsInkSegmentType();
    virtual ~IMp7JrsInkSegmentType();
    /**
     * Get type attribute.
     * @return Mp7JrsInkSegmentType_type_LocalType::Enumeration
     */
    virtual Mp7JrsInkSegmentType_type_LocalType::Enumeration Gettype() const = 0;

    /**
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const = 0;

    /**
     * Set type attribute.
     * @param item Mp7JrsInkSegmentType_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsInkSegmentType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get InkMediaInformation element.
     * @return Mp7JrsInkMediaInformationPtr
     */
    virtual Mp7JrsInkMediaInformationPtr GetInkMediaInformation() const = 0;

    virtual bool IsValidInkMediaInformation() const = 0;

    /**
     * Set InkMediaInformation element.
     * @param item const Mp7JrsInkMediaInformationPtr &
     */
    virtual void SetInkMediaInformation(const Mp7JrsInkMediaInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate InkMediaInformation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateInkMediaInformation() = 0;

    /**
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const = 0;

    virtual bool IsValidMediaTime() const = 0;

    /**
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MediaTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaTime() = 0;

    /**
     * Get TemporalMask element.
     * @return Mp7JrsTemporalMaskPtr
     */
    virtual Mp7JrsTemporalMaskPtr GetTemporalMask() const = 0;

    virtual bool IsValidTemporalMask() const = 0;

    /**
     * Set TemporalMask element.
     * @param item const Mp7JrsTemporalMaskPtr &
     */
    virtual void SetTemporalMask(const Mp7JrsTemporalMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TemporalMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTemporalMask() = 0;

    /**
     * Get SceneGraphMask element.
     * @return Mp7JrsSceneGraphMaskPtr
     */
    virtual Mp7JrsSceneGraphMaskPtr GetSceneGraphMask() const = 0;

    virtual bool IsValidSceneGraphMask() const = 0;

    /**
     * Set SceneGraphMask element.
     * @param item const Mp7JrsSceneGraphMaskPtr &
     */
    virtual void SetSceneGraphMask(const Mp7JrsSceneGraphMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SceneGraphMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSceneGraphMask() = 0;

    /**
     * Get MediaSpaceMask element.
     * @return Mp7JrsMediaSpaceMaskPtr
     */
    virtual Mp7JrsMediaSpaceMaskPtr GetMediaSpaceMask() const = 0;

    virtual bool IsValidMediaSpaceMask() const = 0;

    /**
     * Set MediaSpaceMask element.
     * @param item const Mp7JrsMediaSpaceMaskPtr &
     */
    virtual void SetMediaSpaceMask(const Mp7JrsMediaSpaceMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MediaSpaceMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaSpaceMask() = 0;

    /**
     * Get OrderedGroupDataSetMask element.
     * @return Mp7JrsOrderedGroupDataSetMaskPtr
     */
    virtual Mp7JrsOrderedGroupDataSetMaskPtr GetOrderedGroupDataSetMask() const = 0;

    virtual bool IsValidOrderedGroupDataSetMask() const = 0;

    /**
     * Set OrderedGroupDataSetMask element.
     * @param item const Mp7JrsOrderedGroupDataSetMaskPtr &
     */
    virtual void SetOrderedGroupDataSetMask(const Mp7JrsOrderedGroupDataSetMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate OrderedGroupDataSetMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOrderedGroupDataSetMask() = 0;

    /**
     * Get InkSegmentType_LocalType element.
     * @return Mp7JrsInkSegmentType_CollectionPtr
     */
    virtual Mp7JrsInkSegmentType_CollectionPtr GetInkSegmentType_LocalType() const = 0;

    /**
     * Set InkSegmentType_LocalType element.
     * @param item const Mp7JrsInkSegmentType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetInkSegmentType_LocalType(const Mp7JrsInkSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get InkSegmentType_LocalType0 element.
     * @return Mp7JrsInkSegmentType_Collection0Ptr
     */
    virtual Mp7JrsInkSegmentType_Collection0Ptr GetInkSegmentType_LocalType0() const = 0;

    /**
     * Set InkSegmentType_LocalType0 element.
     * @param item const Mp7JrsInkSegmentType_Collection0Ptr &
     */
    // Mandatory collection
    virtual void SetInkSegmentType_LocalType0(const Mp7JrsInkSegmentType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get InkSegmentType_LocalType1 element.
     * @return Mp7JrsInkSegmentType_Collection1Ptr
     */
    virtual Mp7JrsInkSegmentType_Collection1Ptr GetInkSegmentType_LocalType1() const = 0;

    /**
     * Set InkSegmentType_LocalType1 element.
     * @param item const Mp7JrsInkSegmentType_Collection1Ptr &
     */
    // Mandatory collection
    virtual void SetInkSegmentType_LocalType1(const Mp7JrsInkSegmentType_Collection1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaInformationPtr
     */
    virtual Mp7JrsMediaInformationPtr GetMediaInformation() const = 0;

    /**
     * Set MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaInformationPtr &
     */
    virtual void SetMediaInformation(const Mp7JrsMediaInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMediaInformationRef() const = 0;

    /**
     * Set MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMediaInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetMediaLocator() const = 0;

    /**
     * Set MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetStructuralUnit() const = 0;

    virtual bool IsValidStructuralUnit() const = 0;

    /**
     * Set StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetStructuralUnit(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate StructuralUnit element.
     * (Inherited from Mp7JrsSegmentType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStructuralUnit() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsCreationInformationPtr
     */
    virtual Mp7JrsCreationInformationPtr GetCreationInformation() const = 0;

    /**
     * Set CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsCreationInformationPtr &
     */
    virtual void SetCreationInformation(const Mp7JrsCreationInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCreationInformationRef() const = 0;

    /**
     * Set CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetCreationInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsUsageInformationPtr
     */
    virtual Mp7JrsUsageInformationPtr GetUsageInformation() const = 0;

    /**
     * Set UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsUsageInformationPtr &
     */
    virtual void SetUsageInformation(const Mp7JrsUsageInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetUsageInformationRef() const = 0;

    /**
     * Set UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetUsageInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_TextAnnotation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_TextAnnotation_CollectionPtr GetTextAnnotation() const = 0;

    /**
     * Set TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_TextAnnotation_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetTextAnnotation(const Mp7JrsSegmentType_TextAnnotation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_CollectionPtr
     */
    virtual Mp7JrsSegmentType_CollectionPtr GetSegmentType_LocalType() const = 0;

    /**
     * Set SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetSegmentType_LocalType(const Mp7JrsSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_MatchingHint_CollectionPtr
     */
    virtual Mp7JrsSegmentType_MatchingHint_CollectionPtr GetMatchingHint() const = 0;

    /**
     * Set MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_MatchingHint_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetMatchingHint(const Mp7JrsSegmentType_MatchingHint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_PointOfView_CollectionPtr
     */
    virtual Mp7JrsSegmentType_PointOfView_CollectionPtr GetPointOfView() const = 0;

    /**
     * Set PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_PointOfView_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetPointOfView(const Mp7JrsSegmentType_PointOfView_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_Relation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_Relation_CollectionPtr GetRelation() const = 0;

    /**
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_Relation_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetRelation(const Mp7JrsSegmentType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of InkSegmentType.
     * Currently this type contains 28 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * <li>MediaInformation</li>
     * <li>MediaInformationRef</li>
     * <li>MediaLocator</li>
     * <li>StructuralUnit</li>
     * <li>CreationInformation</li>
     * <li>CreationInformationRef</li>
     * <li>UsageInformation</li>
     * <li>UsageInformationRef</li>
     * <li>urn:mpeg:mpeg7:schema:2004:TextAnnotation</li>
     * <li>Semantic</li>
     * <li>SemanticRef</li>
     * <li>urn:mpeg:mpeg7:schema:2004:MatchingHint</li>
     * <li>urn:mpeg:mpeg7:schema:2004:PointOfView</li>
     * <li>urn:mpeg:mpeg7:schema:2004:Relation</li>
     * <li>InkMediaInformation</li>
     * <li>MediaTime</li>
     * <li>TemporalMask</li>
     * <li>SceneGraphMask</li>
     * <li>MediaSpaceMask</li>
     * <li>OrderedGroupDataSetMask</li>
     * <li>HandWritingRecogInformation</li>
     * <li>HandWritingRecogResult</li>
     * <li>VisualDescriptor</li>
     * <li>VisualDescriptionScheme</li>
     * <li>VisualTimeSeriesDescriptor</li>
     * <li>SpatialDecomposition</li>
     * <li>TemporalDecomposition</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsInkSegmentType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInkSegmentType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInkSegmentType<br>
 * Located at: mpeg7-2004.xsd, line 6263<br>
 * Classified: Class<br>
 * Derived from: SegmentType (Class)<br>
 * Defined in mpeg7-2004.xsd, line 6263.<br>
 */
class MP7JRS_EXPORT Mp7JrsInkSegmentType :
        public IMp7JrsInkSegmentType
{
    friend class Mp7JrsInkSegmentTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsInkSegmentType
     
     * @return Mp7JrsPtr< Mp7JrsSegmentType >
     */
    virtual Mp7JrsPtr< Mp7JrsSegmentType > GetBase() const;
    /*
     * Get type attribute.
     * @return Mp7JrsInkSegmentType_type_LocalType::Enumeration
     */
    virtual Mp7JrsInkSegmentType_type_LocalType::Enumeration Gettype() const;

    /*
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const;

    /*
     * Set type attribute.
     * @param item Mp7JrsInkSegmentType_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsInkSegmentType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype();

        /* @name Sequence

         */
        //@{
    /*
     * Get InkMediaInformation element.
     * @return Mp7JrsInkMediaInformationPtr
     */
    virtual Mp7JrsInkMediaInformationPtr GetInkMediaInformation() const;

    virtual bool IsValidInkMediaInformation() const;

    /*
     * Set InkMediaInformation element.
     * @param item const Mp7JrsInkMediaInformationPtr &
     */
    virtual void SetInkMediaInformation(const Mp7JrsInkMediaInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate InkMediaInformation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateInkMediaInformation();

    /*
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const;

    virtual bool IsValidMediaTime() const;

    /*
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MediaTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaTime();

    /*
     * Get TemporalMask element.
     * @return Mp7JrsTemporalMaskPtr
     */
    virtual Mp7JrsTemporalMaskPtr GetTemporalMask() const;

    virtual bool IsValidTemporalMask() const;

    /*
     * Set TemporalMask element.
     * @param item const Mp7JrsTemporalMaskPtr &
     */
    virtual void SetTemporalMask(const Mp7JrsTemporalMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TemporalMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTemporalMask();

    /*
     * Get SceneGraphMask element.
     * @return Mp7JrsSceneGraphMaskPtr
     */
    virtual Mp7JrsSceneGraphMaskPtr GetSceneGraphMask() const;

    virtual bool IsValidSceneGraphMask() const;

    /*
     * Set SceneGraphMask element.
     * @param item const Mp7JrsSceneGraphMaskPtr &
     */
    virtual void SetSceneGraphMask(const Mp7JrsSceneGraphMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SceneGraphMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSceneGraphMask();

    /*
     * Get MediaSpaceMask element.
     * @return Mp7JrsMediaSpaceMaskPtr
     */
    virtual Mp7JrsMediaSpaceMaskPtr GetMediaSpaceMask() const;

    virtual bool IsValidMediaSpaceMask() const;

    /*
     * Set MediaSpaceMask element.
     * @param item const Mp7JrsMediaSpaceMaskPtr &
     */
    virtual void SetMediaSpaceMask(const Mp7JrsMediaSpaceMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MediaSpaceMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaSpaceMask();

    /*
     * Get OrderedGroupDataSetMask element.
     * @return Mp7JrsOrderedGroupDataSetMaskPtr
     */
    virtual Mp7JrsOrderedGroupDataSetMaskPtr GetOrderedGroupDataSetMask() const;

    virtual bool IsValidOrderedGroupDataSetMask() const;

    /*
     * Set OrderedGroupDataSetMask element.
     * @param item const Mp7JrsOrderedGroupDataSetMaskPtr &
     */
    virtual void SetOrderedGroupDataSetMask(const Mp7JrsOrderedGroupDataSetMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate OrderedGroupDataSetMask element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOrderedGroupDataSetMask();

    /*
     * Get InkSegmentType_LocalType element.
     * @return Mp7JrsInkSegmentType_CollectionPtr
     */
    virtual Mp7JrsInkSegmentType_CollectionPtr GetInkSegmentType_LocalType() const;

    /*
     * Set InkSegmentType_LocalType element.
     * @param item const Mp7JrsInkSegmentType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetInkSegmentType_LocalType(const Mp7JrsInkSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get InkSegmentType_LocalType0 element.
     * @return Mp7JrsInkSegmentType_Collection0Ptr
     */
    virtual Mp7JrsInkSegmentType_Collection0Ptr GetInkSegmentType_LocalType0() const;

    /*
     * Set InkSegmentType_LocalType0 element.
     * @param item const Mp7JrsInkSegmentType_Collection0Ptr &
     */
    // Mandatory collection
    virtual void SetInkSegmentType_LocalType0(const Mp7JrsInkSegmentType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get InkSegmentType_LocalType1 element.
     * @return Mp7JrsInkSegmentType_Collection1Ptr
     */
    virtual Mp7JrsInkSegmentType_Collection1Ptr GetInkSegmentType_LocalType1() const;

    /*
     * Set InkSegmentType_LocalType1 element.
     * @param item const Mp7JrsInkSegmentType_Collection1Ptr &
     */
    // Mandatory collection
    virtual void SetInkSegmentType_LocalType1(const Mp7JrsInkSegmentType_Collection1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaInformationPtr
     */
    virtual Mp7JrsMediaInformationPtr GetMediaInformation() const;

    /*
     * Set MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaInformationPtr &
     */
    virtual void SetMediaInformation(const Mp7JrsMediaInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMediaInformationRef() const;

    /*
     * Set MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMediaInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetMediaLocator() const;

    /*
     * Set MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetStructuralUnit() const;

    virtual bool IsValidStructuralUnit() const;

    /*
     * Set StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetStructuralUnit(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate StructuralUnit element.
     * (Inherited from Mp7JrsSegmentType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStructuralUnit();

        /* @name Choice

         */
        //@{
    /*
     * Get CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsCreationInformationPtr
     */
    virtual Mp7JrsCreationInformationPtr GetCreationInformation() const;

    /*
     * Set CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsCreationInformationPtr &
     */
    virtual void SetCreationInformation(const Mp7JrsCreationInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCreationInformationRef() const;

    /*
     * Set CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetCreationInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsUsageInformationPtr
     */
    virtual Mp7JrsUsageInformationPtr GetUsageInformation() const;

    /*
     * Set UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsUsageInformationPtr &
     */
    virtual void SetUsageInformation(const Mp7JrsUsageInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetUsageInformationRef() const;

    /*
     * Set UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetUsageInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_TextAnnotation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_TextAnnotation_CollectionPtr GetTextAnnotation() const;

    /*
     * Set TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_TextAnnotation_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetTextAnnotation(const Mp7JrsSegmentType_TextAnnotation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_CollectionPtr
     */
    virtual Mp7JrsSegmentType_CollectionPtr GetSegmentType_LocalType() const;

    /*
     * Set SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetSegmentType_LocalType(const Mp7JrsSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_MatchingHint_CollectionPtr
     */
    virtual Mp7JrsSegmentType_MatchingHint_CollectionPtr GetMatchingHint() const;

    /*
     * Set MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_MatchingHint_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetMatchingHint(const Mp7JrsSegmentType_MatchingHint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_PointOfView_CollectionPtr
     */
    virtual Mp7JrsSegmentType_PointOfView_CollectionPtr GetPointOfView() const;

    /*
     * Set PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_PointOfView_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetPointOfView(const Mp7JrsSegmentType_PointOfView_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_Relation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_Relation_CollectionPtr GetRelation() const;

    /*
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_Relation_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetRelation(const Mp7JrsSegmentType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of InkSegmentType.
     * Currently this type contains 28 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * <li>MediaInformation</li>
     * <li>MediaInformationRef</li>
     * <li>MediaLocator</li>
     * <li>StructuralUnit</li>
     * <li>CreationInformation</li>
     * <li>CreationInformationRef</li>
     * <li>UsageInformation</li>
     * <li>UsageInformationRef</li>
     * <li>urn:mpeg:mpeg7:schema:2004:TextAnnotation</li>
     * <li>Semantic</li>
     * <li>SemanticRef</li>
     * <li>urn:mpeg:mpeg7:schema:2004:MatchingHint</li>
     * <li>urn:mpeg:mpeg7:schema:2004:PointOfView</li>
     * <li>urn:mpeg:mpeg7:schema:2004:Relation</li>
     * <li>InkMediaInformation</li>
     * <li>MediaTime</li>
     * <li>TemporalMask</li>
     * <li>SceneGraphMask</li>
     * <li>MediaSpaceMask</li>
     * <li>OrderedGroupDataSetMask</li>
     * <li>HandWritingRecogInformation</li>
     * <li>HandWritingRecogResult</li>
     * <li>VisualDescriptor</li>
     * <li>VisualDescriptionScheme</li>
     * <li>VisualTimeSeriesDescriptor</li>
     * <li>SpatialDecomposition</li>
     * <li>TemporalDecomposition</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
	virtual bool ContentFromString(const XMLCh * const txt);

    /* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
     * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
     */
	virtual XMLCh * ContentToString() const;


    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInkSegmentType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInkSegmentType();

protected:
    Mp7JrsInkSegmentType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsInkSegmentType_type_LocalType::Enumeration m_type;
    bool m_type_Exist;
    Mp7JrsInkSegmentType_type_LocalType::Enumeration m_type_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsSegmentType > m_Base;

    Mp7JrsInkMediaInformationPtr m_InkMediaInformation;
    bool m_InkMediaInformation_Exist; // For optional elements 
    Mp7JrsMediaTimePtr m_MediaTime;
    bool m_MediaTime_Exist; // For optional elements 
    Mp7JrsTemporalMaskPtr m_TemporalMask;
    bool m_TemporalMask_Exist; // For optional elements 
    Mp7JrsSceneGraphMaskPtr m_SceneGraphMask;
    bool m_SceneGraphMask_Exist; // For optional elements 
    Mp7JrsMediaSpaceMaskPtr m_MediaSpaceMask;
    bool m_MediaSpaceMask_Exist; // For optional elements 
    Mp7JrsOrderedGroupDataSetMaskPtr m_OrderedGroupDataSetMask;
    bool m_OrderedGroupDataSetMask_Exist; // For optional elements 
    Mp7JrsInkSegmentType_CollectionPtr m_InkSegmentType_LocalType;
    Mp7JrsInkSegmentType_Collection0Ptr m_InkSegmentType_LocalType0;
    Mp7JrsInkSegmentType_Collection1Ptr m_InkSegmentType_LocalType1;

// no includefile for extension defined 
// file Mp7JrsInkSegmentType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1091MP7JRSINKSEGMENTTYPE_H

