/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1165MP7JRSLINGUISTICDOCUMENTTYPE_LOCALTYPE_H
#define _1165MP7JRSLINGUISTICDOCUMENTTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsLinguisticDocumentType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsLinguisticDocumentType_LocalType_ExtInclude.h


class IMp7JrsLinguisticDocumentType;
class IMp7JrsLinguisticDocumentType_LocalType;
class IMp7JrsSentencesType;
class IMp7JrsSyntacticConstituentType;
typedef Mp7JrsPtr< IMp7JrsLinguisticDocumentType > Mp7JrsLinguisticDocumentPtr;
typedef Mp7JrsPtr< IMp7JrsLinguisticDocumentType_LocalType> Mp7JrsLinguisticDocumentType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSentencesType > Mp7JrsSentencesPtr;
typedef Mp7JrsPtr< IMp7JrsSyntacticConstituentType > Mp7JrsSyntacticConstituentPtr;

/** 
 * Generated interface IMp7JrsLinguisticDocumentType_LocalType for class Mp7JrsLinguisticDocumentType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsLinguisticDocumentType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsLinguisticDocumentType_LocalType();
    virtual ~IMp7JrsLinguisticDocumentType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Heading element.
     * @return Mp7JrsSentencesPtr
     */
    virtual Mp7JrsSentencesPtr GetHeading() const = 0;

    /**
     * Set Heading element.
     * @param item const Mp7JrsSentencesPtr &
     */
    // Mandatory			
    virtual void SetHeading(const Mp7JrsSentencesPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Division element.
     * @return Mp7JrsLinguisticDocumentPtr
     */
    virtual Mp7JrsLinguisticDocumentPtr GetDivision() const = 0;

    /**
     * Set Division element.
     * @param item const Mp7JrsLinguisticDocumentPtr &
     */
    // Mandatory			
    virtual void SetDivision(const Mp7JrsLinguisticDocumentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Paragraph element.
     * @return Mp7JrsSentencesPtr
     */
    virtual Mp7JrsSentencesPtr GetParagraph() const = 0;

    /**
     * Set Paragraph element.
     * @param item const Mp7JrsSentencesPtr &
     */
    // Mandatory			
    virtual void SetParagraph(const Mp7JrsSentencesPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Sentences element.
     * @return Mp7JrsSentencesPtr
     */
    virtual Mp7JrsSentencesPtr GetSentences() const = 0;

    /**
     * Set Sentences element.
     * @param item const Mp7JrsSentencesPtr &
     */
    // Mandatory			
    virtual void SetSentences(const Mp7JrsSentencesPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Sentence element.
     * @return Mp7JrsSyntacticConstituentPtr
     */
    virtual Mp7JrsSyntacticConstituentPtr GetSentence() const = 0;

    /**
     * Set Sentence element.
     * @param item const Mp7JrsSyntacticConstituentPtr &
     */
    // Mandatory			
    virtual void SetSentence(const Mp7JrsSyntacticConstituentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Quotation element.
     * @return Mp7JrsLinguisticDocumentPtr
     */
    virtual Mp7JrsLinguisticDocumentPtr GetQuotation() const = 0;

    /**
     * Set Quotation element.
     * @param item const Mp7JrsLinguisticDocumentPtr &
     */
    // Mandatory			
    virtual void SetQuotation(const Mp7JrsLinguisticDocumentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsLinguisticDocumentType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsLinguisticDocumentType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsLinguisticDocumentType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 9086.<br>
 */
class MP7JRS_EXPORT Mp7JrsLinguisticDocumentType_LocalType :
        public IMp7JrsLinguisticDocumentType_LocalType
{
    friend class Mp7JrsLinguisticDocumentType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Heading element.
     * @return Mp7JrsSentencesPtr
     */
    virtual Mp7JrsSentencesPtr GetHeading() const;

    /*
     * Set Heading element.
     * @param item const Mp7JrsSentencesPtr &
     */
    // Mandatory			
    virtual void SetHeading(const Mp7JrsSentencesPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Division element.
     * @return Mp7JrsLinguisticDocumentPtr
     */
    virtual Mp7JrsLinguisticDocumentPtr GetDivision() const;

    /*
     * Set Division element.
     * @param item const Mp7JrsLinguisticDocumentPtr &
     */
    // Mandatory			
    virtual void SetDivision(const Mp7JrsLinguisticDocumentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Paragraph element.
     * @return Mp7JrsSentencesPtr
     */
    virtual Mp7JrsSentencesPtr GetParagraph() const;

    /*
     * Set Paragraph element.
     * @param item const Mp7JrsSentencesPtr &
     */
    // Mandatory			
    virtual void SetParagraph(const Mp7JrsSentencesPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Sentences element.
     * @return Mp7JrsSentencesPtr
     */
    virtual Mp7JrsSentencesPtr GetSentences() const;

    /*
     * Set Sentences element.
     * @param item const Mp7JrsSentencesPtr &
     */
    // Mandatory			
    virtual void SetSentences(const Mp7JrsSentencesPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Sentence element.
     * @return Mp7JrsSyntacticConstituentPtr
     */
    virtual Mp7JrsSyntacticConstituentPtr GetSentence() const;

    /*
     * Set Sentence element.
     * @param item const Mp7JrsSyntacticConstituentPtr &
     */
    // Mandatory			
    virtual void SetSentence(const Mp7JrsSyntacticConstituentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Quotation element.
     * @return Mp7JrsLinguisticDocumentPtr
     */
    virtual Mp7JrsLinguisticDocumentPtr GetQuotation() const;

    /*
     * Set Quotation element.
     * @param item const Mp7JrsLinguisticDocumentPtr &
     */
    // Mandatory			
    virtual void SetQuotation(const Mp7JrsLinguisticDocumentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsLinguisticDocumentType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsLinguisticDocumentType_LocalType();

protected:
    Mp7JrsLinguisticDocumentType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsSentencesPtr m_Heading;
    Mp7JrsLinguisticDocumentPtr m_Division;
    Mp7JrsSentencesPtr m_Paragraph;
    Mp7JrsSentencesPtr m_Sentences;
    Mp7JrsSyntacticConstituentPtr m_Sentence;
    Mp7JrsLinguisticDocumentPtr m_Quotation;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsLinguisticDocumentType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1165MP7JRSLINGUISTICDOCUMENTTYPE_LOCALTYPE_H

