/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1377MP7JRSMIXTUREAMOUNTOFMOTIONTYPE_H
#define _1377MP7JRSMIXTUREAMOUNTOFMOTIONTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMixtureAmountOfMotionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMixtureAmountOfMotionType_ExtInclude.h


class IMp7JrsMixtureAmountOfMotionType;
class IMp7Jrsunsigned11;
typedef Mp7JrsPtr< IMp7JrsMixtureAmountOfMotionType> Mp7JrsMixtureAmountOfMotionPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned11 > Mp7Jrsunsigned11Ptr;

/** 
 * Generated interface IMp7JrsMixtureAmountOfMotionType for class Mp7JrsMixtureAmountOfMotionType<br>
 * Located at: mpeg7-2004.xsd, line 949<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMixtureAmountOfMotionType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMixtureAmountOfMotionType();
    virtual ~IMp7JrsMixtureAmountOfMotionType();
        /** @name Sequence

         */
        //@{
    /**
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackLeft() const = 0;

    virtual bool IsValidTrackLeft() const = 0;

    /**
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TrackLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackLeft() = 0;

    /**
     * Get TrackRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackRight() const = 0;

    virtual bool IsValidTrackRight() const = 0;

    /**
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TrackRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackRight() = 0;

    /**
     * Get BoomDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomDown() const = 0;

    virtual bool IsValidBoomDown() const = 0;

    /**
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate BoomDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomDown() = 0;

    /**
     * Get BoomUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomUp() const = 0;

    virtual bool IsValidBoomUp() const = 0;

    /**
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate BoomUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomUp() = 0;

    /**
     * Get DollyForward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyForward() const = 0;

    virtual bool IsValidDollyForward() const = 0;

    /**
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyForward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DollyForward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyForward() = 0;

    /**
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyBackward() const = 0;

    virtual bool IsValidDollyBackward() const = 0;

    /**
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyBackward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DollyBackward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyBackward() = 0;

    /**
     * Get PanLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanLeft() const = 0;

    virtual bool IsValidPanLeft() const = 0;

    /**
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PanLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanLeft() = 0;

    /**
     * Get PanRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanRight() const = 0;

    virtual bool IsValidPanRight() const = 0;

    /**
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PanRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanRight() = 0;

    /**
     * Get TiltDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltDown() const = 0;

    virtual bool IsValidTiltDown() const = 0;

    /**
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TiltDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltDown() = 0;

    /**
     * Get TiltUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltUp() const = 0;

    virtual bool IsValidTiltUp() const = 0;

    /**
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TiltUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltUp() = 0;

    /**
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollClockwise() const = 0;

    virtual bool IsValidRollClockwise() const = 0;

    /**
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollClockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate RollClockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollClockwise() = 0;

    /**
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollAnticlockwise() const = 0;

    virtual bool IsValidRollAnticlockwise() const = 0;

    /**
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate RollAnticlockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollAnticlockwise() = 0;

    /**
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomIn() const = 0;

    virtual bool IsValidZoomIn() const = 0;

    /**
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomIn(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ZoomIn element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomIn() = 0;

    /**
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomOut() const = 0;

    virtual bool IsValidZoomOut() const = 0;

    /**
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomOut(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ZoomOut element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomOut() = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of MixtureAmountOfMotionType.
     * Currently this type contains 14 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>TrackLeft</li>
     * <li>TrackRight</li>
     * <li>BoomDown</li>
     * <li>BoomUp</li>
     * <li>DollyForward</li>
     * <li>DollyBackward</li>
     * <li>PanLeft</li>
     * <li>PanRight</li>
     * <li>TiltDown</li>
     * <li>TiltUp</li>
     * <li>RollClockwise</li>
     * <li>RollAnticlockwise</li>
     * <li>ZoomIn</li>
     * <li>ZoomOut</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsMixtureAmountOfMotionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMixtureAmountOfMotionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMixtureAmountOfMotionType<br>
 * Located at: mpeg7-2004.xsd, line 949<br>
 * Classified: Class<br>
 * Defined in mpeg7-2004.xsd, line 949.<br>
 */
class MP7JRS_EXPORT Mp7JrsMixtureAmountOfMotionType :
        public IMp7JrsMixtureAmountOfMotionType
{
    friend class Mp7JrsMixtureAmountOfMotionTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackLeft() const;

    virtual bool IsValidTrackLeft() const;

    /*
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TrackLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackLeft();

    /*
     * Get TrackRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackRight() const;

    virtual bool IsValidTrackRight() const;

    /*
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TrackRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackRight();

    /*
     * Get BoomDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomDown() const;

    virtual bool IsValidBoomDown() const;

    /*
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate BoomDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomDown();

    /*
     * Get BoomUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomUp() const;

    virtual bool IsValidBoomUp() const;

    /*
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate BoomUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomUp();

    /*
     * Get DollyForward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyForward() const;

    virtual bool IsValidDollyForward() const;

    /*
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyForward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DollyForward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyForward();

    /*
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyBackward() const;

    virtual bool IsValidDollyBackward() const;

    /*
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyBackward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DollyBackward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyBackward();

    /*
     * Get PanLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanLeft() const;

    virtual bool IsValidPanLeft() const;

    /*
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PanLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanLeft();

    /*
     * Get PanRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanRight() const;

    virtual bool IsValidPanRight() const;

    /*
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PanRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanRight();

    /*
     * Get TiltDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltDown() const;

    virtual bool IsValidTiltDown() const;

    /*
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TiltDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltDown();

    /*
     * Get TiltUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltUp() const;

    virtual bool IsValidTiltUp() const;

    /*
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TiltUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltUp();

    /*
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollClockwise() const;

    virtual bool IsValidRollClockwise() const;

    /*
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollClockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate RollClockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollClockwise();

    /*
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollAnticlockwise() const;

    virtual bool IsValidRollAnticlockwise() const;

    /*
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate RollAnticlockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollAnticlockwise();

    /*
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomIn() const;

    virtual bool IsValidZoomIn() const;

    /*
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomIn(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ZoomIn element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomIn();

    /*
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomOut() const;

    virtual bool IsValidZoomOut() const;

    /*
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomOut(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ZoomOut element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomOut();

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of MixtureAmountOfMotionType.
     * Currently this type contains 14 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>TrackLeft</li>
     * <li>TrackRight</li>
     * <li>BoomDown</li>
     * <li>BoomUp</li>
     * <li>DollyForward</li>
     * <li>DollyBackward</li>
     * <li>PanLeft</li>
     * <li>PanRight</li>
     * <li>TiltDown</li>
     * <li>TiltUp</li>
     * <li>RollClockwise</li>
     * <li>RollAnticlockwise</li>
     * <li>ZoomIn</li>
     * <li>ZoomOut</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
	virtual bool ContentFromString(const XMLCh * const txt);

    /* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
     * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
     */
	virtual XMLCh * ContentToString() const;


    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMixtureAmountOfMotionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMixtureAmountOfMotionType();

protected:
    Mp7JrsMixtureAmountOfMotionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7Jrsunsigned11Ptr m_TrackLeft;
    bool m_TrackLeft_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_TrackRight;
    bool m_TrackRight_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_BoomDown;
    bool m_BoomDown_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_BoomUp;
    bool m_BoomUp_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_DollyForward;
    bool m_DollyForward_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_DollyBackward;
    bool m_DollyBackward_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_PanLeft;
    bool m_PanLeft_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_PanRight;
    bool m_PanRight_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_TiltDown;
    bool m_TiltDown_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_TiltUp;
    bool m_TiltUp_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_RollClockwise;
    bool m_RollClockwise_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_RollAnticlockwise;
    bool m_RollAnticlockwise_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_ZoomIn;
    bool m_ZoomIn_Exist; // For optional elements 
    Mp7Jrsunsigned11Ptr m_ZoomOut;
    bool m_ZoomOut_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMixtureAmountOfMotionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1377MP7JRSMIXTUREAMOUNTOFMOTIONTYPE_H

