/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


#ifndef _1384MP7JRSMODELDESCRIPTIONTYPE_MODEL_COLLECTIONTYPEFACTORY_H
#define _1384MP7JRSMODELDESCRIPTIONTYPE_MODEL_COLLECTIONTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsModelDescriptionType_Model_CollectionTypeFactory<br>
 * for class Mp7JrsModelDescriptionType_Model_CollectionType:<br>
 * Located at: mpeg7-2004.xsd, line 2738<br>
 * Abstract item type: ModelType<br>
 * Possible classes:<br>
 * \li BinomialDistributionType (Class)<br>
 * \li ClusterClassificationModelType (Class)<br>
 * \li ClusterModelType (Class)<br>
 * \li CollectionModelType (Class)<br>
 * \li ContinuousHiddenMarkovModelType (Class)<br>
 * \li ContinuousUniformDistributionType (Class)<br>
 * \li DescriptorModelType (Class)<br>
 * \li DiscreteHiddenMarkovModelType (Class)<br>
 * \li DiscreteUniformDistributionType (Class)<br>
 * \li ExponentialDistributionType (Class)<br>
 * \li GammaDistributionType (Class)<br>
 * \li GaussianDistributionType (Class)<br>
 * \li GaussianMixtureModelType (Class)<br>
 * \li GeneralizedGaussianDistributionType (Class)<br>
 * \li GeometricDistributionType (Class)<br>
 * \li HistogramProbabilityType (Class)<br>
 * \li HyperGeometricDistributionType (Class)<br>
 * \li LognormalDistributionType (Class)<br>
 * \li ModelStateType (Class)<br>
 * \li PoissonDistributionType (Class)<br>
 * \li ProbabilityClassificationModelType (Class)<br>
 * \li ProbabilityDistributionType (Class)<br>
 * \li ProbabilityModelClassType (Class)<br>
 * \li SoundClassificationModelType (Class)<br>
 * \li SoundModelType (Class)<br>
 * \li StateTransitionModelType (Class)<br>
 */

class MP7JRS_EXPORT Mp7JrsModelDescriptionType_Model_CollectionTypeFactory :
    public Mp7JrsFactory
{
public:
    Mp7JrsModelDescriptionType_Model_CollectionTypeFactory();
    virtual ~Mp7JrsModelDescriptionType_Model_CollectionTypeFactory();
	
    virtual const char * GetTypeName() const; // Formerly GetObjectType()
    virtual Mp7JrsNodePtr CreateObject();
};

#endif // _1384MP7JRSMODELDESCRIPTIONTYPE_MODEL_COLLECTIONTYPEFACTORY_H
