/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1579MP7JRSPACKAGETYPE_LOCALTYPE_H
#define _1579MP7JRSPACKAGETYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPackageType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsPackageType_LocalType_ExtInclude.h


class IMp7JrsPackageType;
class IMp7JrsPackageType_LocalType;
class IMp7JrsPackageType_Scheme_LocalType;
typedef Mp7JrsPtr< IMp7JrsPackageType > Mp7JrsPackagePtr;
typedef Mp7JrsPtr< IMp7JrsPackageType_LocalType> Mp7JrsPackageType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsPackageType_Scheme_LocalType > Mp7JrsPackageType_Scheme_LocalPtr;

/** 
 * Generated interface IMp7JrsPackageType_LocalType for class Mp7JrsPackageType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsPackageType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPackageType_LocalType();
    virtual ~IMp7JrsPackageType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Scheme element.
     * @return Mp7JrsPackageType_Scheme_LocalPtr
     */
    virtual Mp7JrsPackageType_Scheme_LocalPtr GetScheme() const = 0;

    /**
     * Set Scheme element.
     * @param item const Mp7JrsPackageType_Scheme_LocalPtr &
     */
    virtual void SetScheme(const Mp7JrsPackageType_Scheme_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Package element.
     * @return Mp7JrsPackagePtr
     */
    virtual Mp7JrsPackagePtr GetPackage() const = 0;

    /**
     * Set Package element.
     * @param item const Mp7JrsPackagePtr &
     */
    virtual void SetPackage(const Mp7JrsPackagePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPackageType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPackageType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPackageType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 2948.<br>
 */
class MP7JRS_EXPORT Mp7JrsPackageType_LocalType :
        public IMp7JrsPackageType_LocalType
{
    friend class Mp7JrsPackageType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Scheme element.
     * @return Mp7JrsPackageType_Scheme_LocalPtr
     */
    virtual Mp7JrsPackageType_Scheme_LocalPtr GetScheme() const;

    /*
     * Set Scheme element.
     * @param item const Mp7JrsPackageType_Scheme_LocalPtr &
     */
    virtual void SetScheme(const Mp7JrsPackageType_Scheme_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Package element.
     * @return Mp7JrsPackagePtr
     */
    virtual Mp7JrsPackagePtr GetPackage() const;

    /*
     * Set Package element.
     * @param item const Mp7JrsPackagePtr &
     */
    virtual void SetPackage(const Mp7JrsPackagePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPackageType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPackageType_LocalType();

protected:
    Mp7JrsPackageType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsPackageType_Scheme_LocalPtr m_Scheme;
    Mp7JrsPackagePtr m_Package;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsPackageType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1579MP7JRSPACKAGETYPE_LOCALTYPE_H

