/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _1601MP7JRSPARAMETRICMOTIONTYPE_MOTIONMODEL_LOCALTYPE_H
#define _1601MP7JRSPARAMETRICMOTIONTYPE_MOTIONMODEL_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsParametricMotionType_motionModel_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsParametricMotionType_motionModel_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 1063<br>
 * Enumerations: <br>
 * translational (mapped to XML translational) <br>
 * rotationOrScaling (mapped to XML rotationOrScaling) <br>
 * affine (mapped to XML affine) <br>
 * perspective (mapped to XML perspective) <br>
 * quadratic (mapped to XML quadratic) <br>
 */
class MP7JRS_EXPORT Mp7JrsParametricMotionType_motionModel_LocalType
{
public:
	/** Mp7JrsParametricMotionType_motionModel_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		translational, // Mapped to translational
		rotationOrScaling, // Mapped to rotationOrScaling
		affine, // Mapped to affine
		perspective, // Mapped to perspective
		quadratic, // Mapped to quadratic
	};
	

// no includefile for extension defined 
// file Mp7JrsParametricMotionType_motionModel_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration item);
	static Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsParametricMotionType_motionModel_LocalType_ExtPropDef.h



};
#endif // _1601MP7JRSPARAMETRICMOTIONTYPE_MOTIONMODEL_LOCALTYPE_H
