/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2219MP7JRSSTILLREGIONTYPE_LOCALTYPE_H
#define _2219MP7JRSSTILLREGIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsStillRegionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsStillRegionType_LocalType_ExtInclude.h


class IMp7JrsGridLayoutType;
class IMp7JrsStillRegionType_LocalType;
class IMp7JrsVisualDSType;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsGridLayoutType > Mp7JrsGridLayoutPtr;
typedef Mp7JrsPtr< IMp7JrsStillRegionType_LocalType> Mp7JrsStillRegionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsVisualDSType > Mp7JrsVisualDSPtr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsStillRegionType_LocalType for class Mp7JrsStillRegionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsStillRegionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsStillRegionType_LocalType();
    virtual ~IMp7JrsStillRegionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get VisualDescriptor element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetVisualDescriptor() const = 0;

    /**
     * Set VisualDescriptor element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    virtual void SetVisualDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get VisualDescriptionScheme element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsMovingRegionFeaturePtr</li>
     * <li>IMp7JrsStillRegionFeaturePtr</li>
     * <li>IMp7JrsVideoSegmentFeaturePtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetVisualDescriptionScheme() const = 0;

    /**
     * Set VisualDescriptionScheme element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsMovingRegionFeaturePtr</li>
     * <li>IMp7JrsStillRegionFeaturePtr</li>
     * <li>IMp7JrsVideoSegmentFeaturePtr</li>
     * </ul>
     */
    virtual void SetVisualDescriptionScheme(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get GridLayoutDescriptors element.
     * @return Mp7JrsGridLayoutPtr
     */
    virtual Mp7JrsGridLayoutPtr GetGridLayoutDescriptors() const = 0;

    /**
     * Set GridLayoutDescriptors element.
     * @param item const Mp7JrsGridLayoutPtr &
     */
    virtual void SetGridLayoutDescriptors(const Mp7JrsGridLayoutPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsStillRegionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsStillRegionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsStillRegionType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 5669.<br>
 */
class MP7JRS_EXPORT Mp7JrsStillRegionType_LocalType :
        public IMp7JrsStillRegionType_LocalType
{
    friend class Mp7JrsStillRegionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get VisualDescriptor element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetVisualDescriptor() const;

    /*
     * Set VisualDescriptor element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    virtual void SetVisualDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get VisualDescriptionScheme element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsMovingRegionFeaturePtr</li>
     * <li>IMp7JrsStillRegionFeaturePtr</li>
     * <li>IMp7JrsVideoSegmentFeaturePtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetVisualDescriptionScheme() const;

    /*
     * Set VisualDescriptionScheme element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsMovingRegionFeaturePtr</li>
     * <li>IMp7JrsStillRegionFeaturePtr</li>
     * <li>IMp7JrsVideoSegmentFeaturePtr</li>
     * </ul>
     */
    virtual void SetVisualDescriptionScheme(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get GridLayoutDescriptors element.
     * @return Mp7JrsGridLayoutPtr
     */
    virtual Mp7JrsGridLayoutPtr GetGridLayoutDescriptors() const;

    /*
     * Set GridLayoutDescriptors element.
     * @param item const Mp7JrsGridLayoutPtr &
     */
    virtual void SetGridLayoutDescriptors(const Mp7JrsGridLayoutPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsStillRegionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsStillRegionType_LocalType();

protected:
    Mp7JrsStillRegionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsPtr< Mp7JrsNode > m_VisualDescriptor;
    Mp7JrsPtr< Mp7JrsNode > m_VisualDescriptionScheme;
    Mp7JrsGridLayoutPtr m_GridLayoutDescriptors;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsStillRegionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _2219MP7JRSSTILLREGIONTYPE_LOCALTYPE_H

