/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2671MP7JRSVIDEOSEGMENTTYPE_LOCALTYPE0_H
#define _2671MP7JRSVIDEOSEGMENTTYPE_LOCALTYPE0_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsVideoSegmentType_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_LocalType0_ExtInclude.h


class IMp7JrsVideoSegmentMediaSourceDecompositionType;
class IMp7JrsVideoSegmentSpatialDecompositionType;
class IMp7JrsVideoSegmentSpatioTemporalDecompositionType;
class IMp7JrsVideoSegmentTemporalDecompositionType;
class IMp7JrsVideoSegmentType_LocalType0;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentMediaSourceDecompositionType > Mp7JrsVideoSegmentMediaSourceDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatialDecompositionType > Mp7JrsVideoSegmentSpatialDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatioTemporalDecompositionType > Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentTemporalDecompositionType > Mp7JrsVideoSegmentTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_LocalType0> Mp7JrsVideoSegmentType_Local0Ptr;

/** 
 * Generated interface IMp7JrsVideoSegmentType_LocalType0 for class Mp7JrsVideoSegmentType_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsVideoSegmentType_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsVideoSegmentType_LocalType0();
    virtual ~IMp7JrsVideoSegmentType_LocalType0();
        /** @name Choice

         */
        //@{
    /**
     * Get SpatialDecomposition element.
     * @return Mp7JrsVideoSegmentSpatialDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentSpatialDecompositionPtr GetSpatialDecomposition() const = 0;

    /**
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsVideoSegmentSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsVideoSegmentSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TemporalDecomposition element.
     * @return Mp7JrsVideoSegmentTemporalDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentTemporalDecompositionPtr GetTemporalDecomposition() const = 0;

    /**
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsVideoSegmentTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsVideoSegmentTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const = 0;

    /**
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsVideoSegmentMediaSourceDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentMediaSourceDecompositionPtr GetMediaSourceDecomposition() const = 0;

    /**
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsVideoSegmentMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsVideoSegmentMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsVideoSegmentType_LocalType0<br>
 * Defined in mpeg7-2004.xsd, line 5845.<br>
 */
class MP7JRS_EXPORT Mp7JrsVideoSegmentType_LocalType0 :
        public IMp7JrsVideoSegmentType_LocalType0
{
    friend class Mp7JrsVideoSegmentType_LocalType0Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get SpatialDecomposition element.
     * @return Mp7JrsVideoSegmentSpatialDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentSpatialDecompositionPtr GetSpatialDecomposition() const;

    /*
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsVideoSegmentSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsVideoSegmentSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TemporalDecomposition element.
     * @return Mp7JrsVideoSegmentTemporalDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentTemporalDecompositionPtr GetTemporalDecomposition() const;

    /*
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsVideoSegmentTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsVideoSegmentTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const;

    /*
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsVideoSegmentMediaSourceDecompositionPtr
     */
    virtual Mp7JrsVideoSegmentMediaSourceDecompositionPtr GetMediaSourceDecomposition() const;

    /*
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsVideoSegmentMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsVideoSegmentMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsVideoSegmentType_LocalType0();

protected:
    Mp7JrsVideoSegmentType_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsVideoSegmentSpatialDecompositionPtr m_SpatialDecomposition;
    Mp7JrsVideoSegmentTemporalDecompositionPtr m_TemporalDecomposition;
    Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr m_SpatioTemporalDecomposition;
    Mp7JrsVideoSegmentMediaSourceDecompositionPtr m_MediaSourceDecomposition;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _2671MP7JRSVIDEOSEGMENTTYPE_LOCALTYPE0_H

