/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _2749MP7JRSWORDLEXICONTYPE_TOKEN_LINGUISTICUNIT_LOCALTYPE_H
#define _2749MP7JRSWORDLEXICONTYPE_TOKEN_LINGUISTICUNIT_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 2031<br>
 * Enumerations: <br>
 * word (mapped to XML word) <br>
 * syllable (mapped to XML syllable) <br>
 * morpheme (mapped to XML morpheme) <br>
 * phrase (mapped to XML phrase) <br>
 * component (mapped to XML component) <br>
 * stem (mapped to XML stem) <br>
 * affix (mapped to XML affix) <br>
 * nonspeech (mapped to XML nonspeech) <br>
 * other (mapped to XML other) <br>
 */
class MP7JRS_EXPORT Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType
{
public:
	/** Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		word, // Mapped to word
		syllable, // Mapped to syllable
		morpheme, // Mapped to morpheme
		phrase, // Mapped to phrase
		component, // Mapped to component
		stem, // Mapped to stem
		affix, // Mapped to affix
		nonspeech, // Mapped to nonspeech
		other, // Mapped to other
	};
	

// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::Enumeration item);
	static Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType_ExtPropDef.h



};
#endif // _2749MP7JRSWORDLEXICONTYPE_TOKEN_LINGUISTICUNIT_LOCALTYPE_H
