/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// PatternType_H

#ifndef _639MP7JRSCOUNTRYCODE_H
#define _639MP7JRSCOUNTRYCODE_H


#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrscountryCodeFactory.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>
#include "Mp7JrsConvert.h"

// no includefile for extension defined 
// file Mp7JrscountryCode_ExtInclude.h



/**
 * Generated interface IMp7JrscountryCode for Pattern Mp7JrscountryCode
 */
class MP7JRS_EXPORT IMp7JrscountryCode :
	public Mp7JrsNode
{
public:
	virtual XMLCh * GetContent() const = 0;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


// no includefile for extension defined 
// file Mp7JrscountryCode_ExtMethodDef.h


};

/*
 * Generated pattern Mp7JrscountryCode<br>
 * Located at: mpeg7-2004.xsd, line 3373<br>
 * Regular expression: <br>
 * [a-zA-Z]{2}<br>
 * Mapped to string<br>
 */
class MP7JRS_EXPORT Mp7JrscountryCode :
	public IMp7JrscountryCode
{
	friend class Mp7JrscountryCodeFactory;
	
public: 
	virtual XMLCh * GetContent() const;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	virtual XMLCh * ToText() const;
	virtual bool Parse(const XMLCh * const txt);
	virtual bool ContentFromString(const XMLCh * const txt);

	virtual XMLCh * ContentToString() const;

	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent,  XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

// no includefile for extension defined 
// file Mp7JrscountryCode_ExtMyMethodDef.h


	virtual ~Mp7JrscountryCode();

protected:
	Mp7JrscountryCode();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);
	virtual Mp7JrsNodeEnum GetAllChildElements() const { return Mp7JrsNodeEnum(); }

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	XMLCh * m_Content;

// no includefile for extension defined 
// file Mp7JrscountryCode_ExtPropDef.h


protected:
	void Init();
	void Cleanup();
	
protected:
    const XMLCh * const m_nsURI; // For namespace handling
};

#endif // _639MP7JRSCOUNTRYCODE_H

