/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _713MP7JRSDEGREEACCIDENTALTYPE_H
#define _713MP7JRSDEGREEACCIDENTALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsdegreeAccidentalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsdegreeAccidentalType<br>
 * Located at: mpeg7-2004.xsd, line 2369<br>
 * Enumerations: <br>
 * flat (mapped to XML flat) <br>
 * natural (mapped to XML natural) <br>
 * sharp (mapped to XML sharp) <br>
 * doubleSharp (mapped to XML doubleSharp) <br>
 * doubleFlat (mapped to XML doubleFlat) <br>
 */
class MP7JRS_EXPORT Mp7JrsdegreeAccidentalType
{
public:
	/** Mp7JrsdegreeAccidentalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		flat, // Mapped to flat
		natural, // Mapped to natural
		sharp, // Mapped to sharp
		doubleSharp, // Mapped to doubleSharp
		doubleFlat, // Mapped to doubleFlat
	};
	

// no includefile for extension defined 
// file Mp7JrsdegreeAccidentalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsdegreeAccidentalType::Enumeration item);
	static Mp7JrsdegreeAccidentalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsdegreeAccidentalType_ExtPropDef.h



};
#endif // _713MP7JRSDEGREEACCIDENTALTYPE_H
