/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _2353MP7JRSSYNTHESISTYPE_H
#define _2353MP7JRSSYNTHESISTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrssynthesisType_ExtInclude.h




/**
 * Generated enumeration Mp7JrssynthesisType<br>
 * Located at: mpeg7-2004.xsd, line 9133<br>
 * Enumerations: <br>
 * none (mapped to XML none) <br>
 * dependency (mapped to XML dependency) <br>
 * forward (mapped to XML forward) <br>
 * backward (mapped to XML backward) <br>
 * coordination (mapped to XML coordination) <br>
 * apposition (mapped to XML apposition) <br>
 * repair (mapped to XML repair) <br>
 * error (mapped to XML error) <br>
 */
class MP7JRS_EXPORT Mp7JrssynthesisType
{
public:
	/** Mp7JrssynthesisType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		none, // Mapped to none
		dependency, // Mapped to dependency
		forward, // Mapped to forward
		backward, // Mapped to backward
		coordination, // Mapped to coordination
		apposition, // Mapped to apposition
		repair, // Mapped to repair
		error, // Mapped to error
	};
	

// no includefile for extension defined 
// file Mp7JrssynthesisType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrssynthesisType::Enumeration item);
	static Mp7JrssynthesisType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrssynthesisType_ExtPropDef.h



};
#endif // _2353MP7JRSSYNTHESISTYPE_H
