/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _2497MP7JRSUNITTYPE_H
#define _2497MP7JRSUNITTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsunitType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsunitType<br>
 * Located at: mpeg7-2004.xsd, line 9163<br>
 * Enumerations: <br>
 * _char (mapped to XML char) <br>
 * byte (mapped to XML byte) <br>
 * integer (mapped to XML integer) <br>
 * _long (mapped to XML long) <br>
 * _float (mapped to XML float) <br>
 * _double (mapped to XML double) <br>
 */
class MP7JRS_EXPORT Mp7JrsunitType
{
public:
	/** Mp7JrsunitType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		_char, // Mapped to char
		byte, // Mapped to byte
		integer, // Mapped to integer
		_long, // Mapped to long
		_float, // Mapped to float
		_double, // Mapped to double
	};
	

// no includefile for extension defined 
// file Mp7JrsunitType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsunitType::Enumeration item);
	static Mp7JrsunitType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsunitType_ExtPropDef.h



};
#endif // _2497MP7JRSUNITTYPE_H
