 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtImplInclude.h



#include "Mp7JrsVisualDType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalType.h"
#include "Mp7JrsAdvancedFaceRecognitionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsAdvancedFaceRecognitionType::IMp7JrsAdvancedFaceRecognitionType()
{

// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtPropInit.h

}

IMp7JrsAdvancedFaceRecognitionType::~IMp7JrsAdvancedFaceRecognitionType()
{
// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtPropCleanup.h

}

Mp7JrsAdvancedFaceRecognitionType::Mp7JrsAdvancedFaceRecognitionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAdvancedFaceRecognitionType::~Mp7JrsAdvancedFaceRecognitionType()
{
	Cleanup();
}

void Mp7JrsAdvancedFaceRecognitionType::Init()
{
	// Init base
	m_Base = CreateVisualDType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_FourierFeature = Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalPtr(); // Class
	m_CentralFourierFeature = Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalPtr(); // Class
	m_CompositeFeature = Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalPtr(); // Class
	m_SubregionCompositeFeature = Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtMyPropInit.h

}

void Mp7JrsAdvancedFaceRecognitionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_FourierFeature);
	// Mp7JrsFactory::DeleteObject(m_CentralFourierFeature);
	// Mp7JrsFactory::DeleteObject(m_CompositeFeature);
	// Mp7JrsFactory::DeleteObject(m_SubregionCompositeFeature);
}

void Mp7JrsAdvancedFaceRecognitionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AdvancedFaceRecognitionTypePtr, since we
	// might need GetBase(), which isn't defined in IAdvancedFaceRecognitionType
    const Mp7JrsPtr< Mp7JrsAdvancedFaceRecognitionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsVisualDPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsAdvancedFaceRecognitionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_FourierFeature);
		this->SetFourierFeature(Mp7JrsFactory::CloneObject(tmp->GetFourierFeature()));
		// Mp7JrsFactory::DeleteObject(m_CentralFourierFeature);
		this->SetCentralFourierFeature(Mp7JrsFactory::CloneObject(tmp->GetCentralFourierFeature()));
		// Mp7JrsFactory::DeleteObject(m_CompositeFeature);
		this->SetCompositeFeature(Mp7JrsFactory::CloneObject(tmp->GetCompositeFeature()));
		// Mp7JrsFactory::DeleteObject(m_SubregionCompositeFeature);
		this->SetSubregionCompositeFeature(Mp7JrsFactory::CloneObject(tmp->GetSubregionCompositeFeature()));
}

Mp7JrsNodePtr Mp7JrsAdvancedFaceRecognitionType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsAdvancedFaceRecognitionType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsVisualDType > Mp7JrsAdvancedFaceRecognitionType::GetBase() const
{
	return m_Base;
}

Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalPtr Mp7JrsAdvancedFaceRecognitionType::GetFourierFeature() const
{
	return m_FourierFeature;
}

Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalPtr Mp7JrsAdvancedFaceRecognitionType::GetCentralFourierFeature() const
{
	return m_CentralFourierFeature;
}

Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalPtr Mp7JrsAdvancedFaceRecognitionType::GetCompositeFeature() const
{
	return m_CompositeFeature;
}

Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalPtr Mp7JrsAdvancedFaceRecognitionType::GetSubregionCompositeFeature() const
{
	return m_SubregionCompositeFeature;
}

void Mp7JrsAdvancedFaceRecognitionType::SetFourierFeature(const Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAdvancedFaceRecognitionType::SetFourierFeature().");
	}
	if (m_FourierFeature != item)
	{
		// Mp7JrsFactory::DeleteObject(m_FourierFeature);
		m_FourierFeature = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_FourierFeature) m_FourierFeature->SetParent(m_myself.getPointer());
		if (m_FourierFeature && m_FourierFeature->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_FourierFeature_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_FourierFeature->UseTypeAttribute = true;
		}
		if(m_FourierFeature != Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_FourierFeature->SetContentName(XMLString::transcode("FourierFeature"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAdvancedFaceRecognitionType::SetCentralFourierFeature(const Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAdvancedFaceRecognitionType::SetCentralFourierFeature().");
	}
	if (m_CentralFourierFeature != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CentralFourierFeature);
		m_CentralFourierFeature = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CentralFourierFeature) m_CentralFourierFeature->SetParent(m_myself.getPointer());
		if (m_CentralFourierFeature && m_CentralFourierFeature->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_CentralFourierFeature_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CentralFourierFeature->UseTypeAttribute = true;
		}
		if(m_CentralFourierFeature != Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CentralFourierFeature->SetContentName(XMLString::transcode("CentralFourierFeature"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAdvancedFaceRecognitionType::SetCompositeFeature(const Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAdvancedFaceRecognitionType::SetCompositeFeature().");
	}
	if (m_CompositeFeature != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CompositeFeature);
		m_CompositeFeature = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CompositeFeature) m_CompositeFeature->SetParent(m_myself.getPointer());
		if (m_CompositeFeature && m_CompositeFeature->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_CompositeFeature_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CompositeFeature->UseTypeAttribute = true;
		}
		if(m_CompositeFeature != Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CompositeFeature->SetContentName(XMLString::transcode("CompositeFeature"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAdvancedFaceRecognitionType::SetSubregionCompositeFeature(const Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAdvancedFaceRecognitionType::SetSubregionCompositeFeature().");
	}
	if (m_SubregionCompositeFeature != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SubregionCompositeFeature);
		m_SubregionCompositeFeature = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SubregionCompositeFeature) m_SubregionCompositeFeature->SetParent(m_myself.getPointer());
		if (m_SubregionCompositeFeature && m_SubregionCompositeFeature->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_SubregionCompositeFeature_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SubregionCompositeFeature->UseTypeAttribute = true;
		}
		if(m_SubregionCompositeFeature != Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SubregionCompositeFeature->SetContentName(XMLString::transcode("SubregionCompositeFeature"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsAdvancedFaceRecognitionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("FourierFeature")) == 0)
	{
		// FourierFeature is simple element AdvancedFaceRecognitionType_FourierFeature_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetFourierFeature()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_FourierFeature_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetFourierFeature(p, client);
					if((p = GetFourierFeature()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CentralFourierFeature")) == 0)
	{
		// CentralFourierFeature is simple element AdvancedFaceRecognitionType_CentralFourierFeature_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetCentralFourierFeature()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_CentralFourierFeature_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetCentralFourierFeature(p, client);
					if((p = GetCentralFourierFeature()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CompositeFeature")) == 0)
	{
		// CompositeFeature is simple element AdvancedFaceRecognitionType_CompositeFeature_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetCompositeFeature()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_CompositeFeature_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetCompositeFeature(p, client);
					if((p = GetCompositeFeature()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SubregionCompositeFeature")) == 0)
	{
		// SubregionCompositeFeature is simple element AdvancedFaceRecognitionType_SubregionCompositeFeature_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetSubregionCompositeFeature()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AdvancedFaceRecognitionType_SubregionCompositeFeature_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetSubregionCompositeFeature(p, client);
					if((p = GetSubregionCompositeFeature()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for AdvancedFaceRecognitionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "AdvancedFaceRecognitionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsAdvancedFaceRecognitionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsAdvancedFaceRecognitionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsAdvancedFaceRecognitionType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsAdvancedFaceRecognitionType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsAdvancedFaceRecognitionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("AdvancedFaceRecognitionType"));
	// Element serialization:
	// Class
	
	if (m_FourierFeature != Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_FourierFeature->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("FourierFeature"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_FourierFeature->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CentralFourierFeature != Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CentralFourierFeature->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CentralFourierFeature"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CentralFourierFeature->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CompositeFeature != Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CompositeFeature->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CompositeFeature"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CompositeFeature->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_SubregionCompositeFeature != Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SubregionCompositeFeature->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SubregionCompositeFeature"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SubregionCompositeFeature->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsAdvancedFaceRecognitionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsVisualDType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("FourierFeature"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("FourierFeature")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAdvancedFaceRecognitionType_FourierFeature_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFourierFeature(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CentralFourierFeature"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CentralFourierFeature")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAdvancedFaceRecognitionType_CentralFourierFeature_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCentralFourierFeature(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CompositeFeature"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CompositeFeature")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAdvancedFaceRecognitionType_CompositeFeature_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCompositeFeature(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SubregionCompositeFeature"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SubregionCompositeFeature")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSubregionCompositeFeature(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAdvancedFaceRecognitionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("FourierFeature")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAdvancedFaceRecognitionType_FourierFeature_LocalType;
    }
    this->SetFourierFeature(child);
  }
  if (XMLString::compareString(elementname, X("CentralFourierFeature")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAdvancedFaceRecognitionType_CentralFourierFeature_LocalType;
    }
    this->SetCentralFourierFeature(child);
  }
  if (XMLString::compareString(elementname, X("CompositeFeature")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAdvancedFaceRecognitionType_CompositeFeature_LocalType;
    }
    this->SetCompositeFeature(child);
  }
  if (XMLString::compareString(elementname, X("SubregionCompositeFeature")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalType;
    }
    this->SetSubregionCompositeFeature(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAdvancedFaceRecognitionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetFourierFeature() != Mp7JrsNodePtr())
		result.Insert(GetFourierFeature());
	if (GetCentralFourierFeature() != Mp7JrsNodePtr())
		result.Insert(GetCentralFourierFeature());
	if (GetCompositeFeature() != Mp7JrsNodePtr())
		result.Insert(GetCompositeFeature());
	if (GetSubregionCompositeFeature() != Mp7JrsNodePtr())
		result.Insert(GetSubregionCompositeFeature());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAdvancedFaceRecognitionType_ExtMethodImpl.h


