 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_Review_LocalType_ExtImplInclude.h



#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsRatingType.h"
#include "Mp7JrsAgentType.h"
#include "Mp7JrsClassificationPreferencesType_Review_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsClassificationPreferencesType_Review_LocalType::IMp7JrsClassificationPreferencesType_Review_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_Review_LocalType_ExtPropInit.h

}

IMp7JrsClassificationPreferencesType_Review_LocalType::~IMp7JrsClassificationPreferencesType_Review_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_Review_LocalType_ExtPropCleanup.h

}

Mp7JrsClassificationPreferencesType_Review_LocalType::Mp7JrsClassificationPreferencesType_Review_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationPreferencesType_Review_LocalType::~Mp7JrsClassificationPreferencesType_Review_LocalType()
{
	Cleanup();
}

void Mp7JrsClassificationPreferencesType_Review_LocalType::Init()
{

	// Init attributes
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Rating = Mp7JrsRatingPtr(); // Class
	m_Rating_Exist = false;
	m_Reviewer = Mp7JrsPtr< Mp7JrsNode >(); // Class
	m_Reviewer_Exist = false;


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_Review_LocalType_ExtMyPropInit.h

}

void Mp7JrsClassificationPreferencesType_Review_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_Review_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	// Mp7JrsFactory::DeleteObject(m_Rating);
	// Mp7JrsFactory::DeleteObject(m_Reviewer);
}

void Mp7JrsClassificationPreferencesType_Review_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationPreferencesType_Review_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationPreferencesType_Review_LocalType
    const Mp7JrsPtr< Mp7JrsClassificationPreferencesType_Review_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
	if (tmp->IsValidRating())
	{
		// Mp7JrsFactory::DeleteObject(m_Rating);
		this->SetRating(Mp7JrsFactory::CloneObject(tmp->GetRating()));
	}
	else
	{
		InvalidateRating();
	}
	if (tmp->IsValidReviewer())
	{
		// Mp7JrsFactory::DeleteObject(m_Reviewer);
		this->SetReviewer(Mp7JrsFactory::CloneObject(tmp->GetReviewer()));
	}
	else
	{
		InvalidateReviewer();
	}
}

Mp7JrsNodePtr Mp7JrsClassificationPreferencesType_Review_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsClassificationPreferencesType_Review_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrspreferenceValuePtr Mp7JrsClassificationPreferencesType_Review_LocalType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsClassificationPreferencesType_Review_LocalType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsClassificationPreferencesType_Review_LocalType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType_Review_LocalType::SetpreferenceValue().");
	}
    m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType_Review_LocalType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
Mp7JrsRatingPtr Mp7JrsClassificationPreferencesType_Review_LocalType::GetRating() const
{
	return m_Rating;
}

// Element is optional
bool Mp7JrsClassificationPreferencesType_Review_LocalType::IsValidRating() const
{
	return m_Rating_Exist;
}

Mp7JrsPtr< Mp7JrsNode > Mp7JrsClassificationPreferencesType_Review_LocalType::GetReviewer() const
{
	return m_Reviewer;
}

// Element is optional
bool Mp7JrsClassificationPreferencesType_Review_LocalType::IsValidReviewer() const
{
	return m_Reviewer_Exist;
}

void Mp7JrsClassificationPreferencesType_Review_LocalType::SetRating(const Mp7JrsRatingPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType_Review_LocalType::SetRating().");
	}
	if (m_Rating != item || m_Rating_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Rating);
		m_Rating = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Rating) m_Rating->SetParent(m_myself.getPointer());
		if (m_Rating && m_Rating->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:RatingType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Rating->UseTypeAttribute = true;
		}
		m_Rating_Exist = true;
		if(m_Rating != Mp7JrsRatingPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Rating->SetContentName(XMLString::transcode("Rating"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType_Review_LocalType::InvalidateRating()
{
	m_Rating_Exist = false;
}
void Mp7JrsClassificationPreferencesType_Review_LocalType::SetReviewer(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType_Review_LocalType::SetReviewer().");
	}
	if (m_Reviewer != item || m_Reviewer_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Reviewer);
		m_Reviewer = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Reviewer) m_Reviewer->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_Reviewer) m_Reviewer->UseTypeAttribute = true;
		m_Reviewer_Exist = true;
		if(m_Reviewer != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Reviewer->SetContentName(XMLString::transcode("Reviewer"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType_Review_LocalType::InvalidateReviewer()
{
	m_Reviewer_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsClassificationPreferencesType_Review_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Rating")) == 0)
	{
		// Rating is simple element RatingType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetRating()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:RatingType")))) != empty)
			{
				// Is type allowed
				Mp7JrsRatingPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetRating(p, client);
					if((p = GetRating()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Reviewer")) == 0)
	{
		// Reviewer is simple abstract element AgentType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetReviewer()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsAgentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetReviewer(p, client);
					if((p = GetReviewer()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ClassificationPreferencesType_Review_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ClassificationPreferencesType_Review_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsClassificationPreferencesType_Review_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsClassificationPreferencesType_Review_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsClassificationPreferencesType_Review_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsClassificationPreferencesType_Review_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsClassificationPreferencesType_Review_LocalType::ContentToString() const
{
	// Mp7JrsClassificationPreferencesType_Review_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsClassificationPreferencesType_Review_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationPreferencesType_Review_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_Rating != Mp7JrsRatingPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Rating->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Rating"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Rating->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Reviewer != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Reviewer->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Reviewer"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_Reviewer->UseTypeAttribute = true;
		}
		m_Reviewer->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsClassificationPreferencesType_Review_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("preferenceValue")))
	{
        // Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttributeNS(X(""), X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
        Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
        tmp->Parse(parent->getAttribute(X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Rating"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Rating")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateRatingType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetRating(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Reviewer"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Reviewer")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAgentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetReviewer(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_Review_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationPreferencesType_Review_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Rating")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateRatingType;
    }
    this->SetRating(child);
  }
  if (XMLString::compareString(elementname, X("Reviewer")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAgentType;
    }
    this->SetReviewer(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationPreferencesType_Review_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetRating() != Mp7JrsNodePtr())
		result.Insert(GetRating());
	if (GetReviewer() != Mp7JrsNodePtr())
		result.Insert(GetReviewer());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_Review_LocalType_ExtMethodImpl.h


