 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtImplInclude.h



#include "Mp7JrsHeaderType.h"
#include "Mp7JrsClassificationSchemeAliasType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsClassificationSchemeAliasType::IMp7JrsClassificationSchemeAliasType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtPropInit.h

}

IMp7JrsClassificationSchemeAliasType::~IMp7JrsClassificationSchemeAliasType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtPropCleanup.h

}

Mp7JrsClassificationSchemeAliasType::Mp7JrsClassificationSchemeAliasType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationSchemeAliasType::~Mp7JrsClassificationSchemeAliasType()
{
	Cleanup();
}

void Mp7JrsClassificationSchemeAliasType::Init()
{
	// Init base
	m_Base = CreateHeaderType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_alias = NULL; // String
	m_href = NULL; // String



// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtMyPropInit.h

}

void Mp7JrsClassificationSchemeAliasType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	XMLString::release(&m_alias);
	XMLString::release(&m_href);
}

void Mp7JrsClassificationSchemeAliasType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationSchemeAliasTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationSchemeAliasType
    const Mp7JrsPtr< Mp7JrsClassificationSchemeAliasType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsHeaderPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsClassificationSchemeAliasType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	XMLString::release(&m_alias);
		this->Setalias(XMLString::replicate(tmp->Getalias()));
	}
	{
	XMLString::release(&m_href);
		this->Sethref(XMLString::replicate(tmp->Gethref()));
	}
}

Mp7JrsNodePtr Mp7JrsClassificationSchemeAliasType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsClassificationSchemeAliasType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsHeaderType > Mp7JrsClassificationSchemeAliasType::GetBase() const
{
	return m_Base;
}

XMLCh * Mp7JrsClassificationSchemeAliasType::Getalias() const
{
	return m_alias;
}

void Mp7JrsClassificationSchemeAliasType::Setalias(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeAliasType::Setalias().");
	}
    m_alias = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsClassificationSchemeAliasType::Gethref() const
{
	return m_href;
}

void Mp7JrsClassificationSchemeAliasType::Sethref(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeAliasType::Sethref().");
	}
    m_href = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsClassificationSchemeAliasType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsClassificationSchemeAliasType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsClassificationSchemeAliasType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeAliasType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationSchemeAliasType::Invalidateid()
{
	GetBase()->Invalidateid();
}

Mp7JrsNodeEnum Mp7JrsClassificationSchemeAliasType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for ClassificationSchemeAliasType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "ClassificationSchemeAliasType");
	}
	
	return result;
}

XMLCh * Mp7JrsClassificationSchemeAliasType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsClassificationSchemeAliasType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsClassificationSchemeAliasType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsClassificationSchemeAliasType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsClassificationSchemeAliasType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationSchemeAliasType"));
    // Attribute Serialization:
	// String
	if(m_alias != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("alias"), m_alias);
	}
    // Attribute Serialization:
	// String
	if(m_href != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("href"), m_href);
	}
	// Element serialization:

}

bool Mp7JrsClassificationSchemeAliasType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("alias")))
	{
        // Deserialize string type
        this->Setalias(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("alias"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("alias")))
	{
        // Deserialize string type
        this->Setalias(Mp7JrsConvert::TextToString(parent->getAttribute(X("alias"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("href")))
	{
        // Deserialize string type
        this->Sethref(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("href"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("href")))
	{
        // Deserialize string type
        this->Sethref(Mp7JrsConvert::TextToString(parent->getAttribute(X("href"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsHeaderType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationSchemeAliasType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationSchemeAliasType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationSchemeAliasType_ExtMethodImpl.h


