 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrsClassificationType_Genre_CollectionType.h"
#include "Mp7JrsTextAnnotationType.h"
#include "Mp7JrsClassificationType_Purpose_CollectionType.h"
#include "Mp7JrsClassificationType_Language_CollectionType.h"
#include "Mp7JrsClassificationType_CaptionLanguage_CollectionType.h"
#include "Mp7JrsClassificationType_SignLanguage_CollectionType.h"
#include "Mp7JrsClassificationType_Release_LocalType.h"
#include "Mp7JrsClassificationType_Target_LocalType.h"
#include "Mp7JrsClassificationType_ParentalGuidance_CollectionType.h"
#include "Mp7JrsClassificationType_MediaReview_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsClassificationType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsClassificationType_Genre_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Genre
#include "Mp7JrsExtendedLanguageType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Language
#include "Mp7JrsClassificationType_CaptionLanguage_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:CaptionLanguage
#include "Mp7JrsClassificationType_SignLanguage_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:SignLanguage
#include "Mp7JrsParentalGuidanceType.h" // Element collection urn:mpeg:mpeg7:schema:2004:ParentalGuidance
#include "Mp7JrsMediaReviewType.h" // Element collection urn:mpeg:mpeg7:schema:2004:MediaReview

#include <assert.h>
IMp7JrsClassificationType::IMp7JrsClassificationType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtPropInit.h

}

IMp7JrsClassificationType::~IMp7JrsClassificationType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtPropCleanup.h

}

Mp7JrsClassificationType::Mp7JrsClassificationType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationType::~Mp7JrsClassificationType()
{
	Cleanup();
}

void Mp7JrsClassificationType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_Form = Mp7JrsControlledTermUsePtr(); // Class
	m_Form_Exist = false;
	m_Genre = Mp7JrsClassificationType_Genre_CollectionPtr(); // Collection
	m_Subject = Mp7JrsTextAnnotationPtr(); // Class
	m_Subject_Exist = false;
	m_Purpose = Mp7JrsClassificationType_Purpose_CollectionPtr(); // Collection
	m_Language = Mp7JrsClassificationType_Language_CollectionPtr(); // Collection
	m_CaptionLanguage = Mp7JrsClassificationType_CaptionLanguage_CollectionPtr(); // Collection
	m_SignLanguage = Mp7JrsClassificationType_SignLanguage_CollectionPtr(); // Collection
	m_Release = Mp7JrsClassificationType_Release_LocalPtr(); // Class
	m_Release_Exist = false;
	m_Target = Mp7JrsClassificationType_Target_LocalPtr(); // Class
	m_Target_Exist = false;
	m_ParentalGuidance = Mp7JrsClassificationType_ParentalGuidance_CollectionPtr(); // Collection
	m_MediaReview = Mp7JrsClassificationType_MediaReview_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtMyPropInit.h

}

void Mp7JrsClassificationType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_Form);
	// Mp7JrsFactory::DeleteObject(m_Genre);
	// Mp7JrsFactory::DeleteObject(m_Subject);
	// Mp7JrsFactory::DeleteObject(m_Purpose);
	// Mp7JrsFactory::DeleteObject(m_Language);
	// Mp7JrsFactory::DeleteObject(m_CaptionLanguage);
	// Mp7JrsFactory::DeleteObject(m_SignLanguage);
	// Mp7JrsFactory::DeleteObject(m_Release);
	// Mp7JrsFactory::DeleteObject(m_Target);
	// Mp7JrsFactory::DeleteObject(m_ParentalGuidance);
	// Mp7JrsFactory::DeleteObject(m_MediaReview);
}

void Mp7JrsClassificationType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationType
    const Mp7JrsPtr< Mp7JrsClassificationType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsClassificationType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	if (tmp->IsValidForm())
	{
		// Mp7JrsFactory::DeleteObject(m_Form);
		this->SetForm(Mp7JrsFactory::CloneObject(tmp->GetForm()));
	}
	else
	{
		InvalidateForm();
	}
		// Mp7JrsFactory::DeleteObject(m_Genre);
		this->SetGenre(Mp7JrsFactory::CloneObject(tmp->GetGenre()));
	if (tmp->IsValidSubject())
	{
		// Mp7JrsFactory::DeleteObject(m_Subject);
		this->SetSubject(Mp7JrsFactory::CloneObject(tmp->GetSubject()));
	}
	else
	{
		InvalidateSubject();
	}
		// Mp7JrsFactory::DeleteObject(m_Purpose);
		this->SetPurpose(Mp7JrsFactory::CloneObject(tmp->GetPurpose()));
		// Mp7JrsFactory::DeleteObject(m_Language);
		this->SetLanguage(Mp7JrsFactory::CloneObject(tmp->GetLanguage()));
		// Mp7JrsFactory::DeleteObject(m_CaptionLanguage);
		this->SetCaptionLanguage(Mp7JrsFactory::CloneObject(tmp->GetCaptionLanguage()));
		// Mp7JrsFactory::DeleteObject(m_SignLanguage);
		this->SetSignLanguage(Mp7JrsFactory::CloneObject(tmp->GetSignLanguage()));
	if (tmp->IsValidRelease())
	{
		// Mp7JrsFactory::DeleteObject(m_Release);
		this->SetRelease(Mp7JrsFactory::CloneObject(tmp->GetRelease()));
	}
	else
	{
		InvalidateRelease();
	}
	if (tmp->IsValidTarget())
	{
		// Mp7JrsFactory::DeleteObject(m_Target);
		this->SetTarget(Mp7JrsFactory::CloneObject(tmp->GetTarget()));
	}
	else
	{
		InvalidateTarget();
	}
		// Mp7JrsFactory::DeleteObject(m_ParentalGuidance);
		this->SetParentalGuidance(Mp7JrsFactory::CloneObject(tmp->GetParentalGuidance()));
		// Mp7JrsFactory::DeleteObject(m_MediaReview);
		this->SetMediaReview(Mp7JrsFactory::CloneObject(tmp->GetMediaReview()));
}

Mp7JrsNodePtr Mp7JrsClassificationType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsClassificationType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsClassificationType::GetBase() const
{
	return m_Base;
}

Mp7JrsControlledTermUsePtr Mp7JrsClassificationType::GetForm() const
{
	return m_Form;
}

// Element is optional
bool Mp7JrsClassificationType::IsValidForm() const
{
	return m_Form_Exist;
}

Mp7JrsClassificationType_Genre_CollectionPtr Mp7JrsClassificationType::GetGenre() const
{
	return m_Genre;
}

Mp7JrsTextAnnotationPtr Mp7JrsClassificationType::GetSubject() const
{
	return m_Subject;
}

// Element is optional
bool Mp7JrsClassificationType::IsValidSubject() const
{
	return m_Subject_Exist;
}

Mp7JrsClassificationType_Purpose_CollectionPtr Mp7JrsClassificationType::GetPurpose() const
{
	return m_Purpose;
}

Mp7JrsClassificationType_Language_CollectionPtr Mp7JrsClassificationType::GetLanguage() const
{
	return m_Language;
}

Mp7JrsClassificationType_CaptionLanguage_CollectionPtr Mp7JrsClassificationType::GetCaptionLanguage() const
{
	return m_CaptionLanguage;
}

Mp7JrsClassificationType_SignLanguage_CollectionPtr Mp7JrsClassificationType::GetSignLanguage() const
{
	return m_SignLanguage;
}

Mp7JrsClassificationType_Release_LocalPtr Mp7JrsClassificationType::GetRelease() const
{
	return m_Release;
}

// Element is optional
bool Mp7JrsClassificationType::IsValidRelease() const
{
	return m_Release_Exist;
}

Mp7JrsClassificationType_Target_LocalPtr Mp7JrsClassificationType::GetTarget() const
{
	return m_Target;
}

// Element is optional
bool Mp7JrsClassificationType::IsValidTarget() const
{
	return m_Target_Exist;
}

Mp7JrsClassificationType_ParentalGuidance_CollectionPtr Mp7JrsClassificationType::GetParentalGuidance() const
{
	return m_ParentalGuidance;
}

Mp7JrsClassificationType_MediaReview_CollectionPtr Mp7JrsClassificationType::GetMediaReview() const
{
	return m_MediaReview;
}

void Mp7JrsClassificationType::SetForm(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetForm().");
	}
	if (m_Form != item || m_Form_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Form);
		m_Form = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Form) m_Form->SetParent(m_myself.getPointer());
		if (m_Form && m_Form->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Form->UseTypeAttribute = true;
		}
		m_Form_Exist = true;
		if(m_Form != Mp7JrsControlledTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Form->SetContentName(XMLString::transcode("Form"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidateForm()
{
	m_Form_Exist = false;
}
void Mp7JrsClassificationType::SetGenre(const Mp7JrsClassificationType_Genre_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetGenre().");
	}
	if (m_Genre != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Genre);
		m_Genre = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Genre) m_Genre->SetParent(m_myself.getPointer());
		if(m_Genre != Mp7JrsClassificationType_Genre_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Genre->SetContentName(XMLString::transcode("Genre"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::SetSubject(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetSubject().");
	}
	if (m_Subject != item || m_Subject_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Subject);
		m_Subject = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Subject) m_Subject->SetParent(m_myself.getPointer());
		if (m_Subject && m_Subject->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextAnnotationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Subject->UseTypeAttribute = true;
		}
		m_Subject_Exist = true;
		if(m_Subject != Mp7JrsTextAnnotationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Subject->SetContentName(XMLString::transcode("Subject"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidateSubject()
{
	m_Subject_Exist = false;
}
void Mp7JrsClassificationType::SetPurpose(const Mp7JrsClassificationType_Purpose_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetPurpose().");
	}
	if (m_Purpose != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Purpose);
		m_Purpose = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Purpose) m_Purpose->SetParent(m_myself.getPointer());
		if(m_Purpose != Mp7JrsClassificationType_Purpose_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Purpose->SetContentName(XMLString::transcode("Purpose"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::SetLanguage(const Mp7JrsClassificationType_Language_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetLanguage().");
	}
	if (m_Language != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Language);
		m_Language = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Language) m_Language->SetParent(m_myself.getPointer());
		if(m_Language != Mp7JrsClassificationType_Language_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Language->SetContentName(XMLString::transcode("Language"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::SetCaptionLanguage(const Mp7JrsClassificationType_CaptionLanguage_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetCaptionLanguage().");
	}
	if (m_CaptionLanguage != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CaptionLanguage);
		m_CaptionLanguage = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CaptionLanguage) m_CaptionLanguage->SetParent(m_myself.getPointer());
		if(m_CaptionLanguage != Mp7JrsClassificationType_CaptionLanguage_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CaptionLanguage->SetContentName(XMLString::transcode("CaptionLanguage"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::SetSignLanguage(const Mp7JrsClassificationType_SignLanguage_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetSignLanguage().");
	}
	if (m_SignLanguage != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SignLanguage);
		m_SignLanguage = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SignLanguage) m_SignLanguage->SetParent(m_myself.getPointer());
		if(m_SignLanguage != Mp7JrsClassificationType_SignLanguage_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SignLanguage->SetContentName(XMLString::transcode("SignLanguage"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::SetRelease(const Mp7JrsClassificationType_Release_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetRelease().");
	}
	if (m_Release != item || m_Release_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Release);
		m_Release = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Release) m_Release->SetParent(m_myself.getPointer());
		if (m_Release && m_Release->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_Release_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Release->UseTypeAttribute = true;
		}
		m_Release_Exist = true;
		if(m_Release != Mp7JrsClassificationType_Release_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Release->SetContentName(XMLString::transcode("Release"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidateRelease()
{
	m_Release_Exist = false;
}
void Mp7JrsClassificationType::SetTarget(const Mp7JrsClassificationType_Target_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetTarget().");
	}
	if (m_Target != item || m_Target_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Target);
		m_Target = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Target) m_Target->SetParent(m_myself.getPointer());
		if (m_Target && m_Target->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_Target_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Target->UseTypeAttribute = true;
		}
		m_Target_Exist = true;
		if(m_Target != Mp7JrsClassificationType_Target_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Target->SetContentName(XMLString::transcode("Target"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidateTarget()
{
	m_Target_Exist = false;
}
void Mp7JrsClassificationType::SetParentalGuidance(const Mp7JrsClassificationType_ParentalGuidance_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetParentalGuidance().");
	}
	if (m_ParentalGuidance != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ParentalGuidance);
		m_ParentalGuidance = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ParentalGuidance) m_ParentalGuidance->SetParent(m_myself.getPointer());
		if(m_ParentalGuidance != Mp7JrsClassificationType_ParentalGuidance_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ParentalGuidance->SetContentName(XMLString::transcode("ParentalGuidance"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::SetMediaReview(const Mp7JrsClassificationType_MediaReview_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetMediaReview().");
	}
	if (m_MediaReview != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaReview);
		m_MediaReview = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaReview) m_MediaReview->SetParent(m_myself.getPointer());
		if(m_MediaReview != Mp7JrsClassificationType_MediaReview_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaReview->SetContentName(XMLString::transcode("MediaReview"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsClassificationType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsClassificationType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsClassificationType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsClassificationType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsClassificationType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsClassificationType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsClassificationType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsClassificationType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsClassificationType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsClassificationType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsClassificationType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsClassificationType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsClassificationType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsClassificationType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsClassificationType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsClassificationType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsClassificationType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsClassificationType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Form")) == 0)
	{
		// Form is simple element ControlledTermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetForm()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsControlledTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetForm(p, client);
					if((p = GetForm()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Genre")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Genre is item of type ClassificationType_Genre_LocalType
		// in element collection ClassificationType_Genre_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_Genre_CollectionPtr coll = GetGenre();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_Genre_CollectionType;
				SetGenre(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_Genre_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationType_Genre_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Subject")) == 0)
	{
		// Subject is simple element TextAnnotationType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetSubject()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextAnnotationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextAnnotationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetSubject(p, client);
					if((p = GetSubject()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Purpose")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Purpose is item of type ControlledTermUseType
		// in element collection ClassificationType_Purpose_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_Purpose_CollectionPtr coll = GetPurpose();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_Purpose_CollectionType;
				SetPurpose(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsControlledTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Language")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Language is item of type ExtendedLanguageType
		// in element collection ClassificationType_Language_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_Language_CollectionPtr coll = GetLanguage();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_Language_CollectionType;
				SetLanguage(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ExtendedLanguageType")))) != empty)
			{
				// Is type allowed
				Mp7JrsExtendedLanguagePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CaptionLanguage")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:CaptionLanguage is item of type ClassificationType_CaptionLanguage_LocalType
		// in element collection ClassificationType_CaptionLanguage_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_CaptionLanguage_CollectionPtr coll = GetCaptionLanguage();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_CaptionLanguage_CollectionType;
				SetCaptionLanguage(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_CaptionLanguage_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationType_CaptionLanguage_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SignLanguage")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:SignLanguage is item of type ClassificationType_SignLanguage_LocalType
		// in element collection ClassificationType_SignLanguage_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_SignLanguage_CollectionPtr coll = GetSignLanguage();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_SignLanguage_CollectionType;
				SetSignLanguage(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_SignLanguage_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationType_SignLanguage_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Release")) == 0)
	{
		// Release is simple element ClassificationType_Release_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetRelease()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_Release_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationType_Release_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetRelease(p, client);
					if((p = GetRelease()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Target")) == 0)
	{
		// Target is simple element ClassificationType_Target_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTarget()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_Target_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationType_Target_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTarget(p, client);
					if((p = GetTarget()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ParentalGuidance")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:ParentalGuidance is item of type ParentalGuidanceType
		// in element collection ClassificationType_ParentalGuidance_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_ParentalGuidance_CollectionPtr coll = GetParentalGuidance();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_ParentalGuidance_CollectionType;
				SetParentalGuidance(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ParentalGuidanceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsParentalGuidancePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaReview")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:MediaReview is item of type MediaReviewType
		// in element collection ClassificationType_MediaReview_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_MediaReview_CollectionPtr coll = GetMediaReview();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_MediaReview_CollectionType;
				SetMediaReview(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaReviewType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaReviewPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ClassificationType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ClassificationType");
	}		
	
	return result;
}

XMLCh * Mp7JrsClassificationType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsClassificationType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsClassificationType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsClassificationType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsClassificationType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationType"));
	// Element serialization:
	// Class
	
	if (m_Form != Mp7JrsControlledTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Form->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Form"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Form->Serialize(doc, element, &elem);
	}
	if (m_Genre != Mp7JrsClassificationType_Genre_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Genre->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	// Class
	
	if (m_Subject != Mp7JrsTextAnnotationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Subject->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Subject"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Subject->Serialize(doc, element, &elem);
	}
	if (m_Purpose != Mp7JrsClassificationType_Purpose_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Purpose->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Language != Mp7JrsClassificationType_Language_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Language->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_CaptionLanguage != Mp7JrsClassificationType_CaptionLanguage_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_CaptionLanguage->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_SignLanguage != Mp7JrsClassificationType_SignLanguage_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SignLanguage->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	// Class
	
	if (m_Release != Mp7JrsClassificationType_Release_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Release->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Release"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Release->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Target != Mp7JrsClassificationType_Target_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Target->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Target"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Target->Serialize(doc, element, &elem);
	}
	if (m_ParentalGuidance != Mp7JrsClassificationType_ParentalGuidance_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_ParentalGuidance->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_MediaReview != Mp7JrsClassificationType_MediaReview_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MediaReview->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsClassificationType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Form"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Form")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateControlledTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetForm(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Genre"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Genre")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationType_Genre_CollectionPtr tmp = CreateClassificationType_Genre_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetGenre(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Subject"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Subject")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTextAnnotationType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSubject(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Purpose"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Purpose")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationType_Purpose_CollectionPtr tmp = CreateClassificationType_Purpose_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetPurpose(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Language"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Language")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationType_Language_CollectionPtr tmp = CreateClassificationType_Language_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetLanguage(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("CaptionLanguage"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("CaptionLanguage")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationType_CaptionLanguage_CollectionPtr tmp = CreateClassificationType_CaptionLanguage_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetCaptionLanguage(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("SignLanguage"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("SignLanguage")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationType_SignLanguage_CollectionPtr tmp = CreateClassificationType_SignLanguage_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSignLanguage(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Release"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Release")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateClassificationType_Release_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetRelease(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Target"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Target")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateClassificationType_Target_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTarget(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("ParentalGuidance"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("ParentalGuidance")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationType_ParentalGuidance_CollectionPtr tmp = CreateClassificationType_ParentalGuidance_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetParentalGuidance(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("MediaReview"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("MediaReview")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationType_MediaReview_CollectionPtr tmp = CreateClassificationType_MediaReview_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMediaReview(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("Form")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateControlledTermUseType;
    }
    this->SetForm(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Genre")) == 0))
  {
    Mp7JrsClassificationType_Genre_CollectionPtr tmp = CreateClassificationType_Genre_CollectionType;
    this->SetGenre(tmp);
    child = tmp;
  }
  if (XMLString::compareString(elementname, X("Subject")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTextAnnotationType;
    }
    this->SetSubject(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Purpose")) == 0))
  {
    Mp7JrsClassificationType_Purpose_CollectionPtr tmp = CreateClassificationType_Purpose_CollectionType;
    this->SetPurpose(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Language")) == 0))
  {
    Mp7JrsClassificationType_Language_CollectionPtr tmp = CreateClassificationType_Language_CollectionType;
    this->SetLanguage(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("CaptionLanguage")) == 0))
  {
    Mp7JrsClassificationType_CaptionLanguage_CollectionPtr tmp = CreateClassificationType_CaptionLanguage_CollectionType;
    this->SetCaptionLanguage(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("SignLanguage")) == 0))
  {
    Mp7JrsClassificationType_SignLanguage_CollectionPtr tmp = CreateClassificationType_SignLanguage_CollectionType;
    this->SetSignLanguage(tmp);
    child = tmp;
  }
  if (XMLString::compareString(elementname, X("Release")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateClassificationType_Release_LocalType;
    }
    this->SetRelease(child);
  }
  if (XMLString::compareString(elementname, X("Target")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateClassificationType_Target_LocalType;
    }
    this->SetTarget(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("ParentalGuidance")) == 0))
  {
    Mp7JrsClassificationType_ParentalGuidance_CollectionPtr tmp = CreateClassificationType_ParentalGuidance_CollectionType;
    this->SetParentalGuidance(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("MediaReview")) == 0))
  {
    Mp7JrsClassificationType_MediaReview_CollectionPtr tmp = CreateClassificationType_MediaReview_CollectionType;
    this->SetMediaReview(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetForm() != Mp7JrsNodePtr())
		result.Insert(GetForm());
	if (GetGenre() != Mp7JrsNodePtr())
		result.Insert(GetGenre());
	if (GetSubject() != Mp7JrsNodePtr())
		result.Insert(GetSubject());
	if (GetPurpose() != Mp7JrsNodePtr())
		result.Insert(GetPurpose());
	if (GetLanguage() != Mp7JrsNodePtr())
		result.Insert(GetLanguage());
	if (GetCaptionLanguage() != Mp7JrsNodePtr())
		result.Insert(GetCaptionLanguage());
	if (GetSignLanguage() != Mp7JrsNodePtr())
		result.Insert(GetSignLanguage());
	if (GetRelease() != Mp7JrsNodePtr())
		result.Insert(GetRelease());
	if (GetTarget() != Mp7JrsNodePtr())
		result.Insert(GetTarget());
	if (GetParentalGuidance() != Mp7JrsNodePtr())
		result.Insert(GetParentalGuidance());
	if (GetMediaReview() != Mp7JrsNodePtr())
		result.Insert(GetMediaReview());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtMethodImpl.h


