 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtImplInclude.h



#include "Mp7JrsClassificationType_CaptionLanguage_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsClassificationType_CaptionLanguage_LocalType::IMp7JrsClassificationType_CaptionLanguage_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtPropInit.h

}

IMp7JrsClassificationType_CaptionLanguage_LocalType::~IMp7JrsClassificationType_CaptionLanguage_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtPropCleanup.h

}

Mp7JrsClassificationType_CaptionLanguage_LocalType::Mp7JrsClassificationType_CaptionLanguage_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationType_CaptionLanguage_LocalType::~Mp7JrsClassificationType_CaptionLanguage_LocalType()
{
	Cleanup();
}

void Mp7JrsClassificationType_CaptionLanguage_LocalType::Init()
{
	// Init base
	m_Base = XMLString::transcode("");

	// Init attributes
	m_closed = false; // Value
	m_closed_Default = true;
	m_closed_Exist = false;
	m_supplemental = false; // Value
	m_supplemental_Default = false;
	m_supplemental_Exist = false;



// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtMyPropInit.h

}

void Mp7JrsClassificationType_CaptionLanguage_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_Base);
}

void Mp7JrsClassificationType_CaptionLanguage_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationType_CaptionLanguage_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationType_CaptionLanguage_LocalType
    const Mp7JrsPtr< Mp7JrsClassificationType_CaptionLanguage_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	XMLString::release(&m_Base);
	m_Base = XMLString::replicate(tmp->GetContent());
	{
	if (tmp->Existclosed())
	{
		this->Setclosed(tmp->Getclosed());
	}
	else
	{
		Invalidateclosed();
	}
	}
	{
	if (tmp->Existsupplemental())
	{
		this->Setsupplemental(tmp->Getsupplemental());
	}
	else
	{
		Invalidatesupplemental();
	}
	}
}

Mp7JrsNodePtr Mp7JrsClassificationType_CaptionLanguage_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsClassificationType_CaptionLanguage_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


void Mp7JrsClassificationType_CaptionLanguage_LocalType::SetContent(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_CaptionLanguage_LocalType::SetContent().");
	}
    if (m_Base != item)
    {
		XMLString::release(&m_Base);
		m_Base = item;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsClassificationType_CaptionLanguage_LocalType::GetContent() const
{
	return m_Base;
}
bool Mp7JrsClassificationType_CaptionLanguage_LocalType::Getclosed() const
{
	if (this->Existclosed()) {
		return m_closed;
	} else {
		return m_closed_Default;
	}
}

bool Mp7JrsClassificationType_CaptionLanguage_LocalType::Existclosed() const
{
	return m_closed_Exist;
}
void Mp7JrsClassificationType_CaptionLanguage_LocalType::Setclosed(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_CaptionLanguage_LocalType::Setclosed().");
	}
    m_closed = item;
	m_closed_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_CaptionLanguage_LocalType::Invalidateclosed()
{
	m_closed_Exist = false;
}
bool Mp7JrsClassificationType_CaptionLanguage_LocalType::Getsupplemental() const
{
	if (this->Existsupplemental()) {
		return m_supplemental;
	} else {
		return m_supplemental_Default;
	}
}

bool Mp7JrsClassificationType_CaptionLanguage_LocalType::Existsupplemental() const
{
	return m_supplemental_Exist;
}
void Mp7JrsClassificationType_CaptionLanguage_LocalType::Setsupplemental(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_CaptionLanguage_LocalType::Setsupplemental().");
	}
    m_supplemental = item;
	m_supplemental_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_CaptionLanguage_LocalType::Invalidatesupplemental()
{
	m_supplemental_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsClassificationType_CaptionLanguage_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for ClassificationType_CaptionLanguage_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "ClassificationType_CaptionLanguage_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsClassificationType_CaptionLanguage_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsClassificationType_CaptionLanguage_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsClassificationType_CaptionLanguage_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsClassificationType_CaptionLanguage_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsClassificationType_CaptionLanguage_LocalType::ContentToString() const
{
	// Mp7JrsClassificationType_CaptionLanguage_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsClassificationType_CaptionLanguage_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


    element->appendChild(doc->createTextNode(m_Base));

	assert(element);
// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationType_CaptionLanguage_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_closed_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_closed);
		element->setAttributeNS(X(""), X("closed"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_supplemental_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_supplemental);
		element->setAttributeNS(X(""), X("supplemental"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsClassificationType_CaptionLanguage_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("closed")))
	{
        // deserialize value type
        this->Setclosed(Mp7JrsConvert::TextToBool(parent->getAttributeNS(X(""), X("closed"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("closed")))
	{
        // deserialize value type
        this->Setclosed(Mp7JrsConvert::TextToBool(parent->getAttribute(X("closed"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("supplemental")))
	{
        // deserialize value type
        this->Setsupplemental(Mp7JrsConvert::TextToBool(parent->getAttributeNS(X(""), X("supplemental"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("supplemental")))
	{
        // deserialize value type
        this->Setsupplemental(Mp7JrsConvert::TextToBool(parent->getAttribute(X("supplemental"))));
        * current = parent;
    }

	XMLCh * tmp = Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent));
	if(tmp != NULL)
	{
		XMLString::release(&m_Base);
		m_Base = tmp;
		found = true;
	}
// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationType_CaptionLanguage_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationType_CaptionLanguage_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationType_CaptionLanguage_LocalType_ExtMethodImpl.h


