 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtImplInclude.h



#include "Mp7JrsColorLayoutType_YACCoeff27_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff27_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsColorLayoutType_YACCoeff27_LocalType::IMp7JrsColorLayoutType_YACCoeff27_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtPropInit.h

}

IMp7JrsColorLayoutType_YACCoeff27_LocalType::~IMp7JrsColorLayoutType_YACCoeff27_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtPropCleanup.h

}

Mp7JrsColorLayoutType_YACCoeff27_LocalType::Mp7JrsColorLayoutType_YACCoeff27_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsColorLayoutType_YACCoeff27_LocalType::~Mp7JrsColorLayoutType_YACCoeff27_LocalType()
{
	Cleanup();
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::Init()
{
	// Init base
	m_Base = CreateColorLayoutType_YACCoeff27_CollectionType;
	m_Base->m_myself = m_myself.getPointer();
	




// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtMyPropInit.h

}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ColorLayoutType_YACCoeff27_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IColorLayoutType_YACCoeff27_LocalType
    const Mp7JrsPtr< Mp7JrsColorLayoutType_YACCoeff27_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsColorLayoutType_YACCoeff27_CollectionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsColorLayoutType_YACCoeff27_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
}

Mp7JrsNodePtr Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsColorLayoutType_YACCoeff27_CollectionType > Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsPtr< Mp7JrsColorLayoutType_YACCoeff27_CollectionType > Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetBaseCollection() const
{
	return GetBase();
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::Initialize(unsigned int maxElems)
{
	GetBase()->Initialize(maxElems);
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::addElement(const Mp7JrsNodePtr &toAdd, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorLayoutType_YACCoeff27_LocalType::addElement().");
	}
	GetBase()->addElement(toAdd);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_ADDED,
		client, toAdd);
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::setElementAt(const Mp7JrsNodePtr &toSet, unsigned int setAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorLayoutType_YACCoeff27_LocalType::setElementAt().");
	}
	GetBase()->setElementAt(toSet, setAt);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, toSet, setAt);
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::insertElementAt(const Mp7JrsNodePtr &toInsert, unsigned int insertAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorLayoutType_YACCoeff27_LocalType::insertElementAt().");
	}
	GetBase()->insertElementAt(toInsert, insertAt);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_INSERTED,
		client, toInsert, insertAt);
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::removeAllElements(Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorLayoutType_YACCoeff27_LocalType::removeAllElements().");
	}
	GetBase()->removeAllElements();
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::removeElementAt(unsigned int removeAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorLayoutType_YACCoeff27_LocalType::removeElementAt().");
	}
	GetBase()->removeElementAt(removeAt);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

bool Mp7JrsColorLayoutType_YACCoeff27_LocalType::containsElement(const Mp7JrsNodePtr &toCheck)
{
	return GetBase()->containsElement(toCheck);
}

unsigned int Mp7JrsColorLayoutType_YACCoeff27_LocalType::curCapacity() const
{
	return GetBase()->curCapacity();
}

const Mp7JrsNodePtr Mp7JrsColorLayoutType_YACCoeff27_LocalType::elementAt(unsigned int getAt) const
{
	return GetBase()->elementAt(getAt);
}

Mp7JrsNodePtr Mp7JrsColorLayoutType_YACCoeff27_LocalType::elementAt(unsigned int getAt)
{
	return GetBase()->elementAt(getAt);
}

Mp7JrsNodeEnum Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetElementsOfType(unsigned int id) const
{
	return GetBase()->GetElementsOfType(id);
}

Mp7JrsNodeEnum Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetElements() const
{
	return GetBase()->GetElements();
}


unsigned int Mp7JrsColorLayoutType_YACCoeff27_LocalType::size() const
{
	return GetBase()->size();
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::ensureExtraCapacity(unsigned int length)
{
	GetBase()->ensureExtraCapacity(length);
}

int Mp7JrsColorLayoutType_YACCoeff27_LocalType::elementIndexOf(const Mp7JrsNodePtr &toCheck) const
{
	return GetBase()->elementIndexOf(toCheck);
}


Mp7JrsNodeEnum Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for ColorLayoutType_YACCoeff27_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "ColorLayoutType_YACCoeff27_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsColorLayoutType_YACCoeff27_LocalType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsColorLayoutType_YACCoeff27_LocalType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsColorLayoutType_YACCoeff27_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsColorLayoutType_YACCoeff27_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsColorLayoutType_YACCoeff27_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ColorLayoutType_YACCoeff27_LocalType"));
	// Element serialization:

}

bool Mp7JrsColorLayoutType_YACCoeff27_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

  // Extensionbase is Mp7JrsColorLayoutType_YACCoeff27_CollectionType
  // Deserialize cce factory type
  if(m_Base->Deserialize(doc, parent, current))
  {
    found = true;
    parent = * current;
    parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
  }
// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsColorLayoutType_YACCoeff27_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsColorLayoutType_YACCoeff27_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsColorLayoutType_YACCoeff27_LocalType_ExtMethodImpl.h


