 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtImplInclude.h



#include "Mp7JrsConceptCollectionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsConceptCollectionType_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsConceptCollectionType_LocalType0::IMp7JrsConceptCollectionType_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtPropInit.h

}

IMp7JrsConceptCollectionType_LocalType0::~IMp7JrsConceptCollectionType_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtPropCleanup.h

}

Mp7JrsConceptCollectionType_LocalType0::Mp7JrsConceptCollectionType_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsConceptCollectionType_LocalType0::~Mp7JrsConceptCollectionType_LocalType0()
{
	Cleanup();
}

void Mp7JrsConceptCollectionType_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_ConceptCollection = Mp7JrsConceptCollectionPtr(); // Class
	m_ConceptCollectionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtMyPropInit.h

}

void Mp7JrsConceptCollectionType_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_ConceptCollection);
	// Mp7JrsFactory::DeleteObject(m_ConceptCollectionRef);
}

void Mp7JrsConceptCollectionType_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ConceptCollectionType_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in IConceptCollectionType_LocalType0
    const Mp7JrsPtr< Mp7JrsConceptCollectionType_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_ConceptCollection);
		this->SetConceptCollection(Mp7JrsFactory::CloneObject(tmp->GetConceptCollection()));
		// Mp7JrsFactory::DeleteObject(m_ConceptCollectionRef);
		this->SetConceptCollectionRef(Mp7JrsFactory::CloneObject(tmp->GetConceptCollectionRef()));
}

Mp7JrsNodePtr Mp7JrsConceptCollectionType_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsConceptCollectionType_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsConceptCollectionPtr Mp7JrsConceptCollectionType_LocalType0::GetConceptCollection() const
{
	return m_ConceptCollection;
}

Mp7JrsReferencePtr Mp7JrsConceptCollectionType_LocalType0::GetConceptCollectionRef() const
{
	return m_ConceptCollectionRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsConceptCollectionType_LocalType0::SetConceptCollection(const Mp7JrsConceptCollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsConceptCollectionType_LocalType0::SetConceptCollection().");
	}
	if (m_ConceptCollection != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ConceptCollection);
		m_ConceptCollection = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ConceptCollection) m_ConceptCollection->SetParent(m_myself.getPointer());
		if (m_ConceptCollection && m_ConceptCollection->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ConceptCollectionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ConceptCollection->UseTypeAttribute = true;
		}
		if(m_ConceptCollection != Mp7JrsConceptCollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ConceptCollection->SetContentName(XMLString::transcode("ConceptCollection"));
		}
	// Mp7JrsFactory::DeleteObject(m_ConceptCollectionRef);
	m_ConceptCollectionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsConceptCollectionType_LocalType0::SetConceptCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsConceptCollectionType_LocalType0::SetConceptCollectionRef().");
	}
	if (m_ConceptCollectionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ConceptCollectionRef);
		m_ConceptCollectionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ConceptCollectionRef) m_ConceptCollectionRef->SetParent(m_myself.getPointer());
		if (m_ConceptCollectionRef && m_ConceptCollectionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ConceptCollectionRef->UseTypeAttribute = true;
		}
		if(m_ConceptCollectionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ConceptCollectionRef->SetContentName(XMLString::transcode("ConceptCollectionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_ConceptCollection);
	m_ConceptCollection = Mp7JrsConceptCollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: ConceptCollectionType_LocalType0: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsConceptCollectionType_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsConceptCollectionType_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsConceptCollectionType_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsConceptCollectionType_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_ConceptCollection != Mp7JrsConceptCollectionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ConceptCollection->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ConceptCollection"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ConceptCollection->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ConceptCollectionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ConceptCollectionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ConceptCollectionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ConceptCollectionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsConceptCollectionType_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ConceptCollection"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ConceptCollection")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateConceptCollectionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetConceptCollection(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ConceptCollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ConceptCollectionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetConceptCollectionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsConceptCollectionType_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("ConceptCollection")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateConceptCollectionType;
    }
    this->SetConceptCollection(child);
  }
  if (XMLString::compareString(elementname, X("ConceptCollectionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetConceptCollectionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsConceptCollectionType_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetConceptCollection() != Mp7JrsNodePtr())
		result.Insert(GetConceptCollection());
	if (GetConceptCollectionRef() != Mp7JrsNodePtr())
		result.Insert(GetConceptCollectionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtMethodImpl.h


