 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtImplInclude.h



#include "Mp7JrsStateTransitionModelType.h"
#include "Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionType.h"
#include "Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType.h"
#include "Mp7JrsProbabilityMatrixType.h"
#include "Mp7JrsStateTransitionModelType_State_CollectionType.h"
#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsContinuousHiddenMarkovModelType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsModelStateType.h" // Element collection urn:mpeg:mpeg7:schema:2004:State
#include "Mp7JrsDescriptorModelType.h" // Element collection urn:mpeg:mpeg7:schema:2004:DescriptorModel
#include "Mp7JrsContinuousDistributionType.h" // Element collection urn:mpeg:mpeg7:schema:2004:ObservationDistribution

#include <assert.h>
IMp7JrsContinuousHiddenMarkovModelType::IMp7JrsContinuousHiddenMarkovModelType()
{

// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtPropInit.h

}

IMp7JrsContinuousHiddenMarkovModelType::~IMp7JrsContinuousHiddenMarkovModelType()
{
// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtPropCleanup.h

}

Mp7JrsContinuousHiddenMarkovModelType::Mp7JrsContinuousHiddenMarkovModelType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsContinuousHiddenMarkovModelType::~Mp7JrsContinuousHiddenMarkovModelType()
{
	Cleanup();
}

void Mp7JrsContinuousHiddenMarkovModelType::Init()
{
	// Init base
	m_Base = CreateStateTransitionModelType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_DescriptorModel = Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr(); // Collection
	m_ObservationDistribution = Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtMyPropInit.h

}

void Mp7JrsContinuousHiddenMarkovModelType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_DescriptorModel);
	// Mp7JrsFactory::DeleteObject(m_ObservationDistribution);
}

void Mp7JrsContinuousHiddenMarkovModelType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ContinuousHiddenMarkovModelTypePtr, since we
	// might need GetBase(), which isn't defined in IContinuousHiddenMarkovModelType
    const Mp7JrsPtr< Mp7JrsContinuousHiddenMarkovModelType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsStateTransitionModelPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsContinuousHiddenMarkovModelType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_DescriptorModel);
		this->SetDescriptorModel(Mp7JrsFactory::CloneObject(tmp->GetDescriptorModel()));
		// Mp7JrsFactory::DeleteObject(m_ObservationDistribution);
		this->SetObservationDistribution(Mp7JrsFactory::CloneObject(tmp->GetObservationDistribution()));
}

Mp7JrsNodePtr Mp7JrsContinuousHiddenMarkovModelType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsContinuousHiddenMarkovModelType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsStateTransitionModelType > Mp7JrsContinuousHiddenMarkovModelType::GetBase() const
{
	return m_Base;
}

Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr Mp7JrsContinuousHiddenMarkovModelType::GetDescriptorModel() const
{
	return m_DescriptorModel;
}

Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr Mp7JrsContinuousHiddenMarkovModelType::GetObservationDistribution() const
{
	return m_ObservationDistribution;
}

void Mp7JrsContinuousHiddenMarkovModelType::SetDescriptorModel(const Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetDescriptorModel().");
	}
	if (m_DescriptorModel != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DescriptorModel);
		m_DescriptorModel = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DescriptorModel) m_DescriptorModel->SetParent(m_myself.getPointer());
		if(m_DescriptorModel != Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_DescriptorModel->SetContentName(XMLString::transcode("DescriptorModel"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::SetObservationDistribution(const Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetObservationDistribution().");
	}
	if (m_ObservationDistribution != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ObservationDistribution);
		m_ObservationDistribution = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ObservationDistribution) m_ObservationDistribution->SetParent(m_myself.getPointer());
		if(m_ObservationDistribution != Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ObservationDistribution->SetContentName(XMLString::transcode("ObservationDistribution"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsProbabilityMatrixPtr Mp7JrsContinuousHiddenMarkovModelType::GetInitial() const
{
	return GetBase()->GetInitial();
}

// Element is optional
bool Mp7JrsContinuousHiddenMarkovModelType::IsValidInitial() const
{
	return GetBase()->IsValidInitial();
}

Mp7JrsProbabilityMatrixPtr Mp7JrsContinuousHiddenMarkovModelType::GetTransitions() const
{
	return GetBase()->GetTransitions();
}

Mp7JrsStateTransitionModelType_State_CollectionPtr Mp7JrsContinuousHiddenMarkovModelType::GetState() const
{
	return GetBase()->GetState();
}

void Mp7JrsContinuousHiddenMarkovModelType::SetInitial(const Mp7JrsProbabilityMatrixPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetInitial().");
	}
	GetBase()->SetInitial(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::InvalidateInitial()
{
	GetBase()->InvalidateInitial();
}
void Mp7JrsContinuousHiddenMarkovModelType::SetTransitions(const Mp7JrsProbabilityMatrixPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetTransitions().");
	}
	GetBase()->SetTransitions(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::SetState(const Mp7JrsStateTransitionModelType_State_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetState().");
	}
	GetBase()->SetState(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsContinuousHiddenMarkovModelType::GetnumOfStates() const
{
	return GetBase()->GetBase()->GetnumOfStates();
}

void Mp7JrsContinuousHiddenMarkovModelType::SetnumOfStates(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetnumOfStates().");
	}
	GetBase()->GetBase()->SetnumOfStates(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrszeroToOnePtr Mp7JrsContinuousHiddenMarkovModelType::Getconfidence() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Getconfidence();
}

bool Mp7JrsContinuousHiddenMarkovModelType::Existconfidence() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Existconfidence();
}
void Mp7JrsContinuousHiddenMarkovModelType::Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::Setconfidence().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->Setconfidence(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::Invalidateconfidence()
{
	GetBase()->GetBase()->GetBase()->GetBase()->Invalidateconfidence();
}
Mp7JrszeroToOnePtr Mp7JrsContinuousHiddenMarkovModelType::Getreliability() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Getreliability();
}

bool Mp7JrsContinuousHiddenMarkovModelType::Existreliability() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Existreliability();
}
void Mp7JrsContinuousHiddenMarkovModelType::Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::Setreliability().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->Setreliability(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::Invalidatereliability()
{
	GetBase()->GetBase()->GetBase()->GetBase()->Invalidatereliability();
}
XMLCh * Mp7JrsContinuousHiddenMarkovModelType::Getid() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Getid();
}

bool Mp7JrsContinuousHiddenMarkovModelType::Existid() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Existid();
}
void Mp7JrsContinuousHiddenMarkovModelType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::Setid().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::Invalidateid()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsContinuousHiddenMarkovModelType::GettimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsContinuousHiddenMarkovModelType::ExisttimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsContinuousHiddenMarkovModelType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SettimeBase().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::InvalidatetimeBase()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsContinuousHiddenMarkovModelType::GettimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsContinuousHiddenMarkovModelType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsContinuousHiddenMarkovModelType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SettimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsContinuousHiddenMarkovModelType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsContinuousHiddenMarkovModelType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsContinuousHiddenMarkovModelType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsContinuousHiddenMarkovModelType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsContinuousHiddenMarkovModelType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsContinuousHiddenMarkovModelType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsContinuousHiddenMarkovModelType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsContinuousHiddenMarkovModelType::GetHeader() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetHeader();
}

void Mp7JrsContinuousHiddenMarkovModelType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContinuousHiddenMarkovModelType::SetHeader().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsContinuousHiddenMarkovModelType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("DescriptorModel")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:DescriptorModel is item of type DescriptorModelType
		// in element collection ContinuousHiddenMarkovModelType_DescriptorModel_CollectionType
		
		context->Found = true;
		Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr coll = GetDescriptorModel();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateContinuousHiddenMarkovModelType_DescriptorModel_CollectionType;
				SetDescriptorModel(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DescriptorModelType")))) != empty)
			{
				// Is type allowed
				Mp7JrsDescriptorModelPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ObservationDistribution")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:ObservationDistribution is item of abstract type ContinuousDistributionType
		// in element collection ContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType
		
		context->Found = true;
		Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr coll = GetObservationDistribution();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType;
				SetObservationDistribution(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsContinuousDistributionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ContinuousHiddenMarkovModelType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ContinuousHiddenMarkovModelType");
	}		
	
	return result;
}

XMLCh * Mp7JrsContinuousHiddenMarkovModelType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsContinuousHiddenMarkovModelType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsContinuousHiddenMarkovModelType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsContinuousHiddenMarkovModelType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsContinuousHiddenMarkovModelType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ContinuousHiddenMarkovModelType"));
	// Element serialization:
	if (m_DescriptorModel != Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_DescriptorModel->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_ObservationDistribution != Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_ObservationDistribution->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsContinuousHiddenMarkovModelType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsStateTransitionModelType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("DescriptorModel"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("DescriptorModel")) == 0))
        {
            // Deserialize factory type
            Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr tmp = CreateContinuousHiddenMarkovModelType_DescriptorModel_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetDescriptorModel(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("ObservationDistribution"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("ObservationDistribution")) == 0))
        {
            // Deserialize factory type
            Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr tmp = CreateContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetObservationDistribution(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsContinuousHiddenMarkovModelType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("DescriptorModel")) == 0))
  {
    Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr tmp = CreateContinuousHiddenMarkovModelType_DescriptorModel_CollectionType;
    this->SetDescriptorModel(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("ObservationDistribution")) == 0))
  {
    Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr tmp = CreateContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType;
    this->SetObservationDistribution(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsContinuousHiddenMarkovModelType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetDescriptorModel() != Mp7JrsNodePtr())
		result.Insert(GetDescriptorModel());
	if (GetObservationDistribution() != Mp7JrsNodePtr())
		result.Insert(GetObservationDistribution());
	if (GetInitial() != Mp7JrsNodePtr())
		result.Insert(GetInitial());
	if (GetTransitions() != Mp7JrsNodePtr())
		result.Insert(GetTransitions());
	if (GetState() != Mp7JrsNodePtr())
		result.Insert(GetState());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsContinuousHiddenMarkovModelType_ExtMethodImpl.h


