 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtImplInclude.h



#include "Mp7JrsStateTransitionModelType.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_CollectionType.h"
#include "Mp7JrsProbabilityMatrixType.h"
#include "Mp7JrsStateTransitionModelType_State_CollectionType.h"
#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsModelStateType.h" // Element collection urn:mpeg:mpeg7:schema:2004:State
#include "Mp7JrsDiscreteHiddenMarkovModelType_LocalType.h" // Sequence collection ObservationDistribution
#include "Mp7JrsDiscreteDistributionType.h" // Sequence collection element ObservationDistribution

#include <assert.h>
IMp7JrsDiscreteHiddenMarkovModelType::IMp7JrsDiscreteHiddenMarkovModelType()
{

// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtPropInit.h

}

IMp7JrsDiscreteHiddenMarkovModelType::~IMp7JrsDiscreteHiddenMarkovModelType()
{
// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtPropCleanup.h

}

Mp7JrsDiscreteHiddenMarkovModelType::Mp7JrsDiscreteHiddenMarkovModelType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsDiscreteHiddenMarkovModelType::~Mp7JrsDiscreteHiddenMarkovModelType()
{
	Cleanup();
}

void Mp7JrsDiscreteHiddenMarkovModelType::Init()
{
	// Init base
	m_Base = CreateStateTransitionModelType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_DiscreteHiddenMarkovModelType_LocalType = Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtMyPropInit.h

}

void Mp7JrsDiscreteHiddenMarkovModelType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_DiscreteHiddenMarkovModelType_LocalType);
}

void Mp7JrsDiscreteHiddenMarkovModelType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use DiscreteHiddenMarkovModelTypePtr, since we
	// might need GetBase(), which isn't defined in IDiscreteHiddenMarkovModelType
    const Mp7JrsPtr< Mp7JrsDiscreteHiddenMarkovModelType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsStateTransitionModelPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsDiscreteHiddenMarkovModelType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_DiscreteHiddenMarkovModelType_LocalType);
		this->SetDiscreteHiddenMarkovModelType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetDiscreteHiddenMarkovModelType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsDiscreteHiddenMarkovModelType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsDiscreteHiddenMarkovModelType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsStateTransitionModelType > Mp7JrsDiscreteHiddenMarkovModelType::GetBase() const
{
	return m_Base;
}

Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr Mp7JrsDiscreteHiddenMarkovModelType::GetDiscreteHiddenMarkovModelType_LocalType() const
{
	return m_DiscreteHiddenMarkovModelType_LocalType;
}

void Mp7JrsDiscreteHiddenMarkovModelType::SetDiscreteHiddenMarkovModelType_LocalType(const Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetDiscreteHiddenMarkovModelType_LocalType().");
	}
	if (m_DiscreteHiddenMarkovModelType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DiscreteHiddenMarkovModelType_LocalType);
		m_DiscreteHiddenMarkovModelType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DiscreteHiddenMarkovModelType_LocalType) m_DiscreteHiddenMarkovModelType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsProbabilityMatrixPtr Mp7JrsDiscreteHiddenMarkovModelType::GetInitial() const
{
	return GetBase()->GetInitial();
}

// Element is optional
bool Mp7JrsDiscreteHiddenMarkovModelType::IsValidInitial() const
{
	return GetBase()->IsValidInitial();
}

Mp7JrsProbabilityMatrixPtr Mp7JrsDiscreteHiddenMarkovModelType::GetTransitions() const
{
	return GetBase()->GetTransitions();
}

Mp7JrsStateTransitionModelType_State_CollectionPtr Mp7JrsDiscreteHiddenMarkovModelType::GetState() const
{
	return GetBase()->GetState();
}

void Mp7JrsDiscreteHiddenMarkovModelType::SetInitial(const Mp7JrsProbabilityMatrixPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetInitial().");
	}
	GetBase()->SetInitial(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::InvalidateInitial()
{
	GetBase()->InvalidateInitial();
}
void Mp7JrsDiscreteHiddenMarkovModelType::SetTransitions(const Mp7JrsProbabilityMatrixPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetTransitions().");
	}
	GetBase()->SetTransitions(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::SetState(const Mp7JrsStateTransitionModelType_State_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetState().");
	}
	GetBase()->SetState(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsDiscreteHiddenMarkovModelType::GetnumOfStates() const
{
	return GetBase()->GetBase()->GetnumOfStates();
}

void Mp7JrsDiscreteHiddenMarkovModelType::SetnumOfStates(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetnumOfStates().");
	}
	GetBase()->GetBase()->SetnumOfStates(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrszeroToOnePtr Mp7JrsDiscreteHiddenMarkovModelType::Getconfidence() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Getconfidence();
}

bool Mp7JrsDiscreteHiddenMarkovModelType::Existconfidence() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Existconfidence();
}
void Mp7JrsDiscreteHiddenMarkovModelType::Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::Setconfidence().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->Setconfidence(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::Invalidateconfidence()
{
	GetBase()->GetBase()->GetBase()->GetBase()->Invalidateconfidence();
}
Mp7JrszeroToOnePtr Mp7JrsDiscreteHiddenMarkovModelType::Getreliability() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Getreliability();
}

bool Mp7JrsDiscreteHiddenMarkovModelType::Existreliability() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->Existreliability();
}
void Mp7JrsDiscreteHiddenMarkovModelType::Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::Setreliability().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->Setreliability(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::Invalidatereliability()
{
	GetBase()->GetBase()->GetBase()->GetBase()->Invalidatereliability();
}
XMLCh * Mp7JrsDiscreteHiddenMarkovModelType::Getid() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Getid();
}

bool Mp7JrsDiscreteHiddenMarkovModelType::Existid() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Existid();
}
void Mp7JrsDiscreteHiddenMarkovModelType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::Setid().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::Invalidateid()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsDiscreteHiddenMarkovModelType::GettimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsDiscreteHiddenMarkovModelType::ExisttimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsDiscreteHiddenMarkovModelType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SettimeBase().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::InvalidatetimeBase()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsDiscreteHiddenMarkovModelType::GettimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsDiscreteHiddenMarkovModelType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsDiscreteHiddenMarkovModelType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SettimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsDiscreteHiddenMarkovModelType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsDiscreteHiddenMarkovModelType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsDiscreteHiddenMarkovModelType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsDiscreteHiddenMarkovModelType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsDiscreteHiddenMarkovModelType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsDiscreteHiddenMarkovModelType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDiscreteHiddenMarkovModelType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsDiscreteHiddenMarkovModelType::GetHeader() const
{
	return GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->GetHeader();
}

void Mp7JrsDiscreteHiddenMarkovModelType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDiscreteHiddenMarkovModelType::SetHeader().");
	}
	GetBase()->GetBase()->GetBase()->GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsDiscreteHiddenMarkovModelType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Observation")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Observation is itemtype TextualType in element collection DiscreteHiddenMarkovModelType_Observation_CollectionType
		// nested in sequence collection DiscreteHiddenMarkovModelType_CollectionType (itemtype: DiscreteHiddenMarkovModelType_LocalType)
		throw Mp7JrsException(MP7JRS_ERROR, "Sorry, sequence collections of element collections will be supported soon.");
		return result;
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ObservationDistribution")) == 0)
	{
		// ObservationDistribution is contained in itemtype DiscreteHiddenMarkovModelType_LocalType
		// in sequence collection DiscreteHiddenMarkovModelType_CollectionType

		context->Found = true;
		Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr coll = GetDiscreteHiddenMarkovModelType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateDiscreteHiddenMarkovModelType_CollectionType;
				SetDiscreteHiddenMarkovModelType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr)coll->elementAt(i))->GetObservationDistribution()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr item = CreateDiscreteHiddenMarkovModelType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr)coll->elementAt(j))->SetObservationDistribution(
						((Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr)coll->elementAt(j+1))->GetObservationDistribution());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr)coll->elementAt(j))->SetObservationDistribution(
						((Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr)coll->elementAt(j-1))->GetObservationDistribution());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsDiscreteDistributionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr)coll->elementAt(i))->SetObservationDistribution(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr)coll->elementAt(i))->GetObservationDistribution()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for DiscreteHiddenMarkovModelType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "DiscreteHiddenMarkovModelType");
	}		
	
	return result;
}

XMLCh * Mp7JrsDiscreteHiddenMarkovModelType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsDiscreteHiddenMarkovModelType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsDiscreteHiddenMarkovModelType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsDiscreteHiddenMarkovModelType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsDiscreteHiddenMarkovModelType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("DiscreteHiddenMarkovModelType"));
	// Element serialization:
	if (m_DiscreteHiddenMarkovModelType_LocalType != Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_DiscreteHiddenMarkovModelType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsDiscreteHiddenMarkovModelType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsStateTransitionModelType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Sequence Collection
        if((parent != NULL) && (
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:NumOfObservationsPerState")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("NumOfObservationsPerState"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Observation")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("Observation"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ObservationDistribution")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("ObservationDistribution"), X("urn:mpeg:mpeg7:schema:2004")))
                ))
        {
            // Deserialize factory type
            Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr tmp = CreateDiscreteHiddenMarkovModelType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetDiscreteHiddenMarkovModelType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsDiscreteHiddenMarkovModelType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr tmp = CreateDiscreteHiddenMarkovModelType_CollectionType;
    this->SetDiscreteHiddenMarkovModelType_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsDiscreteHiddenMarkovModelType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetDiscreteHiddenMarkovModelType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetDiscreteHiddenMarkovModelType_LocalType());
	if (GetInitial() != Mp7JrsNodePtr())
		result.Insert(GetInitial());
	if (GetTransitions() != Mp7JrsNodePtr())
		result.Insert(GetTransitions());
	if (GetState() != Mp7JrsNodePtr())
		result.Insert(GetState());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_ExtMethodImpl.h


