 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtImplInclude.h



#include "Mp7JrsTemporalSegmentDecompositionType.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType.h" // Sequence collection Shot
#include "Mp7JrsShotType.h" // Sequence collection element Shot
#include "Mp7JrsReferenceType.h" // Sequence collection element ShotRef
#include "Mp7JrsGlobalTransitionType.h" // Sequence collection element GlobalTransition

#include <assert.h>
IMp7JrsEditedVideoEditingTemporalDecompositionType::IMp7JrsEditedVideoEditingTemporalDecompositionType()
{

// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtPropInit.h

}

IMp7JrsEditedVideoEditingTemporalDecompositionType::~IMp7JrsEditedVideoEditingTemporalDecompositionType()
{
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtPropCleanup.h

}

Mp7JrsEditedVideoEditingTemporalDecompositionType::Mp7JrsEditedVideoEditingTemporalDecompositionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsEditedVideoEditingTemporalDecompositionType::~Mp7JrsEditedVideoEditingTemporalDecompositionType()
{
	Cleanup();
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::Init()
{
	// Init base
	m_Base = CreateTemporalSegmentDecompositionType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_EditedVideoEditingTemporalDecompositionType_LocalType = Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtMyPropInit.h

}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_EditedVideoEditingTemporalDecompositionType_LocalType);
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use EditedVideoEditingTemporalDecompositionTypePtr, since we
	// might need GetBase(), which isn't defined in IEditedVideoEditingTemporalDecompositionType
    const Mp7JrsPtr< Mp7JrsEditedVideoEditingTemporalDecompositionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsTemporalSegmentDecompositionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsEditedVideoEditingTemporalDecompositionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_EditedVideoEditingTemporalDecompositionType_LocalType);
		this->SetEditedVideoEditingTemporalDecompositionType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetEditedVideoEditingTemporalDecompositionType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsTemporalSegmentDecompositionType > Mp7JrsEditedVideoEditingTemporalDecompositionType::GetBase() const
{
	return m_Base;
}

Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GetEditedVideoEditingTemporalDecompositionType_LocalType() const
{
	return m_EditedVideoEditingTemporalDecompositionType_LocalType;
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::SetEditedVideoEditingTemporalDecompositionType_LocalType(const Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::SetEditedVideoEditingTemporalDecompositionType_LocalType().");
	}
	if (m_EditedVideoEditingTemporalDecompositionType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_EditedVideoEditingTemporalDecompositionType_LocalType);
		m_EditedVideoEditingTemporalDecompositionType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_EditedVideoEditingTemporalDecompositionType_LocalType) m_EditedVideoEditingTemporalDecompositionType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsEditedVideoEditingTemporalDecompositionType::Getcriteria() const
{
	return GetBase()->GetBase()->Getcriteria();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Existcriteria() const
{
	return GetBase()->GetBase()->Existcriteria();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::Setcriteria(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::Setcriteria().");
	}
	GetBase()->GetBase()->Setcriteria(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::Invalidatecriteria()
{
	GetBase()->GetBase()->Invalidatecriteria();
}
bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Getoverlap() const
{
	return GetBase()->GetBase()->Getoverlap();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Existoverlap() const
{
	return GetBase()->GetBase()->Existoverlap();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::Setoverlap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::Setoverlap().");
	}
	GetBase()->GetBase()->Setoverlap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::Invalidateoverlap()
{
	GetBase()->GetBase()->Invalidateoverlap();
}
bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Getgap() const
{
	return GetBase()->GetBase()->Getgap();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Existgap() const
{
	return GetBase()->GetBase()->Existgap();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::Setgap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::Setgap().");
	}
	GetBase()->GetBase()->Setgap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::Invalidategap()
{
	GetBase()->GetBase()->Invalidategap();
}
XMLCh * Mp7JrsEditedVideoEditingTemporalDecompositionType::Getid() const
{
	return GetBase()->GetBase()->GetBase()->Getid();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Existid() const
{
	return GetBase()->GetBase()->GetBase()->Existid();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::Setid().");
	}
	GetBase()->GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::Invalidateid()
{
	GetBase()->GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GettimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::ExisttimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::SettimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::InvalidatetimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GettimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::SettimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsEditedVideoEditingTemporalDecompositionType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsEditedVideoEditingTemporalDecompositionType::GetHeader() const
{
	return GetBase()->GetBase()->GetBase()->GetHeader();
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType::SetHeader().");
	}
	GetBase()->GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsEditedVideoEditingTemporalDecompositionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Shot")) == 0)
	{
		// Shot is contained in itemtype EditedVideoEditingTemporalDecompositionType_LocalType
		// in sequence collection EditedVideoEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr coll = GetEditedVideoEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateEditedVideoEditingTemporalDecompositionType_CollectionType;
				SetEditedVideoEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetShot()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr item = CreateEditedVideoEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetShot(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetShot());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetShot(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetShot());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ShotType")))) != empty)
			{
				// Is type allowed
				Mp7JrsShotPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetShot(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetShot()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ShotRef")) == 0)
	{
		// ShotRef is contained in itemtype EditedVideoEditingTemporalDecompositionType_LocalType
		// in sequence collection EditedVideoEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr coll = GetEditedVideoEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateEditedVideoEditingTemporalDecompositionType_CollectionType;
				SetEditedVideoEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetShotRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr item = CreateEditedVideoEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetShotRef(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetShotRef());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetShotRef(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetShotRef());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetShotRef(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetShotRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("GlobalTransition")) == 0)
	{
		// GlobalTransition is contained in itemtype EditedVideoEditingTemporalDecompositionType_LocalType
		// in sequence collection EditedVideoEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr coll = GetEditedVideoEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateEditedVideoEditingTemporalDecompositionType_CollectionType;
				SetEditedVideoEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetGlobalTransition()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr item = CreateEditedVideoEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetGlobalTransition(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetGlobalTransition());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetGlobalTransition(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetGlobalTransition());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:GlobalTransitionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsGlobalTransitionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetGlobalTransition(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetGlobalTransition()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("GlobalTransitionRef")) == 0)
	{
		// GlobalTransitionRef is contained in itemtype EditedVideoEditingTemporalDecompositionType_LocalType
		// in sequence collection EditedVideoEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr coll = GetEditedVideoEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateEditedVideoEditingTemporalDecompositionType_CollectionType;
				SetEditedVideoEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetGlobalTransitionRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr item = CreateEditedVideoEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetGlobalTransitionRef(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetGlobalTransitionRef());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetGlobalTransitionRef(
						((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetGlobalTransitionRef());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetGlobalTransitionRef(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetGlobalTransitionRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for EditedVideoEditingTemporalDecompositionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "EditedVideoEditingTemporalDecompositionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsEditedVideoEditingTemporalDecompositionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsEditedVideoEditingTemporalDecompositionType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("EditedVideoEditingTemporalDecompositionType"));
	// Element serialization:
	if (m_EditedVideoEditingTemporalDecompositionType_LocalType != Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_EditedVideoEditingTemporalDecompositionType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsTemporalSegmentDecompositionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Sequence Collection
        if((parent != NULL) && (
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Shot")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("Shot"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ShotRef")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("ShotRef"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:GlobalTransition")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("GlobalTransition"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:GlobalTransitionRef")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("GlobalTransitionRef"), X("urn:mpeg:mpeg7:schema:2004")))
                ))
        {
            // Deserialize factory type
            Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr tmp = CreateEditedVideoEditingTemporalDecompositionType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetEditedVideoEditingTemporalDecompositionType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsEditedVideoEditingTemporalDecompositionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr tmp = CreateEditedVideoEditingTemporalDecompositionType_CollectionType;
    this->SetEditedVideoEditingTemporalDecompositionType_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsEditedVideoEditingTemporalDecompositionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetEditedVideoEditingTemporalDecompositionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetEditedVideoEditingTemporalDecompositionType_LocalType());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_ExtMethodImpl.h


