 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsCreationPreferencesType.h" // Element collection urn:mpeg:mpeg7:schema:2004:CreationPreferences
#include "Mp7JrsClassificationPreferencesType.h" // Element collection urn:mpeg:mpeg7:schema:2004:ClassificationPreferences
#include "Mp7JrsSourcePreferencesType.h" // Element collection urn:mpeg:mpeg7:schema:2004:SourcePreferences
#include "Mp7JrsPreferenceConditionType.h" // Element collection urn:mpeg:mpeg7:schema:2004:PreferenceCondition
#include "Mp7JrsFilteringAndSearchPreferencesType.h" // Element collection urn:mpeg:mpeg7:schema:2004:FilteringAndSearchPreferences

#include <assert.h>
IMp7JrsFilteringAndSearchPreferencesType::IMp7JrsFilteringAndSearchPreferencesType()
{

// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtPropInit.h

}

IMp7JrsFilteringAndSearchPreferencesType::~IMp7JrsFilteringAndSearchPreferencesType()
{
// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtPropCleanup.h

}

Mp7JrsFilteringAndSearchPreferencesType::Mp7JrsFilteringAndSearchPreferencesType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsFilteringAndSearchPreferencesType::~Mp7JrsFilteringAndSearchPreferencesType()
{
	Cleanup();
}

void Mp7JrsFilteringAndSearchPreferencesType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_protected = Mp7JrsuserChoiceType::UninitializedEnumeration;
// old	m_protected = Mp7JrsuserChoiceType::Enumeration::;
// old	m_protected_Default = Mp7JrsuserChoiceType::Enumeration::_true;
	m_protected_Default = Mp7JrsuserChoiceType::_true;
	m_protected_Exist = false;
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_CreationPreferences = Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr(); // Collection
	m_ClassificationPreferences = Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr(); // Collection
	m_SourcePreferences = Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr(); // Collection
	m_PreferenceCondition = Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr(); // Collection
	m_FilteringAndSearchPreferences = Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtMyPropInit.h

}

void Mp7JrsFilteringAndSearchPreferencesType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	// Mp7JrsFactory::DeleteObject(m_CreationPreferences);
	// Mp7JrsFactory::DeleteObject(m_ClassificationPreferences);
	// Mp7JrsFactory::DeleteObject(m_SourcePreferences);
	// Mp7JrsFactory::DeleteObject(m_PreferenceCondition);
	// Mp7JrsFactory::DeleteObject(m_FilteringAndSearchPreferences);
}

void Mp7JrsFilteringAndSearchPreferencesType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use FilteringAndSearchPreferencesTypePtr, since we
	// might need GetBase(), which isn't defined in IFilteringAndSearchPreferencesType
    const Mp7JrsPtr< Mp7JrsFilteringAndSearchPreferencesType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsFilteringAndSearchPreferencesType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	if (tmp->Existprotected())
	{
		this->Setprotected(tmp->Getprotected());
	}
	else
	{
		Invalidateprotected();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_CreationPreferences);
		this->SetCreationPreferences(Mp7JrsFactory::CloneObject(tmp->GetCreationPreferences()));
		// Mp7JrsFactory::DeleteObject(m_ClassificationPreferences);
		this->SetClassificationPreferences(Mp7JrsFactory::CloneObject(tmp->GetClassificationPreferences()));
		// Mp7JrsFactory::DeleteObject(m_SourcePreferences);
		this->SetSourcePreferences(Mp7JrsFactory::CloneObject(tmp->GetSourcePreferences()));
		// Mp7JrsFactory::DeleteObject(m_PreferenceCondition);
		this->SetPreferenceCondition(Mp7JrsFactory::CloneObject(tmp->GetPreferenceCondition()));
		// Mp7JrsFactory::DeleteObject(m_FilteringAndSearchPreferences);
		this->SetFilteringAndSearchPreferences(Mp7JrsFactory::CloneObject(tmp->GetFilteringAndSearchPreferences()));
}

Mp7JrsNodePtr Mp7JrsFilteringAndSearchPreferencesType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsFilteringAndSearchPreferencesType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsFilteringAndSearchPreferencesType::GetBase() const
{
	return m_Base;
}

Mp7JrsuserChoiceType::Enumeration Mp7JrsFilteringAndSearchPreferencesType::Getprotected() const
{
	if (this->Existprotected()) {
		return m_protected;
	} else {
		return m_protected_Default;
	}
}

bool Mp7JrsFilteringAndSearchPreferencesType::Existprotected() const
{
	return m_protected_Exist;
}
void Mp7JrsFilteringAndSearchPreferencesType::Setprotected(Mp7JrsuserChoiceType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::Setprotected().");
	}
    m_protected = item;
	m_protected_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::Invalidateprotected()
{
	m_protected_Exist = false;
}
Mp7JrspreferenceValuePtr Mp7JrsFilteringAndSearchPreferencesType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsFilteringAndSearchPreferencesType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsFilteringAndSearchPreferencesType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetpreferenceValue().");
	}
    m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr Mp7JrsFilteringAndSearchPreferencesType::GetCreationPreferences() const
{
	return m_CreationPreferences;
}

Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr Mp7JrsFilteringAndSearchPreferencesType::GetClassificationPreferences() const
{
	return m_ClassificationPreferences;
}

Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr Mp7JrsFilteringAndSearchPreferencesType::GetSourcePreferences() const
{
	return m_SourcePreferences;
}

Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr Mp7JrsFilteringAndSearchPreferencesType::GetPreferenceCondition() const
{
	return m_PreferenceCondition;
}

Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr Mp7JrsFilteringAndSearchPreferencesType::GetFilteringAndSearchPreferences() const
{
	return m_FilteringAndSearchPreferences;
}

void Mp7JrsFilteringAndSearchPreferencesType::SetCreationPreferences(const Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetCreationPreferences().");
	}
	if (m_CreationPreferences != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CreationPreferences);
		m_CreationPreferences = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CreationPreferences) m_CreationPreferences->SetParent(m_myself.getPointer());
		if(m_CreationPreferences != Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CreationPreferences->SetContentName(XMLString::transcode("CreationPreferences"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::SetClassificationPreferences(const Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetClassificationPreferences().");
	}
	if (m_ClassificationPreferences != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ClassificationPreferences);
		m_ClassificationPreferences = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ClassificationPreferences) m_ClassificationPreferences->SetParent(m_myself.getPointer());
		if(m_ClassificationPreferences != Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ClassificationPreferences->SetContentName(XMLString::transcode("ClassificationPreferences"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::SetSourcePreferences(const Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetSourcePreferences().");
	}
	if (m_SourcePreferences != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SourcePreferences);
		m_SourcePreferences = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SourcePreferences) m_SourcePreferences->SetParent(m_myself.getPointer());
		if(m_SourcePreferences != Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SourcePreferences->SetContentName(XMLString::transcode("SourcePreferences"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::SetPreferenceCondition(const Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetPreferenceCondition().");
	}
	if (m_PreferenceCondition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_PreferenceCondition);
		m_PreferenceCondition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PreferenceCondition) m_PreferenceCondition->SetParent(m_myself.getPointer());
		if(m_PreferenceCondition != Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PreferenceCondition->SetContentName(XMLString::transcode("PreferenceCondition"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::SetFilteringAndSearchPreferences(const Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetFilteringAndSearchPreferences().");
	}
	if (m_FilteringAndSearchPreferences != item)
	{
		// Mp7JrsFactory::DeleteObject(m_FilteringAndSearchPreferences);
		m_FilteringAndSearchPreferences = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_FilteringAndSearchPreferences) m_FilteringAndSearchPreferences->SetParent(m_myself.getPointer());
		if(m_FilteringAndSearchPreferences != Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_FilteringAndSearchPreferences->SetContentName(XMLString::transcode("FilteringAndSearchPreferences"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsFilteringAndSearchPreferencesType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsFilteringAndSearchPreferencesType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsFilteringAndSearchPreferencesType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsFilteringAndSearchPreferencesType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsFilteringAndSearchPreferencesType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsFilteringAndSearchPreferencesType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsFilteringAndSearchPreferencesType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsFilteringAndSearchPreferencesType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsFilteringAndSearchPreferencesType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsFilteringAndSearchPreferencesType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsFilteringAndSearchPreferencesType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsFilteringAndSearchPreferencesType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsFilteringAndSearchPreferencesType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsFilteringAndSearchPreferencesType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsFilteringAndSearchPreferencesType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFilteringAndSearchPreferencesType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsFilteringAndSearchPreferencesType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsFilteringAndSearchPreferencesType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFilteringAndSearchPreferencesType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsFilteringAndSearchPreferencesType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("CreationPreferences")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:CreationPreferences is item of type CreationPreferencesType
		// in element collection FilteringAndSearchPreferencesType_CreationPreferences_CollectionType
		
		context->Found = true;
		Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr coll = GetCreationPreferences();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateFilteringAndSearchPreferencesType_CreationPreferences_CollectionType;
				SetCreationPreferences(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationPreferencesType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationPreferencesPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ClassificationPreferences")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:ClassificationPreferences is item of type ClassificationPreferencesType
		// in element collection FilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType
		
		context->Found = true;
		Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr coll = GetClassificationPreferences();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType;
				SetClassificationPreferences(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SourcePreferences")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:SourcePreferences is item of type SourcePreferencesType
		// in element collection FilteringAndSearchPreferencesType_SourcePreferences_CollectionType
		
		context->Found = true;
		Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr coll = GetSourcePreferences();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateFilteringAndSearchPreferencesType_SourcePreferences_CollectionType;
				SetSourcePreferences(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SourcePreferencesType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSourcePreferencesPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PreferenceCondition")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:PreferenceCondition is item of type PreferenceConditionType
		// in element collection FilteringAndSearchPreferencesType_PreferenceCondition_CollectionType
		
		context->Found = true;
		Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr coll = GetPreferenceCondition();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType;
				SetPreferenceCondition(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PreferenceConditionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsPreferenceConditionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("FilteringAndSearchPreferences")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:FilteringAndSearchPreferences is item of type FilteringAndSearchPreferencesType
		// in element collection FilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType
		
		context->Found = true;
		Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr coll = GetFilteringAndSearchPreferences();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType;
				SetFilteringAndSearchPreferences(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:FilteringAndSearchPreferencesType")))) != empty)
			{
				// Is type allowed
				Mp7JrsFilteringAndSearchPreferencesPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for FilteringAndSearchPreferencesType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "FilteringAndSearchPreferencesType");
	}		
	
	return result;
}

XMLCh * Mp7JrsFilteringAndSearchPreferencesType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsFilteringAndSearchPreferencesType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsFilteringAndSearchPreferencesType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsFilteringAndSearchPreferencesType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsFilteringAndSearchPreferencesType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("FilteringAndSearchPreferencesType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_protected_Exist)
	{
	// Enumeration
	if(m_protected != Mp7JrsuserChoiceType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsuserChoiceType::ToText(m_protected);
		element->setAttributeNS(X(""), X("protected"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_CreationPreferences != Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_CreationPreferences->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_ClassificationPreferences != Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_ClassificationPreferences->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_SourcePreferences != Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SourcePreferences->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_PreferenceCondition != Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_PreferenceCondition->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_FilteringAndSearchPreferences != Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_FilteringAndSearchPreferences->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsFilteringAndSearchPreferencesType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("protected")))
	{
        this->Setprotected(Mp7JrsuserChoiceType::Parse(parent->getAttributeNS(X(""), X("protected"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("protected")))
	{
        this->Setprotected(Mp7JrsuserChoiceType::Parse(parent->getAttribute(X("protected"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("preferenceValue")))
	{
        // Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttributeNS(X(""), X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
        Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
        tmp->Parse(parent->getAttribute(X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("CreationPreferences"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("CreationPreferences")) == 0))
        {
            // Deserialize factory type
            Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_CreationPreferences_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetCreationPreferences(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("ClassificationPreferences"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("ClassificationPreferences")) == 0))
        {
            // Deserialize factory type
            Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetClassificationPreferences(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("SourcePreferences"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("SourcePreferences")) == 0))
        {
            // Deserialize factory type
            Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_SourcePreferences_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSourcePreferences(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("PreferenceCondition"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("PreferenceCondition")) == 0))
        {
            // Deserialize factory type
            Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetPreferenceCondition(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("FilteringAndSearchPreferences"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("FilteringAndSearchPreferences")) == 0))
        {
            // Deserialize factory type
            Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetFilteringAndSearchPreferences(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsFilteringAndSearchPreferencesType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("CreationPreferences")) == 0))
  {
    Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_CreationPreferences_CollectionType;
    this->SetCreationPreferences(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("ClassificationPreferences")) == 0))
  {
    Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType;
    this->SetClassificationPreferences(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("SourcePreferences")) == 0))
  {
    Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_SourcePreferences_CollectionType;
    this->SetSourcePreferences(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("PreferenceCondition")) == 0))
  {
    Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType;
    this->SetPreferenceCondition(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("FilteringAndSearchPreferences")) == 0))
  {
    Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr tmp = CreateFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType;
    this->SetFilteringAndSearchPreferences(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsFilteringAndSearchPreferencesType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCreationPreferences() != Mp7JrsNodePtr())
		result.Insert(GetCreationPreferences());
	if (GetClassificationPreferences() != Mp7JrsNodePtr())
		result.Insert(GetClassificationPreferences());
	if (GetSourcePreferences() != Mp7JrsNodePtr())
		result.Insert(GetSourcePreferences());
	if (GetPreferenceCondition() != Mp7JrsNodePtr())
		result.Insert(GetPreferenceCondition());
	if (GetFilteringAndSearchPreferences() != Mp7JrsNodePtr())
		result.Insert(GetFilteringAndSearchPreferences());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtMethodImpl.h


