 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_LocalType_ExtImplInclude.h



#include "Mp7JrsSummarySegmentGroupType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsHierarchicalSummaryType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsHierarchicalSummaryType_LocalType::IMp7JrsHierarchicalSummaryType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_LocalType_ExtPropInit.h

}

IMp7JrsHierarchicalSummaryType_LocalType::~IMp7JrsHierarchicalSummaryType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_LocalType_ExtPropCleanup.h

}

Mp7JrsHierarchicalSummaryType_LocalType::Mp7JrsHierarchicalSummaryType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsHierarchicalSummaryType_LocalType::~Mp7JrsHierarchicalSummaryType_LocalType()
{
	Cleanup();
}

void Mp7JrsHierarchicalSummaryType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_SummarySegmentGroup = Mp7JrsSummarySegmentGroupPtr(); // Class
	m_SummarySegmentGroupRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_LocalType_ExtMyPropInit.h

}

void Mp7JrsHierarchicalSummaryType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroup);
	// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupRef);
}

void Mp7JrsHierarchicalSummaryType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use HierarchicalSummaryType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IHierarchicalSummaryType_LocalType
    const Mp7JrsPtr< Mp7JrsHierarchicalSummaryType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroup);
		this->SetSummarySegmentGroup(Mp7JrsFactory::CloneObject(tmp->GetSummarySegmentGroup()));
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupRef);
		this->SetSummarySegmentGroupRef(Mp7JrsFactory::CloneObject(tmp->GetSummarySegmentGroupRef()));
}

Mp7JrsNodePtr Mp7JrsHierarchicalSummaryType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsHierarchicalSummaryType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSummarySegmentGroupPtr Mp7JrsHierarchicalSummaryType_LocalType::GetSummarySegmentGroup() const
{
	return m_SummarySegmentGroup;
}

Mp7JrsReferencePtr Mp7JrsHierarchicalSummaryType_LocalType::GetSummarySegmentGroupRef() const
{
	return m_SummarySegmentGroupRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsHierarchicalSummaryType_LocalType::SetSummarySegmentGroup(const Mp7JrsSummarySegmentGroupPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHierarchicalSummaryType_LocalType::SetSummarySegmentGroup().");
	}
	if (m_SummarySegmentGroup != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroup);
		m_SummarySegmentGroup = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SummarySegmentGroup) m_SummarySegmentGroup->SetParent(m_myself.getPointer());
		if (m_SummarySegmentGroup && m_SummarySegmentGroup->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SummarySegmentGroupType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SummarySegmentGroup->UseTypeAttribute = true;
		}
		if(m_SummarySegmentGroup != Mp7JrsSummarySegmentGroupPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SummarySegmentGroup->SetContentName(XMLString::transcode("SummarySegmentGroup"));
		}
	// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupRef);
	m_SummarySegmentGroupRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsHierarchicalSummaryType_LocalType::SetSummarySegmentGroupRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHierarchicalSummaryType_LocalType::SetSummarySegmentGroupRef().");
	}
	if (m_SummarySegmentGroupRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupRef);
		m_SummarySegmentGroupRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SummarySegmentGroupRef) m_SummarySegmentGroupRef->SetParent(m_myself.getPointer());
		if (m_SummarySegmentGroupRef && m_SummarySegmentGroupRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SummarySegmentGroupRef->UseTypeAttribute = true;
		}
		if(m_SummarySegmentGroupRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SummarySegmentGroupRef->SetContentName(XMLString::transcode("SummarySegmentGroupRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroup);
	m_SummarySegmentGroup = Mp7JrsSummarySegmentGroupPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: HierarchicalSummaryType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsHierarchicalSummaryType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsHierarchicalSummaryType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsHierarchicalSummaryType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsHierarchicalSummaryType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_SummarySegmentGroup != Mp7JrsSummarySegmentGroupPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SummarySegmentGroup->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SummarySegmentGroup"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SummarySegmentGroup->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_SummarySegmentGroupRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SummarySegmentGroupRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SummarySegmentGroupRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SummarySegmentGroupRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsHierarchicalSummaryType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentGroup"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SummarySegmentGroup")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSummarySegmentGroupType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSummarySegmentGroup(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentGroupRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SummarySegmentGroupRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSummarySegmentGroupRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsHierarchicalSummaryType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("SummarySegmentGroup")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSummarySegmentGroupType;
    }
    this->SetSummarySegmentGroup(child);
  }
  if (XMLString::compareString(elementname, X("SummarySegmentGroupRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetSummarySegmentGroupRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsHierarchicalSummaryType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSummarySegmentGroup() != Mp7JrsNodePtr())
		result.Insert(GetSummarySegmentGroup());
	if (GetSummarySegmentGroupRef() != Mp7JrsNodePtr())
		result.Insert(GetSummarySegmentGroupRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_LocalType_ExtMethodImpl.h


