 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrsInkMediaInformationType_InputDevice_LocalType.h"
#include "Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalType.h"
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionType.h"
#include "Mp7JrsInkMediaInformationType_Brush_CollectionType.h"
#include "Mp7JrsInkMediaInformationType_Param_CollectionType.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType2.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsInkMediaInformationType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:OverlaidMedia
#include "Mp7JrsInkMediaInformationType_Brush_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Brush
#include "Mp7JrsInkMediaInformationType_Param_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Param

#include <assert.h>
IMp7JrsInkMediaInformationType::IMp7JrsInkMediaInformationType()
{

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtPropInit.h

}

IMp7JrsInkMediaInformationType::~IMp7JrsInkMediaInformationType()
{
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtPropCleanup.h

}

Mp7JrsInkMediaInformationType::Mp7JrsInkMediaInformationType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsInkMediaInformationType::~Mp7JrsInkMediaInformationType()
{
	Cleanup();
}

void Mp7JrsInkMediaInformationType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_InputDevice = Mp7JrsInkMediaInformationType_InputDevice_LocalPtr(); // Class
	m_InputDevice_Exist = false;
	m_WritingFieldLayout = Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalPtr(); // Class
	m_WritingFieldLayout_Exist = false;
	m_OverlaidMedia = Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr(); // Collection
	m_Brush = Mp7JrsInkMediaInformationType_Brush_CollectionPtr(); // Collection
	m_Param = Mp7JrsInkMediaInformationType_Param_CollectionPtr(); // Collection
	m_Handedness = Mp7JrsInkMediaInformationType_Handedness_LocalType::UninitializedEnumeration; // Enumeration
	m_Handedness_Exist = false;
	m_Style = Mp7JrsInkMediaInformationType_Style_Local2Ptr(); // Class
	m_Style_Exist = false;


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtMyPropInit.h

}

void Mp7JrsInkMediaInformationType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_InputDevice);
	// Mp7JrsFactory::DeleteObject(m_WritingFieldLayout);
	// Mp7JrsFactory::DeleteObject(m_OverlaidMedia);
	// Mp7JrsFactory::DeleteObject(m_Brush);
	// Mp7JrsFactory::DeleteObject(m_Param);
	// Mp7JrsFactory::DeleteObject(m_Style);
}

void Mp7JrsInkMediaInformationType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use InkMediaInformationTypePtr, since we
	// might need GetBase(), which isn't defined in IInkMediaInformationType
    const Mp7JrsPtr< Mp7JrsInkMediaInformationType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsInkMediaInformationType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	if (tmp->IsValidInputDevice())
	{
		// Mp7JrsFactory::DeleteObject(m_InputDevice);
		this->SetInputDevice(Mp7JrsFactory::CloneObject(tmp->GetInputDevice()));
	}
	else
	{
		InvalidateInputDevice();
	}
	if (tmp->IsValidWritingFieldLayout())
	{
		// Mp7JrsFactory::DeleteObject(m_WritingFieldLayout);
		this->SetWritingFieldLayout(Mp7JrsFactory::CloneObject(tmp->GetWritingFieldLayout()));
	}
	else
	{
		InvalidateWritingFieldLayout();
	}
		// Mp7JrsFactory::DeleteObject(m_OverlaidMedia);
		this->SetOverlaidMedia(Mp7JrsFactory::CloneObject(tmp->GetOverlaidMedia()));
		// Mp7JrsFactory::DeleteObject(m_Brush);
		this->SetBrush(Mp7JrsFactory::CloneObject(tmp->GetBrush()));
		// Mp7JrsFactory::DeleteObject(m_Param);
		this->SetParam(Mp7JrsFactory::CloneObject(tmp->GetParam()));
	if (tmp->IsValidHandedness())
	{
		this->SetHandedness(tmp->GetHandedness());
	}
	else
	{
		InvalidateHandedness();
	}
	if (tmp->IsValidStyle())
	{
		// Mp7JrsFactory::DeleteObject(m_Style);
		this->SetStyle(Mp7JrsFactory::CloneObject(tmp->GetStyle()));
	}
	else
	{
		InvalidateStyle();
	}
}

Mp7JrsNodePtr Mp7JrsInkMediaInformationType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsInkMediaInformationType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsInkMediaInformationType::GetBase() const
{
	return m_Base;
}

Mp7JrsInkMediaInformationType_InputDevice_LocalPtr Mp7JrsInkMediaInformationType::GetInputDevice() const
{
	return m_InputDevice;
}

// Element is optional
bool Mp7JrsInkMediaInformationType::IsValidInputDevice() const
{
	return m_InputDevice_Exist;
}

Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalPtr Mp7JrsInkMediaInformationType::GetWritingFieldLayout() const
{
	return m_WritingFieldLayout;
}

// Element is optional
bool Mp7JrsInkMediaInformationType::IsValidWritingFieldLayout() const
{
	return m_WritingFieldLayout_Exist;
}

Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr Mp7JrsInkMediaInformationType::GetOverlaidMedia() const
{
	return m_OverlaidMedia;
}

Mp7JrsInkMediaInformationType_Brush_CollectionPtr Mp7JrsInkMediaInformationType::GetBrush() const
{
	return m_Brush;
}

Mp7JrsInkMediaInformationType_Param_CollectionPtr Mp7JrsInkMediaInformationType::GetParam() const
{
	return m_Param;
}

Mp7JrsInkMediaInformationType_Handedness_LocalType::Enumeration Mp7JrsInkMediaInformationType::GetHandedness() const
{
	return m_Handedness;
}

// Element is optional
bool Mp7JrsInkMediaInformationType::IsValidHandedness() const
{
	return m_Handedness_Exist;
}

Mp7JrsInkMediaInformationType_Style_Local2Ptr Mp7JrsInkMediaInformationType::GetStyle() const
{
	return m_Style;
}

// Element is optional
bool Mp7JrsInkMediaInformationType::IsValidStyle() const
{
	return m_Style_Exist;
}

void Mp7JrsInkMediaInformationType::SetInputDevice(const Mp7JrsInkMediaInformationType_InputDevice_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetInputDevice().");
	}
	if (m_InputDevice != item || m_InputDevice_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_InputDevice);
		m_InputDevice = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_InputDevice) m_InputDevice->SetParent(m_myself.getPointer());
		if (m_InputDevice && m_InputDevice->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_InputDevice_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_InputDevice->UseTypeAttribute = true;
		}
		m_InputDevice_Exist = true;
		if(m_InputDevice != Mp7JrsInkMediaInformationType_InputDevice_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_InputDevice->SetContentName(XMLString::transcode("InputDevice"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidateInputDevice()
{
	m_InputDevice_Exist = false;
}
void Mp7JrsInkMediaInformationType::SetWritingFieldLayout(const Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetWritingFieldLayout().");
	}
	if (m_WritingFieldLayout != item || m_WritingFieldLayout_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_WritingFieldLayout);
		m_WritingFieldLayout = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_WritingFieldLayout) m_WritingFieldLayout->SetParent(m_myself.getPointer());
		if (m_WritingFieldLayout && m_WritingFieldLayout->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_WritingFieldLayout_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_WritingFieldLayout->UseTypeAttribute = true;
		}
		m_WritingFieldLayout_Exist = true;
		if(m_WritingFieldLayout != Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_WritingFieldLayout->SetContentName(XMLString::transcode("WritingFieldLayout"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidateWritingFieldLayout()
{
	m_WritingFieldLayout_Exist = false;
}
void Mp7JrsInkMediaInformationType::SetOverlaidMedia(const Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetOverlaidMedia().");
	}
	if (m_OverlaidMedia != item)
	{
		// Mp7JrsFactory::DeleteObject(m_OverlaidMedia);
		m_OverlaidMedia = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_OverlaidMedia) m_OverlaidMedia->SetParent(m_myself.getPointer());
		if(m_OverlaidMedia != Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_OverlaidMedia->SetContentName(XMLString::transcode("OverlaidMedia"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::SetBrush(const Mp7JrsInkMediaInformationType_Brush_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetBrush().");
	}
	if (m_Brush != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Brush);
		m_Brush = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Brush) m_Brush->SetParent(m_myself.getPointer());
		if(m_Brush != Mp7JrsInkMediaInformationType_Brush_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Brush->SetContentName(XMLString::transcode("Brush"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::SetParam(const Mp7JrsInkMediaInformationType_Param_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetParam().");
	}
	if (m_Param != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Param);
		m_Param = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Param) m_Param->SetParent(m_myself.getPointer());
		if(m_Param != Mp7JrsInkMediaInformationType_Param_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Param->SetContentName(XMLString::transcode("Param"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::SetHandedness(Mp7JrsInkMediaInformationType_Handedness_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetHandedness().");
	}
	if (m_Handedness != item || m_Handedness_Exist == false)
	{
		// nothing to free here, hopefully
		m_Handedness = item;
		m_Handedness_Exist = true;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidateHandedness()
{
	m_Handedness_Exist = false;
}
void Mp7JrsInkMediaInformationType::SetStyle(const Mp7JrsInkMediaInformationType_Style_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetStyle().");
	}
	if (m_Style != item || m_Style_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Style);
		m_Style = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Style) m_Style->SetParent(m_myself.getPointer());
		if (m_Style && m_Style->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_Style_LocalType2"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Style->UseTypeAttribute = true;
		}
		m_Style_Exist = true;
		if(m_Style != Mp7JrsInkMediaInformationType_Style_Local2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Style->SetContentName(XMLString::transcode("Style"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidateStyle()
{
	m_Style_Exist = false;
}
XMLCh * Mp7JrsInkMediaInformationType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsInkMediaInformationType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsInkMediaInformationType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsInkMediaInformationType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsInkMediaInformationType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsInkMediaInformationType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsInkMediaInformationType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsInkMediaInformationType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsInkMediaInformationType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsInkMediaInformationType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsInkMediaInformationType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsInkMediaInformationType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsInkMediaInformationType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsInkMediaInformationType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsInkMediaInformationType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsInkMediaInformationType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsInkMediaInformationType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsInkMediaInformationType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("InputDevice")) == 0)
	{
		// InputDevice is simple element InkMediaInformationType_InputDevice_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetInputDevice()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_InputDevice_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsInkMediaInformationType_InputDevice_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetInputDevice(p, client);
					if((p = GetInputDevice()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("WritingFieldLayout")) == 0)
	{
		// WritingFieldLayout is simple element InkMediaInformationType_WritingFieldLayout_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetWritingFieldLayout()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_WritingFieldLayout_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetWritingFieldLayout(p, client);
					if((p = GetWritingFieldLayout()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("OverlaidMedia")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:OverlaidMedia is item of type InkMediaInformationType_OverlaidMedia_LocalType
		// in element collection InkMediaInformationType_OverlaidMedia_CollectionType
		
		context->Found = true;
		Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr coll = GetOverlaidMedia();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateInkMediaInformationType_OverlaidMedia_CollectionType;
				SetOverlaidMedia(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_OverlaidMedia_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsInkMediaInformationType_OverlaidMedia_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Brush")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Brush is item of type InkMediaInformationType_Brush_LocalType
		// in element collection InkMediaInformationType_Brush_CollectionType
		
		context->Found = true;
		Mp7JrsInkMediaInformationType_Brush_CollectionPtr coll = GetBrush();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateInkMediaInformationType_Brush_CollectionType;
				SetBrush(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_Brush_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsInkMediaInformationType_Brush_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Param")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Param is item of type InkMediaInformationType_Param_LocalType
		// in element collection InkMediaInformationType_Param_CollectionType
		
		context->Found = true;
		Mp7JrsInkMediaInformationType_Param_CollectionPtr coll = GetParam();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateInkMediaInformationType_Param_CollectionType;
				SetParam(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_Param_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsInkMediaInformationType_Param_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Style")) == 0)
	{
		// Style is simple element InkMediaInformationType_Style_LocalType2
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetStyle()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InkMediaInformationType_Style_LocalType2")))) != empty)
			{
				// Is type allowed
				Mp7JrsInkMediaInformationType_Style_Local2Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetStyle(p, client);
					if((p = GetStyle()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for InkMediaInformationType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "InkMediaInformationType");
	}		
	
	return result;
}

XMLCh * Mp7JrsInkMediaInformationType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsInkMediaInformationType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsInkMediaInformationType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsInkMediaInformationType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsInkMediaInformationType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("InkMediaInformationType"));
	// Element serialization:
	// Class
	
	if (m_InputDevice != Mp7JrsInkMediaInformationType_InputDevice_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_InputDevice->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("InputDevice"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_InputDevice->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_WritingFieldLayout != Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_WritingFieldLayout->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("WritingFieldLayout"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_WritingFieldLayout->Serialize(doc, element, &elem);
	}
	if (m_OverlaidMedia != Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_OverlaidMedia->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Brush != Mp7JrsInkMediaInformationType_Brush_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Brush->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Param != Mp7JrsInkMediaInformationType_Param_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Param->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if(m_Handedness != Mp7JrsInkMediaInformationType_Handedness_LocalType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsInkMediaInformationType_Handedness_LocalType::ToText(m_Handedness);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("Handedness"), true);
		XMLString::release(&tmp);
	}
	// Class
	
	if (m_Style != Mp7JrsInkMediaInformationType_Style_Local2Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Style->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Style"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Style->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsInkMediaInformationType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("InputDevice"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("InputDevice")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateInkMediaInformationType_InputDevice_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetInputDevice(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("WritingFieldLayout"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("WritingFieldLayout")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateInkMediaInformationType_WritingFieldLayout_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetWritingFieldLayout(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("OverlaidMedia"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("OverlaidMedia")) == 0))
        {
            // Deserialize factory type
            Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr tmp = CreateInkMediaInformationType_OverlaidMedia_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetOverlaidMedia(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Brush"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Brush")) == 0))
        {
            // Deserialize factory type
            Mp7JrsInkMediaInformationType_Brush_CollectionPtr tmp = CreateInkMediaInformationType_Brush_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetBrush(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Param"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Param")) == 0))
        {
            // Deserialize factory type
            Mp7JrsInkMediaInformationType_Param_CollectionPtr tmp = CreateInkMediaInformationType_Param_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetParam(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("Handedness"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Handedness")) == 0))
        {
            Mp7JrsInkMediaInformationType_Handedness_LocalType::Enumeration tmp = Mp7JrsInkMediaInformationType_Handedness_LocalType::Parse(Mp7JrsUtil::GetElementText(parent));
            if(tmp == Mp7JrsInkMediaInformationType_Handedness_LocalType::UninitializedEnumeration)
            {
                    return false;
            }
            this->SetHandedness(tmp);
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Style"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Style")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateInkMediaInformationType_Style_LocalType2;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetStyle(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsInkMediaInformationType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("InputDevice")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateInkMediaInformationType_InputDevice_LocalType;
    }
    this->SetInputDevice(child);
  }
  if (XMLString::compareString(elementname, X("WritingFieldLayout")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateInkMediaInformationType_WritingFieldLayout_LocalType;
    }
    this->SetWritingFieldLayout(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("OverlaidMedia")) == 0))
  {
    Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr tmp = CreateInkMediaInformationType_OverlaidMedia_CollectionType;
    this->SetOverlaidMedia(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Brush")) == 0))
  {
    Mp7JrsInkMediaInformationType_Brush_CollectionPtr tmp = CreateInkMediaInformationType_Brush_CollectionType;
    this->SetBrush(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Param")) == 0))
  {
    Mp7JrsInkMediaInformationType_Param_CollectionPtr tmp = CreateInkMediaInformationType_Param_CollectionType;
    this->SetParam(tmp);
    child = tmp;
  }
  if (XMLString::compareString(elementname, X("Style")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateInkMediaInformationType_Style_LocalType2;
    }
    this->SetStyle(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsInkMediaInformationType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetInputDevice() != Mp7JrsNodePtr())
		result.Insert(GetInputDevice());
	if (GetWritingFieldLayout() != Mp7JrsNodePtr())
		result.Insert(GetWritingFieldLayout());
	if (GetOverlaidMedia() != Mp7JrsNodePtr())
		result.Insert(GetOverlaidMedia());
	if (GetBrush() != Mp7JrsNodePtr())
		result.Insert(GetBrush());
	if (GetParam() != Mp7JrsNodePtr())
		result.Insert(GetParam());
	if (GetStyle() != Mp7JrsNodePtr())
		result.Insert(GetStyle());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_ExtMethodImpl.h


