 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtImplInclude.h



#include "Mp7JrsTermUseType.h"
#include "Mp7JrsInkMediaInformationType_InputDevice_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsInkMediaInformationType_InputDevice_LocalType::IMp7JrsInkMediaInformationType_InputDevice_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtPropInit.h

}

IMp7JrsInkMediaInformationType_InputDevice_LocalType::~IMp7JrsInkMediaInformationType_InputDevice_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtPropCleanup.h

}

Mp7JrsInkMediaInformationType_InputDevice_LocalType::Mp7JrsInkMediaInformationType_InputDevice_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsInkMediaInformationType_InputDevice_LocalType::~Mp7JrsInkMediaInformationType_InputDevice_LocalType()
{
	Cleanup();
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::Init()
{

	// Init attributes
	m_xWidth = 0; // Value
	m_xWidth_Exist = false;
	m_yWidth = 0; // Value
	m_yWidth_Exist = false;
	m_resolutionX = 0; // Value
	m_resolutionX_Exist = false;
	m_resolutionY = 0; // Value
	m_resolutionY_Exist = false;
	m_resolutionZ = 0; // Value
	m_resolutionZ_Exist = false;
	m_resolutionP = 0; // Value
	m_resolutionP_Exist = false;
	m_resolutionS = 0; // Value
	m_resolutionS_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Device = Mp7JrsTermUsePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMyPropInit.h

}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Device);
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use InkMediaInformationType_InputDevice_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IInkMediaInformationType_InputDevice_LocalType
    const Mp7JrsPtr< Mp7JrsInkMediaInformationType_InputDevice_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if (tmp->ExistxWidth())
	{
		this->SetxWidth(tmp->GetxWidth());
	}
	else
	{
		InvalidatexWidth();
	}
	}
	{
	if (tmp->ExistyWidth())
	{
		this->SetyWidth(tmp->GetyWidth());
	}
	else
	{
		InvalidateyWidth();
	}
	}
	{
	if (tmp->ExistresolutionX())
	{
		this->SetresolutionX(tmp->GetresolutionX());
	}
	else
	{
		InvalidateresolutionX();
	}
	}
	{
	if (tmp->ExistresolutionY())
	{
		this->SetresolutionY(tmp->GetresolutionY());
	}
	else
	{
		InvalidateresolutionY();
	}
	}
	{
	if (tmp->ExistresolutionZ())
	{
		this->SetresolutionZ(tmp->GetresolutionZ());
	}
	else
	{
		InvalidateresolutionZ();
	}
	}
	{
	if (tmp->ExistresolutionP())
	{
		this->SetresolutionP(tmp->GetresolutionP());
	}
	else
	{
		InvalidateresolutionP();
	}
	}
	{
	if (tmp->ExistresolutionS())
	{
		this->SetresolutionS(tmp->GetresolutionS());
	}
	else
	{
		InvalidateresolutionS();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_Device);
		this->SetDevice(Mp7JrsFactory::CloneObject(tmp->GetDevice()));
}

Mp7JrsNodePtr Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


unsigned Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetxWidth() const
{
	return m_xWidth;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ExistxWidth() const
{
	return m_xWidth_Exist;
}
void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetxWidth(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetxWidth().");
	}
    m_xWidth = item;
	m_xWidth_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::InvalidatexWidth()
{
	m_xWidth_Exist = false;
}
unsigned Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetyWidth() const
{
	return m_yWidth;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ExistyWidth() const
{
	return m_yWidth_Exist;
}
void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetyWidth(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetyWidth().");
	}
    m_yWidth = item;
	m_yWidth_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::InvalidateyWidth()
{
	m_yWidth_Exist = false;
}
unsigned Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetresolutionX() const
{
	return m_resolutionX;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ExistresolutionX() const
{
	return m_resolutionX_Exist;
}
void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionX(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionX().");
	}
    m_resolutionX = item;
	m_resolutionX_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::InvalidateresolutionX()
{
	m_resolutionX_Exist = false;
}
unsigned Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetresolutionY() const
{
	return m_resolutionY;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ExistresolutionY() const
{
	return m_resolutionY_Exist;
}
void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionY(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionY().");
	}
    m_resolutionY = item;
	m_resolutionY_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::InvalidateresolutionY()
{
	m_resolutionY_Exist = false;
}
unsigned Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetresolutionZ() const
{
	return m_resolutionZ;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ExistresolutionZ() const
{
	return m_resolutionZ_Exist;
}
void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionZ(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionZ().");
	}
    m_resolutionZ = item;
	m_resolutionZ_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::InvalidateresolutionZ()
{
	m_resolutionZ_Exist = false;
}
int Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetresolutionP() const
{
	return m_resolutionP;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ExistresolutionP() const
{
	return m_resolutionP_Exist;
}
void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionP(int item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionP().");
	}
    m_resolutionP = item;
	m_resolutionP_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::InvalidateresolutionP()
{
	m_resolutionP_Exist = false;
}
int Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetresolutionS() const
{
	return m_resolutionS;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ExistresolutionS() const
{
	return m_resolutionS_Exist;
}
void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionS(int item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetresolutionS().");
	}
    m_resolutionS = item;
	m_resolutionS_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::InvalidateresolutionS()
{
	m_resolutionS_Exist = false;
}
Mp7JrsTermUsePtr Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetDevice() const
{
	return m_Device;
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetDevice(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_InputDevice_LocalType::SetDevice().");
	}
	if (m_Device != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Device);
		m_Device = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Device) m_Device->SetParent(m_myself.getPointer());
		if (m_Device && m_Device->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Device->UseTypeAttribute = true;
		}
		if(m_Device != Mp7JrsTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Device->SetContentName(XMLString::transcode("Device"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Device")) == 0)
	{
		// Device is simple element TermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetDevice()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetDevice(p, client);
					if((p = GetDevice()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for InkMediaInformationType_InputDevice_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "InkMediaInformationType_InputDevice_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsInkMediaInformationType_InputDevice_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsInkMediaInformationType_InputDevice_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsInkMediaInformationType_InputDevice_LocalType::ContentToString() const
{
	// Mp7JrsInkMediaInformationType_InputDevice_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsInkMediaInformationType_InputDevice_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("InkMediaInformationType_InputDevice_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_xWidth_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_xWidth);
		element->setAttributeNS(X(""), X("xWidth"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_yWidth_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_yWidth);
		element->setAttributeNS(X(""), X("yWidth"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_resolutionX_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_resolutionX);
		element->setAttributeNS(X(""), X("resolutionX"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_resolutionY_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_resolutionY);
		element->setAttributeNS(X(""), X("resolutionY"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_resolutionZ_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_resolutionZ);
		element->setAttributeNS(X(""), X("resolutionZ"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_resolutionP_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_resolutionP);
		element->setAttributeNS(X(""), X("resolutionP"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_resolutionS_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_resolutionS);
		element->setAttributeNS(X(""), X("resolutionS"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_Device != Mp7JrsTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Device->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Device"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Device->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsInkMediaInformationType_InputDevice_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("xWidth")))
	{
        // deserialize value type
        this->SetxWidth(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("xWidth"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("xWidth")))
	{
        // deserialize value type
        this->SetxWidth(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("xWidth"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("yWidth")))
	{
        // deserialize value type
        this->SetyWidth(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("yWidth"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("yWidth")))
	{
        // deserialize value type
        this->SetyWidth(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("yWidth"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("resolutionX")))
	{
        // deserialize value type
        this->SetresolutionX(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("resolutionX"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("resolutionX")))
	{
        // deserialize value type
        this->SetresolutionX(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("resolutionX"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("resolutionY")))
	{
        // deserialize value type
        this->SetresolutionY(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("resolutionY"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("resolutionY")))
	{
        // deserialize value type
        this->SetresolutionY(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("resolutionY"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("resolutionZ")))
	{
        // deserialize value type
        this->SetresolutionZ(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("resolutionZ"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("resolutionZ")))
	{
        // deserialize value type
        this->SetresolutionZ(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("resolutionZ"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("resolutionP")))
	{
        // deserialize value type
        this->SetresolutionP(Mp7JrsConvert::TextToInt(parent->getAttributeNS(X(""), X("resolutionP"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("resolutionP")))
	{
        // deserialize value type
        this->SetresolutionP(Mp7JrsConvert::TextToInt(parent->getAttribute(X("resolutionP"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("resolutionS")))
	{
        // deserialize value type
        this->SetresolutionS(Mp7JrsConvert::TextToInt(parent->getAttributeNS(X(""), X("resolutionS"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("resolutionS")))
	{
        // deserialize value type
        this->SetresolutionS(Mp7JrsConvert::TextToInt(parent->getAttribute(X("resolutionS"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Device"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Device")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetDevice(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsInkMediaInformationType_InputDevice_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Device")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTermUseType;
    }
    this->SetDevice(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsInkMediaInformationType_InputDevice_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetDevice() != Mp7JrsNodePtr())
		result.Insert(GetDevice());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMethodImpl.h


