 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtImplInclude.h



#include "Mp7JrsintegerVector.h"
#include "Mp7Jrsdim_LocalType.h"
#include "Mp7JrsIntegerDiagonalMatrixType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsIntegerDiagonalMatrixType::IMp7JrsIntegerDiagonalMatrixType()
{

// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtPropInit.h

}

IMp7JrsIntegerDiagonalMatrixType::~IMp7JrsIntegerDiagonalMatrixType()
{
// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtPropCleanup.h

}

Mp7JrsIntegerDiagonalMatrixType::Mp7JrsIntegerDiagonalMatrixType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsIntegerDiagonalMatrixType::~Mp7JrsIntegerDiagonalMatrixType()
{
	Cleanup();
}

void Mp7JrsIntegerDiagonalMatrixType::Init()
{
	// Init base
	m_Base = CreateintegerVector;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_dim = Mp7Jrsdim_LocalPtr(); // Create emtpy class ptr



// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtMyPropInit.h

}

void Mp7JrsIntegerDiagonalMatrixType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_dim);
}

void Mp7JrsIntegerDiagonalMatrixType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use IntegerDiagonalMatrixTypePtr, since we
	// might need GetBase(), which isn't defined in IIntegerDiagonalMatrixType
    const Mp7JrsPtr< Mp7JrsIntegerDiagonalMatrixType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsintegerVectorPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsIntegerDiagonalMatrixType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_dim);
		this->Setdim(Mp7JrsFactory::CloneObject(tmp->Getdim()));
	}
}

Mp7JrsNodePtr Mp7JrsIntegerDiagonalMatrixType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsIntegerDiagonalMatrixType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsintegerVector > Mp7JrsIntegerDiagonalMatrixType::GetBase() const
{
	return m_Base;
}

Mp7JrsPtr< Mp7JrsintegerVector > Mp7JrsIntegerDiagonalMatrixType::GetBaseCollection() const
{
	return GetBase();
}

void Mp7JrsIntegerDiagonalMatrixType::Initialize(unsigned int maxElems)
{
	GetBase()->Initialize(maxElems);
}

void Mp7JrsIntegerDiagonalMatrixType::addElement(const int &toAdd, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntegerDiagonalMatrixType::addElement().");
	}
	GetBase()->addElement(toAdd);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntegerDiagonalMatrixType::setElementAt(const int &toSet, unsigned int setAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntegerDiagonalMatrixType::setElementAt().");
	}
	GetBase()->setElementAt(toSet, setAt);
	Mp7JrsClientManager::SendUpdateNotification(
	m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
	client, m_myself.getPointer());
}

void Mp7JrsIntegerDiagonalMatrixType::insertElementAt(const int &toInsert, unsigned int insertAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntegerDiagonalMatrixType::insertElementAt().");
	}
	GetBase()->insertElementAt(toInsert, insertAt);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntegerDiagonalMatrixType::removeAllElements(Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntegerDiagonalMatrixType::removeAllElements().");
	}
	GetBase()->removeAllElements();
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntegerDiagonalMatrixType::removeElementAt(unsigned int removeAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntegerDiagonalMatrixType::removeElementAt().");
	}
	GetBase()->removeElementAt(removeAt);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

bool Mp7JrsIntegerDiagonalMatrixType::containsElement(const int &toCheck)
{
	return GetBase()->containsElement(toCheck);
}

unsigned int Mp7JrsIntegerDiagonalMatrixType::curCapacity() const
{
	return GetBase()->curCapacity();
}

const int Mp7JrsIntegerDiagonalMatrixType::elementAt(unsigned int getAt) const
{
	return GetBase()->elementAt(getAt);
}

int Mp7JrsIntegerDiagonalMatrixType::elementAt(unsigned int getAt)
{
	return GetBase()->elementAt(getAt);
}


unsigned int Mp7JrsIntegerDiagonalMatrixType::size() const
{
	return GetBase()->size();
}

void Mp7JrsIntegerDiagonalMatrixType::ensureExtraCapacity(unsigned int length)
{
	GetBase()->ensureExtraCapacity(length);
}

int Mp7JrsIntegerDiagonalMatrixType::elementIndexOf(const int &toCheck) const
{
	return GetBase()->elementIndexOf(toCheck);
}

Mp7Jrsdim_LocalPtr Mp7JrsIntegerDiagonalMatrixType::Getdim() const
{
	return m_dim;
}

void Mp7JrsIntegerDiagonalMatrixType::Setdim(const Mp7Jrsdim_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntegerDiagonalMatrixType::Setdim().");
	}
    m_dim = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_dim) m_dim->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsIntegerDiagonalMatrixType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for IntegerDiagonalMatrixType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "IntegerDiagonalMatrixType");
	}
	
	return result;
}

XMLCh * Mp7JrsIntegerDiagonalMatrixType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsIntegerDiagonalMatrixType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsIntegerDiagonalMatrixType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsIntegerDiagonalMatrixType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsIntegerDiagonalMatrixType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("IntegerDiagonalMatrixType"));
    // Attribute Serialization:
	// Class
	if (m_dim != Mp7Jrsdim_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_dim->ToText();
		element->setAttributeNS(X("urn:mpeg:mpeg7:schema:2004"), X("dim"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:

}

bool Mp7JrsIntegerDiagonalMatrixType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X("urn:mpeg:mpeg7:schema:2004"), X("dim")))
	{
        // Deserialize class type
		Mp7Jrsdim_LocalPtr tmp = Createdim_LocalType;
		tmp->Parse(parent->getAttributeNS(X("urn:mpeg:mpeg7:schema:2004"), X("dim")));
        this->Setdim(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("dim")))
	{
		// Deserialize class type
        Mp7Jrsdim_LocalPtr tmp = Createdim_LocalType;
        tmp->Parse(parent->getAttribute(X("dim")));
        this->Setdim(tmp);
        * current = parent;
    }

  // Extensionbase is Mp7JrsintegerVector
  // Deserialize cce factory type
  if(m_Base->Deserialize(doc, parent, current))
  {
    found = true;
    parent = * current;
    parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
  }
// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsIntegerDiagonalMatrixType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsIntegerDiagonalMatrixType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsIntegerDiagonalMatrixType_ExtMethodImpl.h


