 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrsLinguisticEntityType_start_LocalType.h"
#include "Mp7JrsLinguisticEntityType_length_LocalType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrstermReferenceListType.h"
#include "Mp7JrsLinguisticEntityType_edit_LocalType.h"
#include "Mp7JrsLinguisticEntityType_MediaLocator_CollectionType.h"
#include "Mp7JrsLinguisticEntityType_Relation_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsLinguisticEntityType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsMediaLocatorType.h" // Element collection urn:mpeg:mpeg7:schema:2004:MediaLocator
#include "Mp7JrsGeneralRelationType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Relation

#include <assert.h>
IMp7JrsLinguisticEntityType::IMp7JrsLinguisticEntityType()
{

// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtPropInit.h

}

IMp7JrsLinguisticEntityType::~IMp7JrsLinguisticEntityType()
{
// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtPropCleanup.h

}

Mp7JrsLinguisticEntityType::Mp7JrsLinguisticEntityType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsLinguisticEntityType::~Mp7JrsLinguisticEntityType()
{
	Cleanup();
}

void Mp7JrsLinguisticEntityType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_lang = NULL; // String
	m_lang_Exist = false;
	m_start = Mp7JrsLinguisticEntityType_start_LocalPtr(); // Create emtpy class ptr
	m_start_Exist = false;
	m_length = Mp7JrsLinguisticEntityType_length_LocalPtr(); // Create emtpy class ptr
	m_length_Exist = false;
	m_type = Mp7JrstermReferencePtr(); // Create emtpy class ptr
	m_type_Exist = false;
	m_depend = Mp7JrstermReferencePtr(); // Create emtpy class ptr
	m_depend_Exist = false;
	m_equal = Mp7JrstermReferenceListPtr(); // Collection
	m_equal_Exist = false;
	m_semantics = Mp7JrstermReferenceListPtr(); // Collection
	m_semantics_Exist = false;
	m_compoundSemantics = Mp7JrstermReferenceListPtr(); // Collection
	m_compoundSemantics_Exist = false;
	m_operator = Mp7JrstermReferenceListPtr(); // Collection
	m_operator_Exist = false;
	m_copy = Mp7JrstermReferenceListPtr(); // Collection
	m_copy_Exist = false;
	m_noCopy = Mp7JrstermReferenceListPtr(); // Collection
	m_noCopy_Exist = false;
	m_substitute = Mp7JrstermReferencePtr(); // Create emtpy class ptr
	m_substitute_Exist = false;
	m_inScope = Mp7JrstermReferencePtr(); // Create emtpy class ptr
	m_inScope_Exist = false;
	m_edit = Mp7JrsLinguisticEntityType_edit_LocalPtr(); // Pattern
	m_edit_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_MediaLocator = Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr(); // Collection
	m_Relation = Mp7JrsLinguisticEntityType_Relation_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtMyPropInit.h

}

void Mp7JrsLinguisticEntityType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	XMLString::release(&m_lang);
	// Mp7JrsFactory::DeleteObject(m_start);
	// Mp7JrsFactory::DeleteObject(m_length);
	// Mp7JrsFactory::DeleteObject(m_type);
	// Mp7JrsFactory::DeleteObject(m_depend);
	// Mp7JrsFactory::DeleteObject(m_equal);
	// Mp7JrsFactory::DeleteObject(m_semantics);
	// Mp7JrsFactory::DeleteObject(m_compoundSemantics);
	// Mp7JrsFactory::DeleteObject(m_operator);
	// Mp7JrsFactory::DeleteObject(m_copy);
	// Mp7JrsFactory::DeleteObject(m_noCopy);
	// Mp7JrsFactory::DeleteObject(m_substitute);
	// Mp7JrsFactory::DeleteObject(m_inScope);
	// Mp7JrsFactory::DeleteObject(m_edit); 
	// Mp7JrsFactory::DeleteObject(m_MediaLocator);
	// Mp7JrsFactory::DeleteObject(m_Relation);
}

void Mp7JrsLinguisticEntityType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use LinguisticEntityTypePtr, since we
	// might need GetBase(), which isn't defined in ILinguisticEntityType
    const Mp7JrsPtr< Mp7JrsLinguisticEntityType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsLinguisticEntityType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	XMLString::release(&m_lang);
	if (tmp->Existlang())
	{
		this->Setlang(XMLString::replicate(tmp->Getlang()));
	}
	else
	{
		Invalidatelang();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_start);
	if (tmp->Existstart())
	{
		this->Setstart(Mp7JrsFactory::CloneObject(tmp->Getstart()));
	}
	else
	{
		Invalidatestart();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_length);
	if (tmp->Existlength())
	{
		this->Setlength(Mp7JrsFactory::CloneObject(tmp->Getlength()));
	}
	else
	{
		Invalidatelength();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_type);
	if (tmp->Existtype())
	{
		this->Settype(Mp7JrsFactory::CloneObject(tmp->Gettype()));
	}
	else
	{
		Invalidatetype();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_depend);
	if (tmp->Existdepend())
	{
		this->Setdepend(Mp7JrsFactory::CloneObject(tmp->Getdepend()));
	}
	else
	{
		Invalidatedepend();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_equal);
	if (tmp->Existequal())
	{
		this->Setequal(Mp7JrsFactory::CloneObject(tmp->Getequal()));
	}
	else
	{
		Invalidateequal();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_semantics);
	if (tmp->Existsemantics())
	{
		this->Setsemantics(Mp7JrsFactory::CloneObject(tmp->Getsemantics()));
	}
	else
	{
		Invalidatesemantics();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_compoundSemantics);
	if (tmp->ExistcompoundSemantics())
	{
		this->SetcompoundSemantics(Mp7JrsFactory::CloneObject(tmp->GetcompoundSemantics()));
	}
	else
	{
		InvalidatecompoundSemantics();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_operator);
	if (tmp->Existoperator())
	{
		this->Setoperator(Mp7JrsFactory::CloneObject(tmp->Getoperator()));
	}
	else
	{
		Invalidateoperator();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_copy);
	if (tmp->Existcopy())
	{
		this->Setcopy(Mp7JrsFactory::CloneObject(tmp->Getcopy()));
	}
	else
	{
		Invalidatecopy();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_noCopy);
	if (tmp->ExistnoCopy())
	{
		this->SetnoCopy(Mp7JrsFactory::CloneObject(tmp->GetnoCopy()));
	}
	else
	{
		InvalidatenoCopy();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_substitute);
	if (tmp->Existsubstitute())
	{
		this->Setsubstitute(Mp7JrsFactory::CloneObject(tmp->Getsubstitute()));
	}
	else
	{
		Invalidatesubstitute();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_inScope);
	if (tmp->ExistinScope())
	{
		this->SetinScope(Mp7JrsFactory::CloneObject(tmp->GetinScope()));
	}
	else
	{
		InvalidateinScope();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_edit); 
	if (tmp->Existedit())
	{
		this->Setedit(Mp7JrsFactory::CloneObject(tmp->Getedit()));
	}
	else
	{
		Invalidateedit();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_MediaLocator);
		this->SetMediaLocator(Mp7JrsFactory::CloneObject(tmp->GetMediaLocator()));
		// Mp7JrsFactory::DeleteObject(m_Relation);
		this->SetRelation(Mp7JrsFactory::CloneObject(tmp->GetRelation()));
}

Mp7JrsNodePtr Mp7JrsLinguisticEntityType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsLinguisticEntityType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsLinguisticEntityType::GetBase() const
{
	return m_Base;
}

XMLCh * Mp7JrsLinguisticEntityType::Getlang() const
{
	return m_lang;
}

bool Mp7JrsLinguisticEntityType::Existlang() const
{
	return m_lang_Exist;
}
void Mp7JrsLinguisticEntityType::Setlang(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setlang().");
	}
    m_lang = item;
	m_lang_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatelang()
{
	m_lang_Exist = false;
}
Mp7JrsLinguisticEntityType_start_LocalPtr Mp7JrsLinguisticEntityType::Getstart() const
{
	return m_start;
}

bool Mp7JrsLinguisticEntityType::Existstart() const
{
	return m_start_Exist;
}
void Mp7JrsLinguisticEntityType::Setstart(const Mp7JrsLinguisticEntityType_start_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setstart().");
	}
    m_start = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_start) m_start->SetParent(m_myself.getPointer());
	m_start_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatestart()
{
	m_start_Exist = false;
}
Mp7JrsLinguisticEntityType_length_LocalPtr Mp7JrsLinguisticEntityType::Getlength() const
{
	return m_length;
}

bool Mp7JrsLinguisticEntityType::Existlength() const
{
	return m_length_Exist;
}
void Mp7JrsLinguisticEntityType::Setlength(const Mp7JrsLinguisticEntityType_length_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setlength().");
	}
    m_length = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_length) m_length->SetParent(m_myself.getPointer());
	m_length_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatelength()
{
	m_length_Exist = false;
}
Mp7JrstermReferencePtr Mp7JrsLinguisticEntityType::Gettype() const
{
	return m_type;
}

bool Mp7JrsLinguisticEntityType::Existtype() const
{
	return m_type_Exist;
}
void Mp7JrsLinguisticEntityType::Settype(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Settype().");
	}
    m_type = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_type) m_type->SetParent(m_myself.getPointer());
	m_type_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatetype()
{
	m_type_Exist = false;
}
Mp7JrstermReferencePtr Mp7JrsLinguisticEntityType::Getdepend() const
{
	return m_depend;
}

bool Mp7JrsLinguisticEntityType::Existdepend() const
{
	return m_depend_Exist;
}
void Mp7JrsLinguisticEntityType::Setdepend(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setdepend().");
	}
    m_depend = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_depend) m_depend->SetParent(m_myself.getPointer());
	m_depend_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatedepend()
{
	m_depend_Exist = false;
}
Mp7JrstermReferenceListPtr Mp7JrsLinguisticEntityType::Getequal() const
{
	return m_equal;
}

bool Mp7JrsLinguisticEntityType::Existequal() const
{
	return m_equal_Exist;
}
void Mp7JrsLinguisticEntityType::Setequal(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setequal().");
	}
    m_equal = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_equal) m_equal->SetParent(m_myself.getPointer());
	m_equal_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidateequal()
{
	m_equal_Exist = false;
}
Mp7JrstermReferenceListPtr Mp7JrsLinguisticEntityType::Getsemantics() const
{
	return m_semantics;
}

bool Mp7JrsLinguisticEntityType::Existsemantics() const
{
	return m_semantics_Exist;
}
void Mp7JrsLinguisticEntityType::Setsemantics(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setsemantics().");
	}
    m_semantics = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_semantics) m_semantics->SetParent(m_myself.getPointer());
	m_semantics_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatesemantics()
{
	m_semantics_Exist = false;
}
Mp7JrstermReferenceListPtr Mp7JrsLinguisticEntityType::GetcompoundSemantics() const
{
	return m_compoundSemantics;
}

bool Mp7JrsLinguisticEntityType::ExistcompoundSemantics() const
{
	return m_compoundSemantics_Exist;
}
void Mp7JrsLinguisticEntityType::SetcompoundSemantics(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetcompoundSemantics().");
	}
    m_compoundSemantics = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_compoundSemantics) m_compoundSemantics->SetParent(m_myself.getPointer());
	m_compoundSemantics_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::InvalidatecompoundSemantics()
{
	m_compoundSemantics_Exist = false;
}
Mp7JrstermReferenceListPtr Mp7JrsLinguisticEntityType::Getoperator() const
{
	return m_operator;
}

bool Mp7JrsLinguisticEntityType::Existoperator() const
{
	return m_operator_Exist;
}
void Mp7JrsLinguisticEntityType::Setoperator(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setoperator().");
	}
    m_operator = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_operator) m_operator->SetParent(m_myself.getPointer());
	m_operator_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidateoperator()
{
	m_operator_Exist = false;
}
Mp7JrstermReferenceListPtr Mp7JrsLinguisticEntityType::Getcopy() const
{
	return m_copy;
}

bool Mp7JrsLinguisticEntityType::Existcopy() const
{
	return m_copy_Exist;
}
void Mp7JrsLinguisticEntityType::Setcopy(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setcopy().");
	}
    m_copy = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_copy) m_copy->SetParent(m_myself.getPointer());
	m_copy_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatecopy()
{
	m_copy_Exist = false;
}
Mp7JrstermReferenceListPtr Mp7JrsLinguisticEntityType::GetnoCopy() const
{
	return m_noCopy;
}

bool Mp7JrsLinguisticEntityType::ExistnoCopy() const
{
	return m_noCopy_Exist;
}
void Mp7JrsLinguisticEntityType::SetnoCopy(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetnoCopy().");
	}
    m_noCopy = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_noCopy) m_noCopy->SetParent(m_myself.getPointer());
	m_noCopy_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::InvalidatenoCopy()
{
	m_noCopy_Exist = false;
}
Mp7JrstermReferencePtr Mp7JrsLinguisticEntityType::Getsubstitute() const
{
	return m_substitute;
}

bool Mp7JrsLinguisticEntityType::Existsubstitute() const
{
	return m_substitute_Exist;
}
void Mp7JrsLinguisticEntityType::Setsubstitute(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setsubstitute().");
	}
    m_substitute = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_substitute) m_substitute->SetParent(m_myself.getPointer());
	m_substitute_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidatesubstitute()
{
	m_substitute_Exist = false;
}
Mp7JrstermReferencePtr Mp7JrsLinguisticEntityType::GetinScope() const
{
	return m_inScope;
}

bool Mp7JrsLinguisticEntityType::ExistinScope() const
{
	return m_inScope_Exist;
}
void Mp7JrsLinguisticEntityType::SetinScope(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetinScope().");
	}
    m_inScope = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_inScope) m_inScope->SetParent(m_myself.getPointer());
	m_inScope_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::InvalidateinScope()
{
	m_inScope_Exist = false;
}
Mp7JrsLinguisticEntityType_edit_LocalPtr Mp7JrsLinguisticEntityType::Getedit() const
{
	return m_edit;
}

bool Mp7JrsLinguisticEntityType::Existedit() const
{
	return m_edit_Exist;
}
void Mp7JrsLinguisticEntityType::Setedit(const Mp7JrsLinguisticEntityType_edit_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setedit().");
	}
    m_edit = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_edit) m_edit->SetParent(m_myself.getPointer());
	m_edit_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidateedit()
{
	m_edit_Exist = false;
}
Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr Mp7JrsLinguisticEntityType::GetMediaLocator() const
{
	return m_MediaLocator;
}

Mp7JrsLinguisticEntityType_Relation_CollectionPtr Mp7JrsLinguisticEntityType::GetRelation() const
{
	return m_Relation;
}

void Mp7JrsLinguisticEntityType::SetMediaLocator(const Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetMediaLocator().");
	}
	if (m_MediaLocator != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaLocator);
		m_MediaLocator = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaLocator) m_MediaLocator->SetParent(m_myself.getPointer());
		if(m_MediaLocator != Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaLocator->SetContentName(XMLString::transcode("MediaLocator"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::SetRelation(const Mp7JrsLinguisticEntityType_Relation_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetRelation().");
	}
	if (m_Relation != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Relation);
		m_Relation = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Relation) m_Relation->SetParent(m_myself.getPointer());
		if(m_Relation != Mp7JrsLinguisticEntityType_Relation_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Relation->SetContentName(XMLString::transcode("Relation"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsLinguisticEntityType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsLinguisticEntityType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsLinguisticEntityType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsLinguisticEntityType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsLinguisticEntityType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsLinguisticEntityType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsLinguisticEntityType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsLinguisticEntityType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsLinguisticEntityType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsLinguisticEntityType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsLinguisticEntityType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsLinguisticEntityType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsLinguisticEntityType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsLinguisticEntityType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsLinguisticEntityType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLinguisticEntityType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsLinguisticEntityType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsLinguisticEntityType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLinguisticEntityType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsLinguisticEntityType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("MediaLocator")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:MediaLocator is item of type MediaLocatorType
		// in element collection LinguisticEntityType_MediaLocator_CollectionType
		
		context->Found = true;
		Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr coll = GetMediaLocator();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateLinguisticEntityType_MediaLocator_CollectionType;
				SetMediaLocator(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaLocatorType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaLocatorPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Relation")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Relation is item of type GeneralRelationType
		// in element collection LinguisticEntityType_Relation_CollectionType
		
		context->Found = true;
		Mp7JrsLinguisticEntityType_Relation_CollectionPtr coll = GetRelation();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateLinguisticEntityType_Relation_CollectionType;
				SetRelation(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:GeneralRelationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsGeneralRelationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for LinguisticEntityType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "LinguisticEntityType");
	}		
	
	return result;
}

XMLCh * Mp7JrsLinguisticEntityType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsLinguisticEntityType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsLinguisticEntityType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsLinguisticEntityType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsLinguisticEntityType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("LinguisticEntityType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_lang_Exist)
	{
	// String
	if(m_lang != (XMLCh *)NULL)
	{
		element->setAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("xml:lang"), m_lang);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_start_Exist)
	{
	// Class
	if (m_start != Mp7JrsLinguisticEntityType_start_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_start->ToText();
		element->setAttributeNS(X(""), X("start"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_length_Exist)
	{
	// Class
	if (m_length != Mp7JrsLinguisticEntityType_length_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_length->ToText();
		element->setAttributeNS(X(""), X("length"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_type_Exist)
	{
	// Class
	if (m_type != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_type->ToText();
		element->setAttributeNS(X(""), X("type"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_depend_Exist)
	{
	// Class
	if (m_depend != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_depend->ToText();
		element->setAttributeNS(X(""), X("depend"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_equal_Exist)
	{
	// Collection
	if(m_equal != Mp7JrstermReferenceListPtr())
	{
		XMLCh * tmp = m_equal->ToText();
		element->setAttributeNS(X(""), X("equal"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_semantics_Exist)
	{
	// Collection
	if(m_semantics != Mp7JrstermReferenceListPtr())
	{
		XMLCh * tmp = m_semantics->ToText();
		element->setAttributeNS(X(""), X("semantics"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_compoundSemantics_Exist)
	{
	// Collection
	if(m_compoundSemantics != Mp7JrstermReferenceListPtr())
	{
		XMLCh * tmp = m_compoundSemantics->ToText();
		element->setAttributeNS(X(""), X("compoundSemantics"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_operator_Exist)
	{
	// Collection
	if(m_operator != Mp7JrstermReferenceListPtr())
	{
		XMLCh * tmp = m_operator->ToText();
		element->setAttributeNS(X(""), X("operator"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_copy_Exist)
	{
	// Collection
	if(m_copy != Mp7JrstermReferenceListPtr())
	{
		XMLCh * tmp = m_copy->ToText();
		element->setAttributeNS(X(""), X("copy"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_noCopy_Exist)
	{
	// Collection
	if(m_noCopy != Mp7JrstermReferenceListPtr())
	{
		XMLCh * tmp = m_noCopy->ToText();
		element->setAttributeNS(X(""), X("noCopy"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_substitute_Exist)
	{
	// Class
	if (m_substitute != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_substitute->ToText();
		element->setAttributeNS(X(""), X("substitute"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_inScope_Exist)
	{
	// Class
	if (m_inScope != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_inScope->ToText();
		element->setAttributeNS(X(""), X("inScope"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_edit_Exist)
	{
	// Pattern
	if (m_edit != Mp7JrsLinguisticEntityType_edit_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_edit->ToText();
		element->setAttributeNS(X(""), X("edit"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_MediaLocator != Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MediaLocator->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Relation != Mp7JrsLinguisticEntityType_Relation_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Relation->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsLinguisticEntityType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang")))
	{
        // Deserialize string type
        this->Setlang(Mp7JrsConvert::TextToString(parent->getAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("lang")))
	{
        // Deserialize string type
        this->Setlang(Mp7JrsConvert::TextToString(parent->getAttribute(X("lang"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("start")))
	{
        // Deserialize class type
		Mp7JrsLinguisticEntityType_start_LocalPtr tmp = CreateLinguisticEntityType_start_LocalType;
		tmp->Parse(parent->getAttributeNS(X(""), X("start")));
        this->Setstart(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("start")))
	{
		// Deserialize class type
        Mp7JrsLinguisticEntityType_start_LocalPtr tmp = CreateLinguisticEntityType_start_LocalType;
        tmp->Parse(parent->getAttribute(X("start")));
        this->Setstart(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("length")))
	{
        // Deserialize class type
		Mp7JrsLinguisticEntityType_length_LocalPtr tmp = CreateLinguisticEntityType_length_LocalType;
		tmp->Parse(parent->getAttributeNS(X(""), X("length")));
        this->Setlength(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("length")))
	{
		// Deserialize class type
        Mp7JrsLinguisticEntityType_length_LocalPtr tmp = CreateLinguisticEntityType_length_LocalType;
        tmp->Parse(parent->getAttribute(X("length")));
        this->Setlength(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("type")))
	{
        // Deserialize class type
		Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
		tmp->Parse(parent->getAttributeNS(X(""), X("type")));
        this->Settype(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("type")))
	{
		// Deserialize class type
        Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
        tmp->Parse(parent->getAttribute(X("type")));
        this->Settype(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("depend")))
	{
        // Deserialize class type
		Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
		tmp->Parse(parent->getAttributeNS(X(""), X("depend")));
        this->Setdepend(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("depend")))
	{
		// Deserialize class type
        Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
        tmp->Parse(parent->getAttribute(X("depend")));
        this->Setdepend(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("equal")))
	{
        // Deserialize collection type
		Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
		tmp->Parse(parent->getAttributeNS(X(""), X("equal")));
        this->Setequal(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("equal")))
	{
     
		// Deserialize collection type
        Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
        tmp->Parse(parent->getAttribute(X("equal")));
        this->Setequal(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("semantics")))
	{
        // Deserialize collection type
		Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
		tmp->Parse(parent->getAttributeNS(X(""), X("semantics")));
        this->Setsemantics(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("semantics")))
	{
     
		// Deserialize collection type
        Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
        tmp->Parse(parent->getAttribute(X("semantics")));
        this->Setsemantics(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("compoundSemantics")))
	{
        // Deserialize collection type
		Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
		tmp->Parse(parent->getAttributeNS(X(""), X("compoundSemantics")));
        this->SetcompoundSemantics(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("compoundSemantics")))
	{
     
		// Deserialize collection type
        Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
        tmp->Parse(parent->getAttribute(X("compoundSemantics")));
        this->SetcompoundSemantics(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("operator")))
	{
        // Deserialize collection type
		Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
		tmp->Parse(parent->getAttributeNS(X(""), X("operator")));
        this->Setoperator(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("operator")))
	{
     
		// Deserialize collection type
        Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
        tmp->Parse(parent->getAttribute(X("operator")));
        this->Setoperator(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("copy")))
	{
        // Deserialize collection type
		Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
		tmp->Parse(parent->getAttributeNS(X(""), X("copy")));
        this->Setcopy(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("copy")))
	{
     
		// Deserialize collection type
        Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
        tmp->Parse(parent->getAttribute(X("copy")));
        this->Setcopy(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("noCopy")))
	{
        // Deserialize collection type
		Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
		tmp->Parse(parent->getAttributeNS(X(""), X("noCopy")));
        this->SetnoCopy(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("noCopy")))
	{
     
		// Deserialize collection type
        Mp7JrstermReferenceListPtr tmp = CreatetermReferenceListType;
        tmp->Parse(parent->getAttribute(X("noCopy")));
        this->SetnoCopy(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("substitute")))
	{
        // Deserialize class type
		Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
		tmp->Parse(parent->getAttributeNS(X(""), X("substitute")));
        this->Setsubstitute(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("substitute")))
	{
		// Deserialize class type
        Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
        tmp->Parse(parent->getAttribute(X("substitute")));
        this->Setsubstitute(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("inScope")))
	{
        // Deserialize class type
		Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
		tmp->Parse(parent->getAttributeNS(X(""), X("inScope")));
        this->SetinScope(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("inScope")))
	{
		// Deserialize class type
        Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
        tmp->Parse(parent->getAttribute(X("inScope")));
        this->SetinScope(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("edit")))
	{
        Mp7JrsLinguisticEntityType_edit_LocalPtr tmp = CreateLinguisticEntityType_edit_LocalType;
        tmp->Parse(parent->getAttributeNS(X(""), X("edit")));
        this->Setedit(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("edit")))
	{
        Mp7JrsLinguisticEntityType_edit_LocalPtr tmp = CreateLinguisticEntityType_edit_LocalType;
        tmp->Parse(parent->getAttribute(X("edit")));
        this->Setedit(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("MediaLocator"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("MediaLocator")) == 0))
        {
            // Deserialize factory type
            Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr tmp = CreateLinguisticEntityType_MediaLocator_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMediaLocator(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Relation"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Relation")) == 0))
        {
            // Deserialize factory type
            Mp7JrsLinguisticEntityType_Relation_CollectionPtr tmp = CreateLinguisticEntityType_Relation_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetRelation(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsLinguisticEntityType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("MediaLocator")) == 0))
  {
    Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr tmp = CreateLinguisticEntityType_MediaLocator_CollectionType;
    this->SetMediaLocator(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Relation")) == 0))
  {
    Mp7JrsLinguisticEntityType_Relation_CollectionPtr tmp = CreateLinguisticEntityType_Relation_CollectionType;
    this->SetRelation(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsLinguisticEntityType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMediaLocator() != Mp7JrsNodePtr())
		result.Insert(GetMediaLocator());
	if (GetRelation() != Mp7JrsNodePtr())
		result.Insert(GetRelation());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsLinguisticEntityType_ExtMethodImpl.h


