 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtImplInclude.h



#include "Mp7JrsReferenceType.h"
#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsMatchingHintType_Hint_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMatchingHintType_Hint_LocalType::IMp7JrsMatchingHintType_Hint_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtPropInit.h

}

IMp7JrsMatchingHintType_Hint_LocalType::~IMp7JrsMatchingHintType_Hint_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtPropCleanup.h

}

Mp7JrsMatchingHintType_Hint_LocalType::Mp7JrsMatchingHintType_Hint_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMatchingHintType_Hint_LocalType::~Mp7JrsMatchingHintType_Hint_LocalType()
{
	Cleanup();
}

void Mp7JrsMatchingHintType_Hint_LocalType::Init()
{
	// Init base
	m_Base = CreateReferenceType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_value = CreatezeroToOneType; // Create a valid class
	m_value->SetContent(0.0); // Use Value initialiser (xxx2)



// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtMyPropInit.h

}

void Mp7JrsMatchingHintType_Hint_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_value);
}

void Mp7JrsMatchingHintType_Hint_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MatchingHintType_Hint_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMatchingHintType_Hint_LocalType
    const Mp7JrsPtr< Mp7JrsMatchingHintType_Hint_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsReferencePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMatchingHintType_Hint_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_value);
		this->Setvalue(Mp7JrsFactory::CloneObject(tmp->Getvalue()));
	}
}

Mp7JrsNodePtr Mp7JrsMatchingHintType_Hint_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsMatchingHintType_Hint_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsReferenceType > Mp7JrsMatchingHintType_Hint_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrszeroToOnePtr Mp7JrsMatchingHintType_Hint_LocalType::Getvalue() const
{
	return m_value;
}

void Mp7JrsMatchingHintType_Hint_LocalType::Setvalue(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMatchingHintType_Hint_LocalType::Setvalue().");
	}
    m_value = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_value) m_value->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsMatchingHintType_Hint_LocalType::Getidref() const
{
	return GetBase()->Getidref();
}

bool Mp7JrsMatchingHintType_Hint_LocalType::Existidref() const
{
	return GetBase()->Existidref();
}
void Mp7JrsMatchingHintType_Hint_LocalType::Setidref(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMatchingHintType_Hint_LocalType::Setidref().");
	}
	GetBase()->Setidref(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMatchingHintType_Hint_LocalType::Invalidateidref()
{
	GetBase()->Invalidateidref();
}
Mp7JrsxPathRefPtr Mp7JrsMatchingHintType_Hint_LocalType::Getxpath() const
{
	return GetBase()->Getxpath();
}

bool Mp7JrsMatchingHintType_Hint_LocalType::Existxpath() const
{
	return GetBase()->Existxpath();
}
void Mp7JrsMatchingHintType_Hint_LocalType::Setxpath(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMatchingHintType_Hint_LocalType::Setxpath().");
	}
	GetBase()->Setxpath(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMatchingHintType_Hint_LocalType::Invalidatexpath()
{
	GetBase()->Invalidatexpath();
}
XMLCh * Mp7JrsMatchingHintType_Hint_LocalType::Gethref() const
{
	return GetBase()->Gethref();
}

bool Mp7JrsMatchingHintType_Hint_LocalType::Existhref() const
{
	return GetBase()->Existhref();
}
void Mp7JrsMatchingHintType_Hint_LocalType::Sethref(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMatchingHintType_Hint_LocalType::Sethref().");
	}
	GetBase()->Sethref(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMatchingHintType_Hint_LocalType::Invalidatehref()
{
	GetBase()->Invalidatehref();
}

Mp7JrsNodeEnum Mp7JrsMatchingHintType_Hint_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for MatchingHintType_Hint_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "MatchingHintType_Hint_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsMatchingHintType_Hint_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMatchingHintType_Hint_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsMatchingHintType_Hint_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsMatchingHintType_Hint_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsMatchingHintType_Hint_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MatchingHintType_Hint_LocalType"));
    // Attribute Serialization:
	// Class
	if (m_value != Mp7JrszeroToOnePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_value->ToText();
		element->setAttributeNS(X(""), X("value"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:

}

bool Mp7JrsMatchingHintType_Hint_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("value")))
	{
        // Deserialize class type
		Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
		tmp->Parse(parent->getAttributeNS(X(""), X("value")));
        this->Setvalue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("value")))
	{
		// Deserialize class type
        Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
        tmp->Parse(parent->getAttribute(X("value")));
        this->Setvalue(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsReferenceType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMatchingHintType_Hint_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMatchingHintType_Hint_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMatchingHintType_Hint_LocalType_ExtMethodImpl.h


