 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtImplInclude.h



#include "Mp7JrsMediaFormatType_BitRate_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMediaFormatType_BitRate_LocalType::IMp7JrsMediaFormatType_BitRate_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtPropInit.h

}

IMp7JrsMediaFormatType_BitRate_LocalType::~IMp7JrsMediaFormatType_BitRate_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtPropCleanup.h

}

Mp7JrsMediaFormatType_BitRate_LocalType::Mp7JrsMediaFormatType_BitRate_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaFormatType_BitRate_LocalType::~Mp7JrsMediaFormatType_BitRate_LocalType()
{
	Cleanup();
}

void Mp7JrsMediaFormatType_BitRate_LocalType::Init()
{
	// Init base
	m_Base = 0;

	// Init attributes
	m_variable = false; // Value
	m_variable_Default = false;
	m_variable_Exist = false;
	m_minimum = 0; // Value
	m_minimum_Exist = false;
	m_average = 0; // Value
	m_average_Exist = false;
	m_maximum = 0; // Value
	m_maximum_Exist = false;



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtMyPropInit.h

}

void Mp7JrsMediaFormatType_BitRate_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtMyPropCleanup.h


}

void Mp7JrsMediaFormatType_BitRate_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaFormatType_BitRate_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaFormatType_BitRate_LocalType
    const Mp7JrsPtr< Mp7JrsMediaFormatType_BitRate_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	m_Base = tmp->GetContent();
	{
	if (tmp->Existvariable())
	{
		this->Setvariable(tmp->Getvariable());
	}
	else
	{
		Invalidatevariable();
	}
	}
	{
	if (tmp->Existminimum())
	{
		this->Setminimum(tmp->Getminimum());
	}
	else
	{
		Invalidateminimum();
	}
	}
	{
	if (tmp->Existaverage())
	{
		this->Setaverage(tmp->Getaverage());
	}
	else
	{
		Invalidateaverage();
	}
	}
	{
	if (tmp->Existmaximum())
	{
		this->Setmaximum(tmp->Getmaximum());
	}
	else
	{
		Invalidatemaximum();
	}
	}
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_BitRate_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMediaFormatType_BitRate_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


void Mp7JrsMediaFormatType_BitRate_LocalType::SetContent(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_BitRate_LocalType::SetContent().");
	}
    if (m_Base != item)
    {
		m_Base = item;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsMediaFormatType_BitRate_LocalType::GetContent() const
{
	return m_Base;
}
bool Mp7JrsMediaFormatType_BitRate_LocalType::Getvariable() const
{
	if (this->Existvariable()) {
		return m_variable;
	} else {
		return m_variable_Default;
	}
}

bool Mp7JrsMediaFormatType_BitRate_LocalType::Existvariable() const
{
	return m_variable_Exist;
}
void Mp7JrsMediaFormatType_BitRate_LocalType::Setvariable(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_BitRate_LocalType::Setvariable().");
	}
    m_variable = item;
	m_variable_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_BitRate_LocalType::Invalidatevariable()
{
	m_variable_Exist = false;
}
unsigned Mp7JrsMediaFormatType_BitRate_LocalType::Getminimum() const
{
	return m_minimum;
}

bool Mp7JrsMediaFormatType_BitRate_LocalType::Existminimum() const
{
	return m_minimum_Exist;
}
void Mp7JrsMediaFormatType_BitRate_LocalType::Setminimum(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_BitRate_LocalType::Setminimum().");
	}
    m_minimum = item;
	m_minimum_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_BitRate_LocalType::Invalidateminimum()
{
	m_minimum_Exist = false;
}
unsigned Mp7JrsMediaFormatType_BitRate_LocalType::Getaverage() const
{
	return m_average;
}

bool Mp7JrsMediaFormatType_BitRate_LocalType::Existaverage() const
{
	return m_average_Exist;
}
void Mp7JrsMediaFormatType_BitRate_LocalType::Setaverage(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_BitRate_LocalType::Setaverage().");
	}
    m_average = item;
	m_average_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_BitRate_LocalType::Invalidateaverage()
{
	m_average_Exist = false;
}
unsigned Mp7JrsMediaFormatType_BitRate_LocalType::Getmaximum() const
{
	return m_maximum;
}

bool Mp7JrsMediaFormatType_BitRate_LocalType::Existmaximum() const
{
	return m_maximum_Exist;
}
void Mp7JrsMediaFormatType_BitRate_LocalType::Setmaximum(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_BitRate_LocalType::Setmaximum().");
	}
    m_maximum = item;
	m_maximum_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_BitRate_LocalType::Invalidatemaximum()
{
	m_maximum_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_BitRate_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for MediaFormatType_BitRate_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "MediaFormatType_BitRate_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsMediaFormatType_BitRate_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaFormatType_BitRate_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsMediaFormatType_BitRate_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsMediaFormatType_BitRate_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsMediaFormatType_BitRate_LocalType::ContentToString() const
{
	// Mp7JrsMediaFormatType_BitRate_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsMediaFormatType_BitRate_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


    {
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_Base);
		element->appendChild(doc->createTextNode(tmp));
		XMLString::release(&tmp);
    }

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaFormatType_BitRate_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_variable_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_variable);
		element->setAttributeNS(X(""), X("variable"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_minimum_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_minimum);
		element->setAttributeNS(X(""), X("minimum"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_average_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_average);
		element->setAttributeNS(X(""), X("average"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_maximum_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_maximum);
		element->setAttributeNS(X(""), X("maximum"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsMediaFormatType_BitRate_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("variable")))
	{
        // deserialize value type
        this->Setvariable(Mp7JrsConvert::TextToBool(parent->getAttributeNS(X(""), X("variable"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("variable")))
	{
        // deserialize value type
        this->Setvariable(Mp7JrsConvert::TextToBool(parent->getAttribute(X("variable"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("minimum")))
	{
        // deserialize value type
        this->Setminimum(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("minimum"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("minimum")))
	{
        // deserialize value type
        this->Setminimum(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("minimum"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("average")))
	{
        // deserialize value type
        this->Setaverage(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("average"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("average")))
	{
        // deserialize value type
        this->Setaverage(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("average"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("maximum")))
	{
        // deserialize value type
        this->Setmaximum(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("maximum"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("maximum")))
	{
        // deserialize value type
        this->Setmaximum(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("maximum"))));
        * current = parent;
    }

  m_Base = Mp7JrsConvert::TextToUnsignedInt(Mp7JrsUtil::GetElementText(parent));
  found = true;
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_BitRate_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_BitRate_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtMethodImpl.h


