 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtImplInclude.h



#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType2.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Definition_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Definition
#include "Mp7JrsInlineTermDefinitionType_Term_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Term

#include <assert.h>
IMp7JrsMediaFormatType_VisualCoding_Format_LocalType::IMp7JrsMediaFormatType_VisualCoding_Format_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtPropInit.h

}

IMp7JrsMediaFormatType_VisualCoding_Format_LocalType::~IMp7JrsMediaFormatType_VisualCoding_Format_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtPropCleanup.h

}

Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Mp7JrsMediaFormatType_VisualCoding_Format_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::~Mp7JrsMediaFormatType_VisualCoding_Format_LocalType()
{
	Cleanup();
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Init()
{
	// Init base
	m_Base = CreateControlledTermUseType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_colorDomain = Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local2Ptr(); // Create emtpy class ptr
	m_colorDomain_Exist = false;



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtMyPropInit.h

}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_colorDomain);
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaFormatType_VisualCoding_Format_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaFormatType_VisualCoding_Format_LocalType
    const Mp7JrsPtr< Mp7JrsMediaFormatType_VisualCoding_Format_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsControlledTermUsePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMediaFormatType_VisualCoding_Format_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_colorDomain);
	if (tmp->ExistcolorDomain())
	{
		this->SetcolorDomain(Mp7JrsFactory::CloneObject(tmp->GetcolorDomain()));
	}
	else
	{
		InvalidatecolorDomain();
	}
	}
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsControlledTermUseType > Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local2Ptr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetcolorDomain() const
{
	if (this->ExistcolorDomain()) {
		return m_colorDomain;
	} else {
		return m_colorDomain_Default;
	}
}

bool Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::ExistcolorDomain() const
{
	return m_colorDomain_Exist;
}
void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetcolorDomain(const Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetcolorDomain().");
	}
    m_colorDomain = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_colorDomain) m_colorDomain->SetParent(m_myself.getPointer());
	m_colorDomain_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::InvalidatecolorDomain()
{
	m_colorDomain_Exist = false;
}
Mp7JrstermReferencePtr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Gethref() const
{
	return GetBase()->Gethref();
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Sethref().");
	}
	GetBase()->Sethref(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsInlineTermDefinitionType_Name_CollectionPtr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetName() const
{
	return GetBase()->GetBase()->GetName();
}

Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetDefinition() const
{
	return GetBase()->GetBase()->GetDefinition();
}

Mp7JrsInlineTermDefinitionType_Term_CollectionPtr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetTerm() const
{
	return GetBase()->GetBase()->GetTerm();
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetName().");
	}
	GetBase()->GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetDefinition().");
	}
	GetBase()->GetBase()->SetDefinition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::SetTerm().");
	}
	GetBase()->GetBase()->SetTerm(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MediaFormatType_VisualCoding_Format_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MediaFormatType_VisualCoding_Format_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaFormatType_VisualCoding_Format_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_colorDomain_Exist)
	{
	// Class
	if (m_colorDomain != Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_colorDomain->ToText();
		element->setAttributeNS(X(""), X("colorDomain"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("colorDomain")))
	{
        // Deserialize class type
		Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local2Ptr tmp = CreateMediaFormatType_VisualCoding_Format_colorDomain_LocalType2;
		tmp->Parse(parent->getAttributeNS(X(""), X("colorDomain")));
        this->SetcolorDomain(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("colorDomain")))
	{
		// Deserialize class type
        Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local2Ptr tmp = CreateMediaFormatType_VisualCoding_Format_colorDomain_LocalType2;
        tmp->Parse(parent->getAttribute(X("colorDomain")));
        this->SetcolorDomain(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsControlledTermUseType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_VisualCoding_Format_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetDefinition() != Mp7JrsNodePtr())
		result.Insert(GetDefinition());
	if (GetTerm() != Mp7JrsNodePtr())
		result.Insert(GetTerm());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_LocalType_ExtMethodImpl.h


