 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtImplInclude.h



#include "Mp7JrsDType.h"
#include "Mp7JrsMediaQualityType_QualityRating_CollectionType.h"
#include "Mp7JrsAgentType.h"
#include "Mp7JrsMediaQualityType_RatingInformationLocator_CollectionType.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_LocalType.h"
#include "Mp7JrsMediaQualityType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsMediaQualityType_QualityRating_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:QualityRating
#include "Mp7JrsReferenceType.h" // Element collection urn:mpeg:mpeg7:schema:2004:RatingInformationLocator

#include <assert.h>
IMp7JrsMediaQualityType::IMp7JrsMediaQualityType()
{

// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtPropInit.h

}

IMp7JrsMediaQualityType::~IMp7JrsMediaQualityType()
{
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtPropCleanup.h

}

Mp7JrsMediaQualityType::Mp7JrsMediaQualityType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaQualityType::~Mp7JrsMediaQualityType()
{
	Cleanup();
}

void Mp7JrsMediaQualityType::Init()
{
	// Init base
	m_Base = CreateDType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_QualityRating = Mp7JrsMediaQualityType_QualityRating_CollectionPtr(); // Collection
	m_RatingSource = Mp7JrsPtr< Mp7JrsNode >(); // Class
	m_RatingSource_Exist = false;
	m_RatingInformationLocator = Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr(); // Collection
	m_PerceptibleDefects = Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr(); // Class
	m_PerceptibleDefects_Exist = false;


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtMyPropInit.h

}

void Mp7JrsMediaQualityType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_QualityRating);
	// Mp7JrsFactory::DeleteObject(m_RatingSource);
	// Mp7JrsFactory::DeleteObject(m_RatingInformationLocator);
	// Mp7JrsFactory::DeleteObject(m_PerceptibleDefects);
}

void Mp7JrsMediaQualityType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaQualityTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaQualityType
    const Mp7JrsPtr< Mp7JrsMediaQualityType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMediaQualityType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_QualityRating);
		this->SetQualityRating(Mp7JrsFactory::CloneObject(tmp->GetQualityRating()));
	if (tmp->IsValidRatingSource())
	{
		// Mp7JrsFactory::DeleteObject(m_RatingSource);
		this->SetRatingSource(Mp7JrsFactory::CloneObject(tmp->GetRatingSource()));
	}
	else
	{
		InvalidateRatingSource();
	}
		// Mp7JrsFactory::DeleteObject(m_RatingInformationLocator);
		this->SetRatingInformationLocator(Mp7JrsFactory::CloneObject(tmp->GetRatingInformationLocator()));
	if (tmp->IsValidPerceptibleDefects())
	{
		// Mp7JrsFactory::DeleteObject(m_PerceptibleDefects);
		this->SetPerceptibleDefects(Mp7JrsFactory::CloneObject(tmp->GetPerceptibleDefects()));
	}
	else
	{
		InvalidatePerceptibleDefects();
	}
}

Mp7JrsNodePtr Mp7JrsMediaQualityType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsMediaQualityType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDType > Mp7JrsMediaQualityType::GetBase() const
{
	return m_Base;
}

Mp7JrsMediaQualityType_QualityRating_CollectionPtr Mp7JrsMediaQualityType::GetQualityRating() const
{
	return m_QualityRating;
}

Mp7JrsPtr< Mp7JrsNode > Mp7JrsMediaQualityType::GetRatingSource() const
{
	return m_RatingSource;
}

// Element is optional
bool Mp7JrsMediaQualityType::IsValidRatingSource() const
{
	return m_RatingSource_Exist;
}

Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr Mp7JrsMediaQualityType::GetRatingInformationLocator() const
{
	return m_RatingInformationLocator;
}

Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr Mp7JrsMediaQualityType::GetPerceptibleDefects() const
{
	return m_PerceptibleDefects;
}

// Element is optional
bool Mp7JrsMediaQualityType::IsValidPerceptibleDefects() const
{
	return m_PerceptibleDefects_Exist;
}

void Mp7JrsMediaQualityType::SetQualityRating(const Mp7JrsMediaQualityType_QualityRating_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaQualityType::SetQualityRating().");
	}
	if (m_QualityRating != item)
	{
		// Mp7JrsFactory::DeleteObject(m_QualityRating);
		m_QualityRating = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_QualityRating) m_QualityRating->SetParent(m_myself.getPointer());
		if(m_QualityRating != Mp7JrsMediaQualityType_QualityRating_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_QualityRating->SetContentName(XMLString::transcode("QualityRating"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaQualityType::SetRatingSource(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaQualityType::SetRatingSource().");
	}
	if (m_RatingSource != item || m_RatingSource_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_RatingSource);
		m_RatingSource = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_RatingSource) m_RatingSource->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_RatingSource) m_RatingSource->UseTypeAttribute = true;
		m_RatingSource_Exist = true;
		if(m_RatingSource != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_RatingSource->SetContentName(XMLString::transcode("RatingSource"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaQualityType::InvalidateRatingSource()
{
	m_RatingSource_Exist = false;
}
void Mp7JrsMediaQualityType::SetRatingInformationLocator(const Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaQualityType::SetRatingInformationLocator().");
	}
	if (m_RatingInformationLocator != item)
	{
		// Mp7JrsFactory::DeleteObject(m_RatingInformationLocator);
		m_RatingInformationLocator = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_RatingInformationLocator) m_RatingInformationLocator->SetParent(m_myself.getPointer());
		if(m_RatingInformationLocator != Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_RatingInformationLocator->SetContentName(XMLString::transcode("RatingInformationLocator"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaQualityType::SetPerceptibleDefects(const Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaQualityType::SetPerceptibleDefects().");
	}
	if (m_PerceptibleDefects != item || m_PerceptibleDefects_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_PerceptibleDefects);
		m_PerceptibleDefects = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PerceptibleDefects) m_PerceptibleDefects->SetParent(m_myself.getPointer());
		if (m_PerceptibleDefects && m_PerceptibleDefects->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaQualityType_PerceptibleDefects_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_PerceptibleDefects->UseTypeAttribute = true;
		}
		m_PerceptibleDefects_Exist = true;
		if(m_PerceptibleDefects != Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PerceptibleDefects->SetContentName(XMLString::transcode("PerceptibleDefects"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaQualityType::InvalidatePerceptibleDefects()
{
	m_PerceptibleDefects_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaQualityType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("QualityRating")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:QualityRating is item of type MediaQualityType_QualityRating_LocalType
		// in element collection MediaQualityType_QualityRating_CollectionType
		
		context->Found = true;
		Mp7JrsMediaQualityType_QualityRating_CollectionPtr coll = GetQualityRating();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMediaQualityType_QualityRating_CollectionType;
				SetQualityRating(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaQualityType_QualityRating_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaQualityType_QualityRating_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("RatingSource")) == 0)
	{
		// RatingSource is simple abstract element AgentType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetRatingSource()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsAgentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetRatingSource(p, client);
					if((p = GetRatingSource()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("RatingInformationLocator")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:RatingInformationLocator is item of type ReferenceType
		// in element collection MediaQualityType_RatingInformationLocator_CollectionType
		
		context->Found = true;
		Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr coll = GetRatingInformationLocator();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMediaQualityType_RatingInformationLocator_CollectionType;
				SetRatingInformationLocator(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PerceptibleDefects")) == 0)
	{
		// PerceptibleDefects is simple element MediaQualityType_PerceptibleDefects_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPerceptibleDefects()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaQualityType_PerceptibleDefects_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPerceptibleDefects(p, client);
					if((p = GetPerceptibleDefects()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MediaQualityType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MediaQualityType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMediaQualityType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsMediaQualityType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsMediaQualityType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsMediaQualityType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsMediaQualityType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaQualityType"));
	// Element serialization:
	if (m_QualityRating != Mp7JrsMediaQualityType_QualityRating_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_QualityRating->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	// Class
	
	if (m_RatingSource != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_RatingSource->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("RatingSource"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_RatingSource->UseTypeAttribute = true;
		}
		m_RatingSource->Serialize(doc, element, &elem);
	}
	if (m_RatingInformationLocator != Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_RatingInformationLocator->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	// Class
	
	if (m_PerceptibleDefects != Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_PerceptibleDefects->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("PerceptibleDefects"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_PerceptibleDefects->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMediaQualityType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsDType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("QualityRating"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("QualityRating")) == 0))
        {
            // Deserialize factory type
            Mp7JrsMediaQualityType_QualityRating_CollectionPtr tmp = CreateMediaQualityType_QualityRating_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetQualityRating(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("RatingSource"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("RatingSource")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAgentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetRatingSource(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("RatingInformationLocator"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("RatingInformationLocator")) == 0))
        {
            // Deserialize factory type
            Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr tmp = CreateMediaQualityType_RatingInformationLocator_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetRatingInformationLocator(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("PerceptibleDefects"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("PerceptibleDefects")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaQualityType_PerceptibleDefects_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPerceptibleDefects(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaQualityType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("QualityRating")) == 0))
  {
    Mp7JrsMediaQualityType_QualityRating_CollectionPtr tmp = CreateMediaQualityType_QualityRating_CollectionType;
    this->SetQualityRating(tmp);
    child = tmp;
  }
  if (XMLString::compareString(elementname, X("RatingSource")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAgentType;
    }
    this->SetRatingSource(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("RatingInformationLocator")) == 0))
  {
    Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr tmp = CreateMediaQualityType_RatingInformationLocator_CollectionType;
    this->SetRatingInformationLocator(tmp);
    child = tmp;
  }
  if (XMLString::compareString(elementname, X("PerceptibleDefects")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaQualityType_PerceptibleDefects_LocalType;
    }
    this->SetPerceptibleDefects(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaQualityType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetQualityRating() != Mp7JrsNodePtr())
		result.Insert(GetQualityRating());
	if (GetRatingSource() != Mp7JrsNodePtr())
		result.Insert(GetRatingSource());
	if (GetRatingInformationLocator() != Mp7JrsNodePtr())
		result.Insert(GetRatingInformationLocator());
	if (GetPerceptibleDefects() != Mp7JrsNodePtr())
		result.Insert(GetPerceptibleDefects());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtMethodImpl.h


