 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtImplInclude.h



#include "Mp7JrsnonNegativeReal.h"
#include "Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType::IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtPropInit.h

}

IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType::~IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtPropCleanup.h

}

Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::~Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType()
{
	Cleanup();
}

void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::Init()
{

	// Init attributes
	m_avgQuantScale = CreatenonNegativeReal; // Create a valid class
	m_avgQuantScale->SetContent(0.0); // Use Value initialiser (xxx2)
	m_avgQuantScale_Exist = false;
	m_intraFrameDistance = 0; // Value
	m_intraFrameDistance_Exist = false;
	m_anchorFrameDistance = 1; // Value
	m_anchorFrameDistance_Exist = false;



// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtMyPropInit.h

}

void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_avgQuantScale);
}

void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaTranscodingHintsType_CodingHints_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaTranscodingHintsType_CodingHints_LocalType
    const Mp7JrsPtr< Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_avgQuantScale);
	if (tmp->ExistavgQuantScale())
	{
		this->SetavgQuantScale(Mp7JrsFactory::CloneObject(tmp->GetavgQuantScale()));
	}
	else
	{
		InvalidateavgQuantScale();
	}
	}
	{
	if (tmp->ExistintraFrameDistance())
	{
		this->SetintraFrameDistance(tmp->GetintraFrameDistance());
	}
	else
	{
		InvalidateintraFrameDistance();
	}
	}
	{
	if (tmp->ExistanchorFrameDistance())
	{
		this->SetanchorFrameDistance(tmp->GetanchorFrameDistance());
	}
	else
	{
		InvalidateanchorFrameDistance();
	}
	}
}

Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsnonNegativeRealPtr Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::GetavgQuantScale() const
{
	return m_avgQuantScale;
}

bool Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::ExistavgQuantScale() const
{
	return m_avgQuantScale_Exist;
}
void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::SetavgQuantScale(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::SetavgQuantScale().");
	}
    m_avgQuantScale = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_avgQuantScale) m_avgQuantScale->SetParent(m_myself.getPointer());
	m_avgQuantScale_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::InvalidateavgQuantScale()
{
	m_avgQuantScale_Exist = false;
}
unsigned Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::GetintraFrameDistance() const
{
	return m_intraFrameDistance;
}

bool Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::ExistintraFrameDistance() const
{
	return m_intraFrameDistance_Exist;
}
void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::SetintraFrameDistance(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::SetintraFrameDistance().");
	}
    m_intraFrameDistance = item;
	m_intraFrameDistance_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::InvalidateintraFrameDistance()
{
	m_intraFrameDistance_Exist = false;
}
unsigned Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::GetanchorFrameDistance() const
{
	return m_anchorFrameDistance;
}

bool Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::ExistanchorFrameDistance() const
{
	return m_anchorFrameDistance_Exist;
}
void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::SetanchorFrameDistance(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::SetanchorFrameDistance().");
	}
    m_anchorFrameDistance = item;
	m_anchorFrameDistance_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::InvalidateanchorFrameDistance()
{
	m_anchorFrameDistance_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::ContentToString() const
{
	// Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaTranscodingHintsType_CodingHints_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_avgQuantScale_Exist)
	{
	// Class
	if (m_avgQuantScale != Mp7JrsnonNegativeRealPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_avgQuantScale->ToText();
		element->setAttributeNS(X(""), X("avgQuantScale"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_intraFrameDistance_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_intraFrameDistance);
		element->setAttributeNS(X(""), X("intraFrameDistance"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_anchorFrameDistance_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_anchorFrameDistance);
		element->setAttributeNS(X(""), X("anchorFrameDistance"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("avgQuantScale")))
	{
        // Deserialize class type
		Mp7JrsnonNegativeRealPtr tmp = CreatenonNegativeReal;
		tmp->Parse(parent->getAttributeNS(X(""), X("avgQuantScale")));
        this->SetavgQuantScale(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("avgQuantScale")))
	{
		// Deserialize class type
        Mp7JrsnonNegativeRealPtr tmp = CreatenonNegativeReal;
        tmp->Parse(parent->getAttribute(X("avgQuantScale")));
        this->SetavgQuantScale(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("intraFrameDistance")))
	{
        // deserialize value type
        this->SetintraFrameDistance(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("intraFrameDistance"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("intraFrameDistance")))
	{
        // deserialize value type
        this->SetintraFrameDistance(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("intraFrameDistance"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("anchorFrameDistance")))
	{
        // deserialize value type
        this->SetanchorFrameDistance(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("anchorFrameDistance"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("anchorFrameDistance")))
	{
        // deserialize value type
        this->SetanchorFrameDistance(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("anchorFrameDistance"))));
        * current = parent;
    }

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtMethodImpl.h


