 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtImplInclude.h



#include "Mp7JrsnonNegativeReal.h"
#include "Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtPropInit.h

}

IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::~IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtPropCleanup.h

}

Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::~Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType()
{
	Cleanup();
}

void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::Init()
{

	// Init attributes
	m_shapeChange = 0.0; // Value
	m_shapeChange_Exist = false;
	m_numOfNonTranspBlocks = CreatenonNegativeReal; // Create a valid class
	m_numOfNonTranspBlocks->SetContent(0.0); // Use Value initialiser (xxx2)
	m_numOfNonTranspBlocks_Exist = false;



// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtMyPropInit.h

}

void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_numOfNonTranspBlocks);
}

void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaTranscodingHintsType_ShapeHint_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaTranscodingHintsType_ShapeHint_LocalType
    const Mp7JrsPtr< Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if (tmp->ExistshapeChange())
	{
		this->SetshapeChange(tmp->GetshapeChange());
	}
	else
	{
		InvalidateshapeChange();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_numOfNonTranspBlocks);
	if (tmp->ExistnumOfNonTranspBlocks())
	{
		this->SetnumOfNonTranspBlocks(Mp7JrsFactory::CloneObject(tmp->GetnumOfNonTranspBlocks()));
	}
	else
	{
		InvalidatenumOfNonTranspBlocks();
	}
	}
}

Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


float Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::GetshapeChange() const
{
	return m_shapeChange;
}

bool Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::ExistshapeChange() const
{
	return m_shapeChange_Exist;
}
void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::SetshapeChange(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::SetshapeChange().");
	}
    m_shapeChange = item;
	m_shapeChange_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::InvalidateshapeChange()
{
	m_shapeChange_Exist = false;
}
Mp7JrsnonNegativeRealPtr Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::GetnumOfNonTranspBlocks() const
{
	return m_numOfNonTranspBlocks;
}

bool Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::ExistnumOfNonTranspBlocks() const
{
	return m_numOfNonTranspBlocks_Exist;
}
void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::SetnumOfNonTranspBlocks(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::SetnumOfNonTranspBlocks().");
	}
    m_numOfNonTranspBlocks = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_numOfNonTranspBlocks) m_numOfNonTranspBlocks->SetParent(m_myself.getPointer());
	m_numOfNonTranspBlocks_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::InvalidatenumOfNonTranspBlocks()
{
	m_numOfNonTranspBlocks_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::ContentToString() const
{
	// Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaTranscodingHintsType_ShapeHint_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_shapeChange_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_shapeChange);
		element->setAttributeNS(X(""), X("shapeChange"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_numOfNonTranspBlocks_Exist)
	{
	// Class
	if (m_numOfNonTranspBlocks != Mp7JrsnonNegativeRealPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_numOfNonTranspBlocks->ToText();
		element->setAttributeNS(X(""), X("numOfNonTranspBlocks"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("shapeChange")))
	{
        // deserialize value type
        this->SetshapeChange(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("shapeChange"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("shapeChange")))
	{
        // deserialize value type
        this->SetshapeChange(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("shapeChange"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("numOfNonTranspBlocks")))
	{
        // Deserialize class type
		Mp7JrsnonNegativeRealPtr tmp = CreatenonNegativeReal;
		tmp->Parse(parent->getAttributeNS(X(""), X("numOfNonTranspBlocks")));
        this->SetnumOfNonTranspBlocks(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("numOfNonTranspBlocks")))
	{
		// Deserialize class type
        Mp7JrsnonNegativeRealPtr tmp = CreatenonNegativeReal;
        tmp->Parse(parent->getAttribute(X("numOfNonTranspBlocks")));
        this->SetnumOfNonTranspBlocks(tmp);
        * current = parent;
    }

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtMethodImpl.h


