 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtImplInclude.h



#include "Mp7JrsTextualType.h"
#include "Mp7JrsMelodySequenceType_NoteArray_Note_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMelodySequenceType_NoteArray_Note_LocalType::IMp7JrsMelodySequenceType_NoteArray_Note_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtPropInit.h

}

IMp7JrsMelodySequenceType_NoteArray_Note_LocalType::~IMp7JrsMelodySequenceType_NoteArray_Note_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtPropCleanup.h

}

Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::Mp7JrsMelodySequenceType_NoteArray_Note_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::~Mp7JrsMelodySequenceType_NoteArray_Note_LocalType()
{
	Cleanup();
}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Interval = (0.0); // Value

	m_NoteRelDuration = (0.0); // Value

	m_Lyric = Mp7JrsTextualPtr(); // Class
	m_Lyric_Exist = false;


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtMyPropInit.h

}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Lyric);
}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MelodySequenceType_NoteArray_Note_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMelodySequenceType_NoteArray_Note_LocalType
    const Mp7JrsPtr< Mp7JrsMelodySequenceType_NoteArray_Note_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		this->SetInterval(tmp->GetInterval());
		this->SetNoteRelDuration(tmp->GetNoteRelDuration());
	if (tmp->IsValidLyric())
	{
		// Mp7JrsFactory::DeleteObject(m_Lyric);
		this->SetLyric(Mp7JrsFactory::CloneObject(tmp->GetLyric()));
	}
	else
	{
		InvalidateLyric();
	}
}

Mp7JrsNodePtr Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


float Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::GetInterval() const
{
	return m_Interval;
}

float Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::GetNoteRelDuration() const
{
	return m_NoteRelDuration;
}

Mp7JrsTextualPtr Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::GetLyric() const
{
	return m_Lyric;
}

// Element is optional
bool Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::IsValidLyric() const
{
	return m_Lyric_Exist;
}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::SetInterval(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::SetInterval().");
	}
	if (m_Interval != item)
	{
		m_Interval = item;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::SetNoteRelDuration(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::SetNoteRelDuration().");
	}
	if (m_NoteRelDuration != item)
	{
		m_NoteRelDuration = item;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::SetLyric(const Mp7JrsTextualPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::SetLyric().");
	}
	if (m_Lyric != item || m_Lyric_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Lyric);
		m_Lyric = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Lyric) m_Lyric->SetParent(m_myself.getPointer());
		if (m_Lyric && m_Lyric->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Lyric->UseTypeAttribute = true;
		}
		m_Lyric_Exist = true;
		if(m_Lyric != Mp7JrsTextualPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Lyric->SetContentName(XMLString::transcode("Lyric"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::InvalidateLyric()
{
	m_Lyric_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Lyric")) == 0)
	{
		// Lyric is simple element TextualType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetLyric()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextualPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetLyric(p, client);
					if((p = GetLyric()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MelodySequenceType_NoteArray_Note_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MelodySequenceType_NoteArray_Note_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsMelodySequenceType_NoteArray_Note_LocalType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::ContentToString() const
{
	// Mp7JrsMelodySequenceType_NoteArray_Note_LocalType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MelodySequenceType_NoteArray_Note_LocalType"));
	// Element serialization:
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_Interval);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("Interval"), false);
		XMLString::release(&tmp);
	}
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_NoteRelDuration);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("NoteRelDuration"), false);
		XMLString::release(&tmp);
	}
	// Class
	
	if (m_Lyric != Mp7JrsTextualPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Lyric->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Lyric"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Lyric->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	// Deserialize value element
	if(Mp7JrsUtil::HasNodeName(parent, X("Interval"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		XMLCh * tmp = Mp7JrsUtil::GetElementText(parent);
		this->SetInterval(Mp7JrsConvert::TextToFloat(tmp));
		XMLString::release(&tmp);
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	// Deserialize value element
	if(Mp7JrsUtil::HasNodeName(parent, X("NoteRelDuration"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		XMLCh * tmp = Mp7JrsUtil::GetElementText(parent);
		this->SetNoteRelDuration(Mp7JrsConvert::TextToFloat(tmp));
		XMLString::release(&tmp);
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Lyric"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Lyric")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTextualType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetLyric(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Lyric")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTextualType;
    }
    this->SetLyric(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMelodySequenceType_NoteArray_Note_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetLyric() != Mp7JrsNodePtr())
		result.Insert(GetLyric());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtMethodImpl.h


