 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtImplInclude.h



#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtPropInit.h

}

IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::~IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtPropCleanup.h

}

Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::~Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType()
{
	Cleanup();
}

void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Vector4 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr(); // Class
	m_Vector16 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr(); // Class
	m_Vector64 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr(); // Class
	m_Vector256 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtMyPropInit.h

}

void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Vector4);
	// Mp7JrsFactory::DeleteObject(m_Vector16);
	// Mp7JrsFactory::DeleteObject(m_Vector64);
	// Mp7JrsFactory::DeleteObject(m_Vector256);
}

void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MotionActivityType_SpatialLocalizationParams_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMotionActivityType_SpatialLocalizationParams_LocalType
    const Mp7JrsPtr< Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Vector4);
		this->SetVector4(Mp7JrsFactory::CloneObject(tmp->GetVector4()));
		// Mp7JrsFactory::DeleteObject(m_Vector16);
		this->SetVector16(Mp7JrsFactory::CloneObject(tmp->GetVector16()));
		// Mp7JrsFactory::DeleteObject(m_Vector64);
		this->SetVector64(Mp7JrsFactory::CloneObject(tmp->GetVector64()));
		// Mp7JrsFactory::DeleteObject(m_Vector256);
		this->SetVector256(Mp7JrsFactory::CloneObject(tmp->GetVector256()));
}

Mp7JrsNodePtr Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetVector4() const
{
	return m_Vector4;
}

Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetVector16() const
{
	return m_Vector16;
}

Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetVector64() const
{
	return m_Vector64;
}

Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetVector256() const
{
	return m_Vector256;
}

// implementing setter for choice 
/* element */
void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector4(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector4().");
	}
	if (m_Vector4 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Vector4);
		m_Vector4 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Vector4) m_Vector4->SetParent(m_myself.getPointer());
		if (m_Vector4 && m_Vector4->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector4_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Vector4->UseTypeAttribute = true;
		}
		if(m_Vector4 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Vector4->SetContentName(XMLString::transcode("Vector4"));
		}
	// Mp7JrsFactory::DeleteObject(m_Vector16);
	m_Vector16 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector64);
	m_Vector64 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector256);
	m_Vector256 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector16(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector16().");
	}
	if (m_Vector16 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Vector16);
		m_Vector16 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Vector16) m_Vector16->SetParent(m_myself.getPointer());
		if (m_Vector16 && m_Vector16->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector16_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Vector16->UseTypeAttribute = true;
		}
		if(m_Vector16 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Vector16->SetContentName(XMLString::transcode("Vector16"));
		}
	// Mp7JrsFactory::DeleteObject(m_Vector4);
	m_Vector4 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector64);
	m_Vector64 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector256);
	m_Vector256 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector64(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector64().");
	}
	if (m_Vector64 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Vector64);
		m_Vector64 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Vector64) m_Vector64->SetParent(m_myself.getPointer());
		if (m_Vector64 && m_Vector64->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector64_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Vector64->UseTypeAttribute = true;
		}
		if(m_Vector64 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Vector64->SetContentName(XMLString::transcode("Vector64"));
		}
	// Mp7JrsFactory::DeleteObject(m_Vector4);
	m_Vector4 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector16);
	m_Vector16 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector256);
	m_Vector256 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector256(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::SetVector256().");
	}
	if (m_Vector256 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Vector256);
		m_Vector256 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Vector256) m_Vector256->SetParent(m_myself.getPointer());
		if (m_Vector256 && m_Vector256->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector256_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Vector256->UseTypeAttribute = true;
		}
		if(m_Vector256 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Vector256->SetContentName(XMLString::transcode("Vector256"));
		}
	// Mp7JrsFactory::DeleteObject(m_Vector4);
	m_Vector4 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector16);
	m_Vector16 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr();
	// Mp7JrsFactory::DeleteObject(m_Vector64);
	m_Vector64 = Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Vector4")) == 0)
	{
		// Vector4 is simple element MotionActivityType_SpatialLocalizationParams_Vector4_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetVector4()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector4_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetVector4(p, client);
					if((p = GetVector4()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Vector16")) == 0)
	{
		// Vector16 is simple element MotionActivityType_SpatialLocalizationParams_Vector16_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetVector16()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector16_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetVector16(p, client);
					if((p = GetVector16()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Vector64")) == 0)
	{
		// Vector64 is simple element MotionActivityType_SpatialLocalizationParams_Vector64_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetVector64()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector64_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetVector64(p, client);
					if((p = GetVector64()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Vector256")) == 0)
	{
		// Vector256 is simple element MotionActivityType_SpatialLocalizationParams_Vector256_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetVector256()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MotionActivityType_SpatialLocalizationParams_Vector256_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetVector256(p, client);
					if((p = GetVector256()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MotionActivityType_SpatialLocalizationParams_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MotionActivityType_SpatialLocalizationParams_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::ContentToString() const
{
	// Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MotionActivityType_SpatialLocalizationParams_LocalType"));
	// Element serialization:
	// Class
	
	if (m_Vector4 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Vector4->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Vector4"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Vector4->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Vector16 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Vector16->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Vector16"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Vector16->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Vector64 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Vector64->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Vector64"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Vector64->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Vector256 != Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Vector256->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Vector256"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Vector256->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Vector4"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Vector4")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMotionActivityType_SpatialLocalizationParams_Vector4_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVector4(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Vector16"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Vector16")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMotionActivityType_SpatialLocalizationParams_Vector16_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVector16(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Vector64"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Vector64")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMotionActivityType_SpatialLocalizationParams_Vector64_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVector64(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Vector256"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Vector256")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMotionActivityType_SpatialLocalizationParams_Vector256_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVector256(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Vector4")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMotionActivityType_SpatialLocalizationParams_Vector4_LocalType;
    }
    this->SetVector4(child);
  }
  if (XMLString::compareString(elementname, X("Vector16")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMotionActivityType_SpatialLocalizationParams_Vector16_LocalType;
    }
    this->SetVector16(child);
  }
  if (XMLString::compareString(elementname, X("Vector64")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMotionActivityType_SpatialLocalizationParams_Vector64_LocalType;
    }
    this->SetVector64(child);
  }
  if (XMLString::compareString(elementname, X("Vector256")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMotionActivityType_SpatialLocalizationParams_Vector256_LocalType;
    }
    this->SetVector256(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetVector4() != Mp7JrsNodePtr())
		result.Insert(GetVector4());
	if (GetVector16() != Mp7JrsNodePtr())
		result.Insert(GetVector16());
	if (GetVector64() != Mp7JrsNodePtr())
		result.Insert(GetVector64());
	if (GetVector256() != Mp7JrsNodePtr())
		result.Insert(GetVector256());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtMethodImpl.h


