 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType_ExtImplInclude.h



#include "Mp7JrsSegmentType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::IMp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType_ExtPropInit.h

}

IMp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::~IMp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType_ExtPropCleanup.h

}

Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::~Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType()
{
	Cleanup();
}

void Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Segment = Mp7JrsPtr< Mp7JrsNode >(); // Class
	m_SegmentRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Segment);
	// Mp7JrsFactory::DeleteObject(m_SegmentRef);
}

void Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MultimediaSegmentMediaSourceDecompositionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMultimediaSegmentMediaSourceDecompositionType_LocalType
    const Mp7JrsPtr< Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Segment);
		this->SetSegment(Mp7JrsFactory::CloneObject(tmp->GetSegment()));
		// Mp7JrsFactory::DeleteObject(m_SegmentRef);
		this->SetSegmentRef(Mp7JrsFactory::CloneObject(tmp->GetSegmentRef()));
}

Mp7JrsNodePtr Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsPtr< Mp7JrsNode > Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::GetSegment() const
{
	return m_Segment;
}

Mp7JrsReferencePtr Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::GetSegmentRef() const
{
	return m_SegmentRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::SetSegment(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::SetSegment().");
	}
	if (m_Segment != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Segment);
		m_Segment = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Segment) m_Segment->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_Segment) m_Segment->UseTypeAttribute = true;
		if(m_Segment != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Segment->SetContentName(XMLString::transcode("Segment"));
		}
	// Mp7JrsFactory::DeleteObject(m_SegmentRef);
	m_SegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::SetSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::SetSegmentRef().");
	}
	if (m_SegmentRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SegmentRef);
		m_SegmentRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SegmentRef) m_SegmentRef->SetParent(m_myself.getPointer());
		if (m_SegmentRef && m_SegmentRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SegmentRef->UseTypeAttribute = true;
		}
		if(m_SegmentRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SegmentRef->SetContentName(XMLString::transcode("SegmentRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_Segment);
	m_Segment = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: MultimediaSegmentMediaSourceDecompositionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_Segment != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Segment->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Segment"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_Segment->UseTypeAttribute = true;
		}
		m_Segment->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_SegmentRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SegmentRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SegmentRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SegmentRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Segment"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Segment")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSegmentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSegment(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SegmentRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SegmentRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSegmentRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Segment")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSegmentType;
    }
    this->SetSegment(child);
  }
  if (XMLString::compareString(elementname, X("SegmentRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetSegmentRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSegment() != Mp7JrsNodePtr())
		result.Insert(GetSegment());
	if (GetSegmentRef() != Mp7JrsNodePtr())
		result.Insert(GetSegmentRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType_ExtMethodImpl.h


