 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtImplInclude.h



#include "Mp7JrsDependencyStructurePhraseType.h"
#include "Mp7JrsWordFormType.h"
#include "Mp7JrsNonDependencyStructurePhraseType.h"
#include "Mp7JrsNonDependencyStructurePhraseType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsNonDependencyStructurePhraseType_LocalType::IMp7JrsNonDependencyStructurePhraseType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtPropInit.h

}

IMp7JrsNonDependencyStructurePhraseType_LocalType::~IMp7JrsNonDependencyStructurePhraseType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtPropCleanup.h

}

Mp7JrsNonDependencyStructurePhraseType_LocalType::Mp7JrsNonDependencyStructurePhraseType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsNonDependencyStructurePhraseType_LocalType::~Mp7JrsNonDependencyStructurePhraseType_LocalType()
{
	Cleanup();
}

void Mp7JrsNonDependencyStructurePhraseType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Quotation = Mp7JrsDependencyStructurePhrasePtr(); // Class
	m_Phrase = Mp7JrsDependencyStructurePhrasePtr(); // Class
	m_Word = Mp7JrsWordFormPtr(); // Class
	m_NonDependencyPhrase = Mp7JrsNonDependencyStructurePhrasePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtMyPropInit.h

}

void Mp7JrsNonDependencyStructurePhraseType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Quotation);
	// Mp7JrsFactory::DeleteObject(m_Phrase);
	// Mp7JrsFactory::DeleteObject(m_Word);
	// Mp7JrsFactory::DeleteObject(m_NonDependencyPhrase);
}

void Mp7JrsNonDependencyStructurePhraseType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use NonDependencyStructurePhraseType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in INonDependencyStructurePhraseType_LocalType
    const Mp7JrsPtr< Mp7JrsNonDependencyStructurePhraseType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Quotation);
		this->SetQuotation(Mp7JrsFactory::CloneObject(tmp->GetQuotation()));
		// Mp7JrsFactory::DeleteObject(m_Phrase);
		this->SetPhrase(Mp7JrsFactory::CloneObject(tmp->GetPhrase()));
		// Mp7JrsFactory::DeleteObject(m_Word);
		this->SetWord(Mp7JrsFactory::CloneObject(tmp->GetWord()));
		// Mp7JrsFactory::DeleteObject(m_NonDependencyPhrase);
		this->SetNonDependencyPhrase(Mp7JrsFactory::CloneObject(tmp->GetNonDependencyPhrase()));
}

Mp7JrsNodePtr Mp7JrsNonDependencyStructurePhraseType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsNonDependencyStructurePhraseType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsDependencyStructurePhrasePtr Mp7JrsNonDependencyStructurePhraseType_LocalType::GetQuotation() const
{
	return m_Quotation;
}

Mp7JrsDependencyStructurePhrasePtr Mp7JrsNonDependencyStructurePhraseType_LocalType::GetPhrase() const
{
	return m_Phrase;
}

Mp7JrsWordFormPtr Mp7JrsNonDependencyStructurePhraseType_LocalType::GetWord() const
{
	return m_Word;
}

Mp7JrsNonDependencyStructurePhrasePtr Mp7JrsNonDependencyStructurePhraseType_LocalType::GetNonDependencyPhrase() const
{
	return m_NonDependencyPhrase;
}

// implementing setter for choice 
/* element */
void Mp7JrsNonDependencyStructurePhraseType_LocalType::SetQuotation(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonDependencyStructurePhraseType_LocalType::SetQuotation().");
	}
	if (m_Quotation != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Quotation);
		m_Quotation = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Quotation) m_Quotation->SetParent(m_myself.getPointer());
		if (m_Quotation && m_Quotation->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DependencyStructurePhraseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Quotation->UseTypeAttribute = true;
		}
		if(m_Quotation != Mp7JrsDependencyStructurePhrasePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Quotation->SetContentName(XMLString::transcode("Quotation"));
		}
	// Mp7JrsFactory::DeleteObject(m_Phrase);
	m_Phrase = Mp7JrsDependencyStructurePhrasePtr();
	// Mp7JrsFactory::DeleteObject(m_Word);
	m_Word = Mp7JrsWordFormPtr();
	// Mp7JrsFactory::DeleteObject(m_NonDependencyPhrase);
	m_NonDependencyPhrase = Mp7JrsNonDependencyStructurePhrasePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonDependencyStructurePhraseType_LocalType::SetPhrase(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonDependencyStructurePhraseType_LocalType::SetPhrase().");
	}
	if (m_Phrase != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Phrase);
		m_Phrase = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Phrase) m_Phrase->SetParent(m_myself.getPointer());
		if (m_Phrase && m_Phrase->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DependencyStructurePhraseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Phrase->UseTypeAttribute = true;
		}
		if(m_Phrase != Mp7JrsDependencyStructurePhrasePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Phrase->SetContentName(XMLString::transcode("Phrase"));
		}
	// Mp7JrsFactory::DeleteObject(m_Quotation);
	m_Quotation = Mp7JrsDependencyStructurePhrasePtr();
	// Mp7JrsFactory::DeleteObject(m_Word);
	m_Word = Mp7JrsWordFormPtr();
	// Mp7JrsFactory::DeleteObject(m_NonDependencyPhrase);
	m_NonDependencyPhrase = Mp7JrsNonDependencyStructurePhrasePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonDependencyStructurePhraseType_LocalType::SetWord(const Mp7JrsWordFormPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonDependencyStructurePhraseType_LocalType::SetWord().");
	}
	if (m_Word != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Word);
		m_Word = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Word) m_Word->SetParent(m_myself.getPointer());
		if (m_Word && m_Word->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:WordFormType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Word->UseTypeAttribute = true;
		}
		if(m_Word != Mp7JrsWordFormPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Word->SetContentName(XMLString::transcode("Word"));
		}
	// Mp7JrsFactory::DeleteObject(m_Quotation);
	m_Quotation = Mp7JrsDependencyStructurePhrasePtr();
	// Mp7JrsFactory::DeleteObject(m_Phrase);
	m_Phrase = Mp7JrsDependencyStructurePhrasePtr();
	// Mp7JrsFactory::DeleteObject(m_NonDependencyPhrase);
	m_NonDependencyPhrase = Mp7JrsNonDependencyStructurePhrasePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonDependencyStructurePhraseType_LocalType::SetNonDependencyPhrase(const Mp7JrsNonDependencyStructurePhrasePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonDependencyStructurePhraseType_LocalType::SetNonDependencyPhrase().");
	}
	if (m_NonDependencyPhrase != item)
	{
		// Mp7JrsFactory::DeleteObject(m_NonDependencyPhrase);
		m_NonDependencyPhrase = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_NonDependencyPhrase) m_NonDependencyPhrase->SetParent(m_myself.getPointer());
		if (m_NonDependencyPhrase && m_NonDependencyPhrase->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:NonDependencyStructurePhraseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_NonDependencyPhrase->UseTypeAttribute = true;
		}
		if(m_NonDependencyPhrase != Mp7JrsNonDependencyStructurePhrasePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_NonDependencyPhrase->SetContentName(XMLString::transcode("NonDependencyPhrase"));
		}
	// Mp7JrsFactory::DeleteObject(m_Quotation);
	m_Quotation = Mp7JrsDependencyStructurePhrasePtr();
	// Mp7JrsFactory::DeleteObject(m_Phrase);
	m_Phrase = Mp7JrsDependencyStructurePhrasePtr();
	// Mp7JrsFactory::DeleteObject(m_Word);
	m_Word = Mp7JrsWordFormPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: NonDependencyStructurePhraseType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsNonDependencyStructurePhraseType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsNonDependencyStructurePhraseType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsNonDependencyStructurePhraseType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsNonDependencyStructurePhraseType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_Quotation != Mp7JrsDependencyStructurePhrasePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Quotation->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Quotation"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Quotation->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Phrase != Mp7JrsDependencyStructurePhrasePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Phrase->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Phrase"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Phrase->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Word != Mp7JrsWordFormPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Word->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Word"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Word->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_NonDependencyPhrase != Mp7JrsNonDependencyStructurePhrasePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_NonDependencyPhrase->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("NonDependencyPhrase"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_NonDependencyPhrase->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsNonDependencyStructurePhraseType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Quotation"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Quotation")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateDependencyStructurePhraseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetQuotation(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Phrase"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Phrase")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateDependencyStructurePhraseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPhrase(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Word"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Word")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateWordFormType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetWord(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("NonDependencyPhrase"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("NonDependencyPhrase")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateNonDependencyStructurePhraseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetNonDependencyPhrase(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsNonDependencyStructurePhraseType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Quotation")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateDependencyStructurePhraseType;
    }
    this->SetQuotation(child);
  }
  if (XMLString::compareString(elementname, X("Phrase")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateDependencyStructurePhraseType;
    }
    this->SetPhrase(child);
  }
  if (XMLString::compareString(elementname, X("Word")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateWordFormType;
    }
    this->SetWord(child);
  }
  if (XMLString::compareString(elementname, X("NonDependencyPhrase")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateNonDependencyStructurePhraseType;
    }
    this->SetNonDependencyPhrase(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsNonDependencyStructurePhraseType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetQuotation() != Mp7JrsNodePtr())
		result.Insert(GetQuotation());
	if (GetPhrase() != Mp7JrsNodePtr())
		result.Insert(GetPhrase());
	if (GetWord() != Mp7JrsNodePtr())
		result.Insert(GetWord());
	if (GetNonDependencyPhrase() != Mp7JrsNodePtr())
		result.Insert(GetNonDependencyPhrase());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtMethodImpl.h


