 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtImplInclude.h



#include "Mp7Jrsunsigned11.h"
#include "Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType.h"
#include "Mp7JrsNonMixtureAmountOfMotionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsNonMixtureAmountOfMotionType::IMp7JrsNonMixtureAmountOfMotionType()
{

// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtPropInit.h

}

IMp7JrsNonMixtureAmountOfMotionType::~IMp7JrsNonMixtureAmountOfMotionType()
{
// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtPropCleanup.h

}

Mp7JrsNonMixtureAmountOfMotionType::Mp7JrsNonMixtureAmountOfMotionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsNonMixtureAmountOfMotionType::~Mp7JrsNonMixtureAmountOfMotionType()
{
	Cleanup();
}

void Mp7JrsNonMixtureAmountOfMotionType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_TrackLeft = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_TrackRight = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_BoomDown = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_BoomUp = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_DollyForward = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_DollyBackward = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_PanLeft = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_PanRight = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_TiltDown = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_TiltUp = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_RollClockwise = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_ZoomIn = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_ZoomOut = Mp7Jrsunsigned11Ptr(); // Class with content 
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMyPropInit.h

}

void Mp7JrsNonMixtureAmountOfMotionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	// Mp7JrsFactory::DeleteObject(m_Fixed);
}

void Mp7JrsNonMixtureAmountOfMotionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use NonMixtureAmountOfMotionTypePtr, since we
	// might need GetBase(), which isn't defined in INonMixtureAmountOfMotionType
    const Mp7JrsPtr< Mp7JrsNonMixtureAmountOfMotionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_TrackLeft);
		this->SetTrackLeft(Mp7JrsFactory::CloneObject(tmp->GetTrackLeft()));
		// Mp7JrsFactory::DeleteObject(m_TrackRight);
		this->SetTrackRight(Mp7JrsFactory::CloneObject(tmp->GetTrackRight()));
		// Mp7JrsFactory::DeleteObject(m_BoomDown);
		this->SetBoomDown(Mp7JrsFactory::CloneObject(tmp->GetBoomDown()));
		// Mp7JrsFactory::DeleteObject(m_BoomUp);
		this->SetBoomUp(Mp7JrsFactory::CloneObject(tmp->GetBoomUp()));
		// Mp7JrsFactory::DeleteObject(m_DollyForward);
		this->SetDollyForward(Mp7JrsFactory::CloneObject(tmp->GetDollyForward()));
		// Mp7JrsFactory::DeleteObject(m_DollyBackward);
		this->SetDollyBackward(Mp7JrsFactory::CloneObject(tmp->GetDollyBackward()));
		// Mp7JrsFactory::DeleteObject(m_PanLeft);
		this->SetPanLeft(Mp7JrsFactory::CloneObject(tmp->GetPanLeft()));
		// Mp7JrsFactory::DeleteObject(m_PanRight);
		this->SetPanRight(Mp7JrsFactory::CloneObject(tmp->GetPanRight()));
		// Mp7JrsFactory::DeleteObject(m_TiltDown);
		this->SetTiltDown(Mp7JrsFactory::CloneObject(tmp->GetTiltDown()));
		// Mp7JrsFactory::DeleteObject(m_TiltUp);
		this->SetTiltUp(Mp7JrsFactory::CloneObject(tmp->GetTiltUp()));
		// Mp7JrsFactory::DeleteObject(m_RollClockwise);
		this->SetRollClockwise(Mp7JrsFactory::CloneObject(tmp->GetRollClockwise()));
		// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
		this->SetRollAnticlockwise(Mp7JrsFactory::CloneObject(tmp->GetRollAnticlockwise()));
		// Mp7JrsFactory::DeleteObject(m_ZoomIn);
		this->SetZoomIn(Mp7JrsFactory::CloneObject(tmp->GetZoomIn()));
		// Mp7JrsFactory::DeleteObject(m_ZoomOut);
		this->SetZoomOut(Mp7JrsFactory::CloneObject(tmp->GetZoomOut()));
		// Mp7JrsFactory::DeleteObject(m_Fixed);
		this->SetFixed(Mp7JrsFactory::CloneObject(tmp->GetFixed()));
}

Mp7JrsNodePtr Mp7JrsNonMixtureAmountOfMotionType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsNonMixtureAmountOfMotionType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetTrackLeft() const
{
	return m_TrackLeft;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetTrackRight() const
{
	return m_TrackRight;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetBoomDown() const
{
	return m_BoomDown;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetBoomUp() const
{
	return m_BoomUp;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetDollyForward() const
{
	return m_DollyForward;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetDollyBackward() const
{
	return m_DollyBackward;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetPanLeft() const
{
	return m_PanLeft;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetPanRight() const
{
	return m_PanRight;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetTiltDown() const
{
	return m_TiltDown;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetTiltUp() const
{
	return m_TiltUp;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetRollClockwise() const
{
	return m_RollClockwise;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetRollAnticlockwise() const
{
	return m_RollAnticlockwise;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetZoomIn() const
{
	return m_ZoomIn;
}

Mp7Jrsunsigned11Ptr Mp7JrsNonMixtureAmountOfMotionType::GetZoomOut() const
{
	return m_ZoomOut;
}

Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr Mp7JrsNonMixtureAmountOfMotionType::GetFixed() const
{
	return m_Fixed;
}

// implementing setter for choice 
/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetTrackLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetTrackLeft().");
	}
	if (m_TrackLeft != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TrackLeft);
		m_TrackLeft = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TrackLeft) m_TrackLeft->SetParent(m_myself.getPointer());
		if (m_TrackLeft && m_TrackLeft->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TrackLeft->UseTypeAttribute = true;
		}
		if(m_TrackLeft != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TrackLeft->SetContentName(XMLString::transcode("TrackLeft"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetTrackRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetTrackRight().");
	}
	if (m_TrackRight != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TrackRight);
		m_TrackRight = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TrackRight) m_TrackRight->SetParent(m_myself.getPointer());
		if (m_TrackRight && m_TrackRight->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TrackRight->UseTypeAttribute = true;
		}
		if(m_TrackRight != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TrackRight->SetContentName(XMLString::transcode("TrackRight"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetBoomDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetBoomDown().");
	}
	if (m_BoomDown != item)
	{
		// Mp7JrsFactory::DeleteObject(m_BoomDown);
		m_BoomDown = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_BoomDown) m_BoomDown->SetParent(m_myself.getPointer());
		if (m_BoomDown && m_BoomDown->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_BoomDown->UseTypeAttribute = true;
		}
		if(m_BoomDown != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_BoomDown->SetContentName(XMLString::transcode("BoomDown"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetBoomUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetBoomUp().");
	}
	if (m_BoomUp != item)
	{
		// Mp7JrsFactory::DeleteObject(m_BoomUp);
		m_BoomUp = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_BoomUp) m_BoomUp->SetParent(m_myself.getPointer());
		if (m_BoomUp && m_BoomUp->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_BoomUp->UseTypeAttribute = true;
		}
		if(m_BoomUp != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_BoomUp->SetContentName(XMLString::transcode("BoomUp"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetDollyForward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetDollyForward().");
	}
	if (m_DollyForward != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DollyForward);
		m_DollyForward = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DollyForward) m_DollyForward->SetParent(m_myself.getPointer());
		if (m_DollyForward && m_DollyForward->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_DollyForward->UseTypeAttribute = true;
		}
		if(m_DollyForward != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_DollyForward->SetContentName(XMLString::transcode("DollyForward"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetDollyBackward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetDollyBackward().");
	}
	if (m_DollyBackward != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DollyBackward);
		m_DollyBackward = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DollyBackward) m_DollyBackward->SetParent(m_myself.getPointer());
		if (m_DollyBackward && m_DollyBackward->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_DollyBackward->UseTypeAttribute = true;
		}
		if(m_DollyBackward != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_DollyBackward->SetContentName(XMLString::transcode("DollyBackward"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetPanLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetPanLeft().");
	}
	if (m_PanLeft != item)
	{
		// Mp7JrsFactory::DeleteObject(m_PanLeft);
		m_PanLeft = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PanLeft) m_PanLeft->SetParent(m_myself.getPointer());
		if (m_PanLeft && m_PanLeft->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_PanLeft->UseTypeAttribute = true;
		}
		if(m_PanLeft != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PanLeft->SetContentName(XMLString::transcode("PanLeft"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetPanRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetPanRight().");
	}
	if (m_PanRight != item)
	{
		// Mp7JrsFactory::DeleteObject(m_PanRight);
		m_PanRight = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PanRight) m_PanRight->SetParent(m_myself.getPointer());
		if (m_PanRight && m_PanRight->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_PanRight->UseTypeAttribute = true;
		}
		if(m_PanRight != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PanRight->SetContentName(XMLString::transcode("PanRight"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetTiltDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetTiltDown().");
	}
	if (m_TiltDown != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TiltDown);
		m_TiltDown = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TiltDown) m_TiltDown->SetParent(m_myself.getPointer());
		if (m_TiltDown && m_TiltDown->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TiltDown->UseTypeAttribute = true;
		}
		if(m_TiltDown != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TiltDown->SetContentName(XMLString::transcode("TiltDown"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetTiltUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetTiltUp().");
	}
	if (m_TiltUp != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TiltUp);
		m_TiltUp = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TiltUp) m_TiltUp->SetParent(m_myself.getPointer());
		if (m_TiltUp && m_TiltUp->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TiltUp->UseTypeAttribute = true;
		}
		if(m_TiltUp != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TiltUp->SetContentName(XMLString::transcode("TiltUp"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetRollClockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetRollClockwise().");
	}
	if (m_RollClockwise != item)
	{
		// Mp7JrsFactory::DeleteObject(m_RollClockwise);
		m_RollClockwise = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_RollClockwise) m_RollClockwise->SetParent(m_myself.getPointer());
		if (m_RollClockwise && m_RollClockwise->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_RollClockwise->UseTypeAttribute = true;
		}
		if(m_RollClockwise != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_RollClockwise->SetContentName(XMLString::transcode("RollClockwise"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetRollAnticlockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetRollAnticlockwise().");
	}
	if (m_RollAnticlockwise != item)
	{
		// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
		m_RollAnticlockwise = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_RollAnticlockwise) m_RollAnticlockwise->SetParent(m_myself.getPointer());
		if (m_RollAnticlockwise && m_RollAnticlockwise->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_RollAnticlockwise->UseTypeAttribute = true;
		}
		if(m_RollAnticlockwise != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_RollAnticlockwise->SetContentName(XMLString::transcode("RollAnticlockwise"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetZoomIn(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetZoomIn().");
	}
	if (m_ZoomIn != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ZoomIn);
		m_ZoomIn = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ZoomIn) m_ZoomIn->SetParent(m_myself.getPointer());
		if (m_ZoomIn && m_ZoomIn->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ZoomIn->UseTypeAttribute = true;
		}
		if(m_ZoomIn != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ZoomIn->SetContentName(XMLString::transcode("ZoomIn"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetZoomOut(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetZoomOut().");
	}
	if (m_ZoomOut != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ZoomOut);
		m_ZoomOut = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ZoomOut) m_ZoomOut->SetParent(m_myself.getPointer());
		if (m_ZoomOut && m_ZoomOut->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ZoomOut->UseTypeAttribute = true;
		}
		if(m_ZoomOut != Mp7Jrsunsigned11Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ZoomOut->SetContentName(XMLString::transcode("ZoomOut"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_Fixed);
	m_Fixed = Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsNonMixtureAmountOfMotionType::SetFixed(const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureAmountOfMotionType::SetFixed().");
	}
	if (m_Fixed != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Fixed);
		m_Fixed = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Fixed) m_Fixed->SetParent(m_myself.getPointer());
		if (m_Fixed && m_Fixed->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:NonMixtureAmountOfMotionType_Fixed_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Fixed->UseTypeAttribute = true;
		}
		if(m_Fixed != Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Fixed->SetContentName(XMLString::transcode("Fixed"));
		}
	// Mp7JrsFactory::DeleteObject(m_TrackLeft);
	m_TrackLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TrackRight);
	m_TrackRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomDown);
	m_BoomDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_BoomUp);
	m_BoomUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyForward);
	m_DollyForward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_DollyBackward);
	m_DollyBackward = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanLeft);
	m_PanLeft = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_PanRight);
	m_PanRight = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltDown);
	m_TiltDown = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_TiltUp);
	m_TiltUp = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollClockwise);
	m_RollClockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_RollAnticlockwise);
	m_RollAnticlockwise = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomIn);
	m_ZoomIn = Mp7Jrsunsigned11Ptr();
	// Mp7JrsFactory::DeleteObject(m_ZoomOut);
	m_ZoomOut = Mp7Jrsunsigned11Ptr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsNonMixtureAmountOfMotionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("TrackLeft")) == 0)
	{
		// TrackLeft is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTrackLeft()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTrackLeft(p, client);
					if((p = GetTrackLeft()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TrackRight")) == 0)
	{
		// TrackRight is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTrackRight()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTrackRight(p, client);
					if((p = GetTrackRight()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("BoomDown")) == 0)
	{
		// BoomDown is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetBoomDown()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetBoomDown(p, client);
					if((p = GetBoomDown()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("BoomUp")) == 0)
	{
		// BoomUp is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetBoomUp()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetBoomUp(p, client);
					if((p = GetBoomUp()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("DollyForward")) == 0)
	{
		// DollyForward is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetDollyForward()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetDollyForward(p, client);
					if((p = GetDollyForward()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("DollyBackward")) == 0)
	{
		// DollyBackward is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetDollyBackward()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetDollyBackward(p, client);
					if((p = GetDollyBackward()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PanLeft")) == 0)
	{
		// PanLeft is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPanLeft()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPanLeft(p, client);
					if((p = GetPanLeft()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PanRight")) == 0)
	{
		// PanRight is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPanRight()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPanRight(p, client);
					if((p = GetPanRight()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TiltDown")) == 0)
	{
		// TiltDown is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTiltDown()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTiltDown(p, client);
					if((p = GetTiltDown()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TiltUp")) == 0)
	{
		// TiltUp is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTiltUp()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTiltUp(p, client);
					if((p = GetTiltUp()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("RollClockwise")) == 0)
	{
		// RollClockwise is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetRollClockwise()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetRollClockwise(p, client);
					if((p = GetRollClockwise()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("RollAnticlockwise")) == 0)
	{
		// RollAnticlockwise is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetRollAnticlockwise()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetRollAnticlockwise(p, client);
					if((p = GetRollAnticlockwise()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ZoomIn")) == 0)
	{
		// ZoomIn is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetZoomIn()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetZoomIn(p, client);
					if((p = GetZoomIn()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ZoomOut")) == 0)
	{
		// ZoomOut is simple element unsigned11
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetZoomOut()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned11")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned11Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetZoomOut(p, client);
					if((p = GetZoomOut()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Fixed")) == 0)
	{
		// Fixed is simple element NonMixtureAmountOfMotionType_Fixed_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetFixed()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:NonMixtureAmountOfMotionType_Fixed_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetFixed(p, client);
					if((p = GetFixed()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for NonMixtureAmountOfMotionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "NonMixtureAmountOfMotionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsNonMixtureAmountOfMotionType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsNonMixtureAmountOfMotionType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsNonMixtureAmountOfMotionType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsNonMixtureAmountOfMotionType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsNonMixtureAmountOfMotionType::ContentToString() const
{
	// Mp7JrsNonMixtureAmountOfMotionType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsNonMixtureAmountOfMotionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("NonMixtureAmountOfMotionType"));
	// Element serialization:
	// Class with content		
	
	if (m_TrackLeft != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TrackLeft->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TrackLeft"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TrackLeft->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_TrackRight != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TrackRight->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TrackRight"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TrackRight->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_BoomDown != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_BoomDown->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("BoomDown"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_BoomDown->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_BoomUp != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_BoomUp->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("BoomUp"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_BoomUp->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_DollyForward != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_DollyForward->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("DollyForward"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_DollyForward->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_DollyBackward != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_DollyBackward->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("DollyBackward"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_DollyBackward->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_PanLeft != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_PanLeft->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("PanLeft"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_PanLeft->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_PanRight != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_PanRight->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("PanRight"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_PanRight->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_TiltDown != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TiltDown->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TiltDown"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TiltDown->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_TiltUp != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TiltUp->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TiltUp"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TiltUp->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_RollClockwise != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_RollClockwise->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("RollClockwise"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_RollClockwise->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_RollAnticlockwise != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_RollAnticlockwise->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("RollAnticlockwise"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_RollAnticlockwise->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_ZoomIn != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ZoomIn->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ZoomIn"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ZoomIn->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_ZoomOut != Mp7Jrsunsigned11Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ZoomOut->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ZoomOut"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ZoomOut->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Fixed != Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Fixed->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Fixed"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Fixed->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsNonMixtureAmountOfMotionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TrackLeft"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TrackLeft")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTrackLeft(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TrackRight"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TrackRight")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTrackRight(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("BoomDown"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("BoomDown")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetBoomDown(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("BoomUp"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("BoomUp")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetBoomUp(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("DollyForward"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("DollyForward")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetDollyForward(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("DollyBackward"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("DollyBackward")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetDollyBackward(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("PanLeft"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("PanLeft")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPanLeft(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("PanRight"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("PanRight")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPanRight(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TiltDown"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TiltDown")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTiltDown(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TiltUp"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TiltUp")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTiltUp(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("RollClockwise"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("RollClockwise")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetRollClockwise(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("RollAnticlockwise"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("RollAnticlockwise")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetRollAnticlockwise(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ZoomIn"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ZoomIn")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetZoomIn(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ZoomOut"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ZoomOut")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned11;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetZoomOut(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Fixed"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Fixed")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateNonMixtureAmountOfMotionType_Fixed_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFixed(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsNonMixtureAmountOfMotionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("TrackLeft")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetTrackLeft(child);
  }
  if (XMLString::compareString(elementname, X("TrackRight")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetTrackRight(child);
  }
  if (XMLString::compareString(elementname, X("BoomDown")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetBoomDown(child);
  }
  if (XMLString::compareString(elementname, X("BoomUp")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetBoomUp(child);
  }
  if (XMLString::compareString(elementname, X("DollyForward")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetDollyForward(child);
  }
  if (XMLString::compareString(elementname, X("DollyBackward")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetDollyBackward(child);
  }
  if (XMLString::compareString(elementname, X("PanLeft")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetPanLeft(child);
  }
  if (XMLString::compareString(elementname, X("PanRight")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetPanRight(child);
  }
  if (XMLString::compareString(elementname, X("TiltDown")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetTiltDown(child);
  }
  if (XMLString::compareString(elementname, X("TiltUp")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetTiltUp(child);
  }
  if (XMLString::compareString(elementname, X("RollClockwise")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetRollClockwise(child);
  }
  if (XMLString::compareString(elementname, X("RollAnticlockwise")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetRollAnticlockwise(child);
  }
  if (XMLString::compareString(elementname, X("ZoomIn")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetZoomIn(child);
  }
  if (XMLString::compareString(elementname, X("ZoomOut")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned11;
    }
    this->SetZoomOut(child);
  }
  if (XMLString::compareString(elementname, X("Fixed")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateNonMixtureAmountOfMotionType_Fixed_LocalType;
    }
    this->SetFixed(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsNonMixtureAmountOfMotionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTrackLeft() != Mp7JrsNodePtr())
		result.Insert(GetTrackLeft());
	if (GetTrackRight() != Mp7JrsNodePtr())
		result.Insert(GetTrackRight());
	if (GetBoomDown() != Mp7JrsNodePtr())
		result.Insert(GetBoomDown());
	if (GetBoomUp() != Mp7JrsNodePtr())
		result.Insert(GetBoomUp());
	if (GetDollyForward() != Mp7JrsNodePtr())
		result.Insert(GetDollyForward());
	if (GetDollyBackward() != Mp7JrsNodePtr())
		result.Insert(GetDollyBackward());
	if (GetPanLeft() != Mp7JrsNodePtr())
		result.Insert(GetPanLeft());
	if (GetPanRight() != Mp7JrsNodePtr())
		result.Insert(GetPanRight());
	if (GetTiltDown() != Mp7JrsNodePtr())
		result.Insert(GetTiltDown());
	if (GetTiltUp() != Mp7JrsNodePtr())
		result.Insert(GetTiltUp());
	if (GetRollClockwise() != Mp7JrsNodePtr())
		result.Insert(GetRollClockwise());
	if (GetRollAnticlockwise() != Mp7JrsNodePtr())
		result.Insert(GetRollAnticlockwise());
	if (GetZoomIn() != Mp7JrsNodePtr())
		result.Insert(GetZoomIn());
	if (GetZoomOut() != Mp7JrsNodePtr())
		result.Insert(GetZoomOut());
	if (GetFixed() != Mp7JrsNodePtr())
		result.Insert(GetFixed());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMethodImpl.h


