 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtImplInclude.h



#include "Mp7JrsCameraMotionSegmentType.h"
#include "Mp7JrsNonMixtureAmountOfMotionType.h"
#include "Mp7JrsMediaTimeType.h"
#include "Mp7JrsFocusOfExpansionType.h"
#include "Mp7JrsNonMixtureCameraMotionSegmentType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsNonMixtureCameraMotionSegmentType::IMp7JrsNonMixtureCameraMotionSegmentType()
{

// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtPropInit.h

}

IMp7JrsNonMixtureCameraMotionSegmentType::~IMp7JrsNonMixtureCameraMotionSegmentType()
{
// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtPropCleanup.h

}

Mp7JrsNonMixtureCameraMotionSegmentType::Mp7JrsNonMixtureCameraMotionSegmentType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsNonMixtureCameraMotionSegmentType::~Mp7JrsNonMixtureCameraMotionSegmentType()
{
	Cleanup();
}

void Mp7JrsNonMixtureCameraMotionSegmentType::Init()
{
	// Init base
	m_Base = CreateCameraMotionSegmentType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_AmountOfMotion = Mp7JrsNonMixtureAmountOfMotionPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtMyPropInit.h

}

void Mp7JrsNonMixtureCameraMotionSegmentType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_AmountOfMotion);
}

void Mp7JrsNonMixtureCameraMotionSegmentType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use NonMixtureCameraMotionSegmentTypePtr, since we
	// might need GetBase(), which isn't defined in INonMixtureCameraMotionSegmentType
    const Mp7JrsPtr< Mp7JrsNonMixtureCameraMotionSegmentType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsCameraMotionSegmentPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsNonMixtureCameraMotionSegmentType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_AmountOfMotion);
		this->SetAmountOfMotion(Mp7JrsFactory::CloneObject(tmp->GetAmountOfMotion()));
}

Mp7JrsNodePtr Mp7JrsNonMixtureCameraMotionSegmentType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsNonMixtureCameraMotionSegmentType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsCameraMotionSegmentType > Mp7JrsNonMixtureCameraMotionSegmentType::GetBase() const
{
	return m_Base;
}

Mp7JrsNonMixtureAmountOfMotionPtr Mp7JrsNonMixtureCameraMotionSegmentType::GetAmountOfMotion() const
{
	return m_AmountOfMotion;
}

void Mp7JrsNonMixtureCameraMotionSegmentType::SetAmountOfMotion(const Mp7JrsNonMixtureAmountOfMotionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureCameraMotionSegmentType::SetAmountOfMotion().");
	}
	if (m_AmountOfMotion != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AmountOfMotion);
		m_AmountOfMotion = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AmountOfMotion) m_AmountOfMotion->SetParent(m_myself.getPointer());
		if (m_AmountOfMotion && m_AmountOfMotion->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:NonMixtureAmountOfMotionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AmountOfMotion->UseTypeAttribute = true;
		}
		if(m_AmountOfMotion != Mp7JrsNonMixtureAmountOfMotionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AmountOfMotion->SetContentName(XMLString::transcode("AmountOfMotion"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsMediaTimePtr Mp7JrsNonMixtureCameraMotionSegmentType::GetMediaTime() const
{
	return GetBase()->GetMediaTime();
}

Mp7JrsFocusOfExpansionPtr Mp7JrsNonMixtureCameraMotionSegmentType::GetFocusOfExpansion() const
{
	return GetBase()->GetFocusOfExpansion();
}

// Element is optional
bool Mp7JrsNonMixtureCameraMotionSegmentType::IsValidFocusOfExpansion() const
{
	return GetBase()->IsValidFocusOfExpansion();
}

void Mp7JrsNonMixtureCameraMotionSegmentType::SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureCameraMotionSegmentType::SetMediaTime().");
	}
	GetBase()->SetMediaTime(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsNonMixtureCameraMotionSegmentType::SetFocusOfExpansion(const Mp7JrsFocusOfExpansionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsNonMixtureCameraMotionSegmentType::SetFocusOfExpansion().");
	}
	GetBase()->SetFocusOfExpansion(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsNonMixtureCameraMotionSegmentType::InvalidateFocusOfExpansion()
{
	GetBase()->InvalidateFocusOfExpansion();
}

Mp7JrsNodeEnum Mp7JrsNonMixtureCameraMotionSegmentType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("AmountOfMotion")) == 0)
	{
		// AmountOfMotion is simple element NonMixtureAmountOfMotionType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetAmountOfMotion()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:NonMixtureAmountOfMotionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsNonMixtureAmountOfMotionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetAmountOfMotion(p, client);
					if((p = GetAmountOfMotion()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for NonMixtureCameraMotionSegmentType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "NonMixtureCameraMotionSegmentType");
	}		
	
	return result;
}

XMLCh * Mp7JrsNonMixtureCameraMotionSegmentType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsNonMixtureCameraMotionSegmentType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsNonMixtureCameraMotionSegmentType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsNonMixtureCameraMotionSegmentType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsNonMixtureCameraMotionSegmentType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("NonMixtureCameraMotionSegmentType"));
	// Element serialization:
	// Class
	
	if (m_AmountOfMotion != Mp7JrsNonMixtureAmountOfMotionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AmountOfMotion->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AmountOfMotion"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AmountOfMotion->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsNonMixtureCameraMotionSegmentType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsCameraMotionSegmentType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AmountOfMotion"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AmountOfMotion")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateNonMixtureAmountOfMotionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAmountOfMotion(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsNonMixtureCameraMotionSegmentType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("AmountOfMotion")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateNonMixtureAmountOfMotionType;
    }
    this->SetAmountOfMotion(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsNonMixtureCameraMotionSegmentType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetAmountOfMotion() != Mp7JrsNodePtr())
		result.Insert(GetAmountOfMotion());
	if (GetMediaTime() != Mp7JrsNodePtr())
		result.Insert(GetMediaTime());
	if (GetFocusOfExpansion() != Mp7JrsNodePtr())
		result.Insert(GetFocusOfExpansion());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsNonMixtureCameraMotionSegmentType_ExtMethodImpl.h


