 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtImplInclude.h



#include "Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtPropInit.h

}

IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::~IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtPropCleanup.h

}

Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::~Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType()
{
	Cleanup();
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::Init()
{

	// Init attributes
	m_setRef = NULL; // String
	m_setRef_Exist = false;
	m_startComponent = 0; // Value
	m_startComponent_Exist = false;
	m_startUnit = 0; // Value
	m_startUnit_Exist = false;
	m_endComponent = 0; // Value
	m_endComponent_Exist = false;
	m_endUnit = 0; // Value
	m_endUnit_Exist = false;



// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtMyPropInit.h

}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_setRef);
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use OrderedGroupDataSetMaskType_SubInterval_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IOrderedGroupDataSetMaskType_SubInterval_LocalType
    const Mp7JrsPtr< Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	XMLString::release(&m_setRef);
	if (tmp->ExistsetRef())
	{
		this->SetsetRef(XMLString::replicate(tmp->GetsetRef()));
	}
	else
	{
		InvalidatesetRef();
	}
	}
	{
	if (tmp->ExiststartComponent())
	{
		this->SetstartComponent(tmp->GetstartComponent());
	}
	else
	{
		InvalidatestartComponent();
	}
	}
	{
	if (tmp->ExiststartUnit())
	{
		this->SetstartUnit(tmp->GetstartUnit());
	}
	else
	{
		InvalidatestartUnit();
	}
	}
	{
	if (tmp->ExistendComponent())
	{
		this->SetendComponent(tmp->GetendComponent());
	}
	else
	{
		InvalidateendComponent();
	}
	}
	{
	if (tmp->ExistendUnit())
	{
		this->SetendUnit(tmp->GetendUnit());
	}
	else
	{
		InvalidateendUnit();
	}
	}
}

Mp7JrsNodePtr Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetsetRef() const
{
	return m_setRef;
}

bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ExistsetRef() const
{
	return m_setRef_Exist;
}
void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetsetRef(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetsetRef().");
	}
    m_setRef = item;
	m_setRef_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::InvalidatesetRef()
{
	m_setRef_Exist = false;
}
unsigned Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetstartComponent() const
{
	return m_startComponent;
}

bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ExiststartComponent() const
{
	return m_startComponent_Exist;
}
void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetstartComponent(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetstartComponent().");
	}
    m_startComponent = item;
	m_startComponent_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::InvalidatestartComponent()
{
	m_startComponent_Exist = false;
}
unsigned Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetstartUnit() const
{
	return m_startUnit;
}

bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ExiststartUnit() const
{
	return m_startUnit_Exist;
}
void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetstartUnit(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetstartUnit().");
	}
    m_startUnit = item;
	m_startUnit_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::InvalidatestartUnit()
{
	m_startUnit_Exist = false;
}
unsigned Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetendComponent() const
{
	return m_endComponent;
}

bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ExistendComponent() const
{
	return m_endComponent_Exist;
}
void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetendComponent(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetendComponent().");
	}
    m_endComponent = item;
	m_endComponent_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::InvalidateendComponent()
{
	m_endComponent_Exist = false;
}
unsigned Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetendUnit() const
{
	return m_endUnit;
}

bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ExistendUnit() const
{
	return m_endUnit_Exist;
}
void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetendUnit(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::SetendUnit().");
	}
    m_endUnit = item;
	m_endUnit_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::InvalidateendUnit()
{
	m_endUnit_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::ContentToString() const
{
	// Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("OrderedGroupDataSetMaskType_SubInterval_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_setRef_Exist)
	{
	// String
	if(m_setRef != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("setRef"), m_setRef);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_startComponent_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_startComponent);
		element->setAttributeNS(X(""), X("startComponent"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_startUnit_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_startUnit);
		element->setAttributeNS(X(""), X("startUnit"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_endComponent_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_endComponent);
		element->setAttributeNS(X(""), X("endComponent"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_endUnit_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_endUnit);
		element->setAttributeNS(X(""), X("endUnit"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("setRef")))
	{
        // Deserialize string type
        this->SetsetRef(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("setRef"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("setRef")))
	{
        // Deserialize string type
        this->SetsetRef(Mp7JrsConvert::TextToString(parent->getAttribute(X("setRef"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("startComponent")))
	{
        // deserialize value type
        this->SetstartComponent(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("startComponent"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("startComponent")))
	{
        // deserialize value type
        this->SetstartComponent(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("startComponent"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("startUnit")))
	{
        // deserialize value type
        this->SetstartUnit(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("startUnit"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("startUnit")))
	{
        // deserialize value type
        this->SetstartUnit(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("startUnit"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("endComponent")))
	{
        // deserialize value type
        this->SetendComponent(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("endComponent"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("endComponent")))
	{
        // deserialize value type
        this->SetendComponent(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("endComponent"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("endUnit")))
	{
        // deserialize value type
        this->SetendUnit(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("endUnit"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("endUnit")))
	{
        // deserialize value type
        this->SetendUnit(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("endUnit"))));
        * current = parent;
    }

// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtMethodImpl.h


