 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtImplInclude.h



#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Definition_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsPersonGroupType_NameTerm_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Definition
#include "Mp7JrsInlineTermDefinitionType_Term_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Term

#include <assert.h>
IMp7JrsPersonGroupType_NameTerm_LocalType::IMp7JrsPersonGroupType_NameTerm_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtPropInit.h

}

IMp7JrsPersonGroupType_NameTerm_LocalType::~IMp7JrsPersonGroupType_NameTerm_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtPropCleanup.h

}

Mp7JrsPersonGroupType_NameTerm_LocalType::Mp7JrsPersonGroupType_NameTerm_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPersonGroupType_NameTerm_LocalType::~Mp7JrsPersonGroupType_NameTerm_LocalType()
{
	Cleanup();
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::Init()
{
	// Init base
	m_Base = CreateControlledTermUseType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_type = Mp7JrsPersonGroupType_NameTerm_type_LocalType::UninitializedEnumeration;
	m_type_Exist = false;



// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtMyPropInit.h

}

void Mp7JrsPersonGroupType_NameTerm_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PersonGroupType_NameTerm_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPersonGroupType_NameTerm_LocalType
    const Mp7JrsPtr< Mp7JrsPersonGroupType_NameTerm_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsControlledTermUsePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsPersonGroupType_NameTerm_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	if (tmp->Existtype())
	{
		this->Settype(tmp->Gettype());
	}
	else
	{
		Invalidatetype();
	}
	}
}

Mp7JrsNodePtr Mp7JrsPersonGroupType_NameTerm_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsPersonGroupType_NameTerm_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsControlledTermUseType > Mp7JrsPersonGroupType_NameTerm_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsPersonGroupType_NameTerm_type_LocalType::Enumeration Mp7JrsPersonGroupType_NameTerm_LocalType::Gettype() const
{
	return m_type;
}

bool Mp7JrsPersonGroupType_NameTerm_LocalType::Existtype() const
{
	return m_type_Exist;
}
void Mp7JrsPersonGroupType_NameTerm_LocalType::Settype(Mp7JrsPersonGroupType_NameTerm_type_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonGroupType_NameTerm_LocalType::Settype().");
	}
    m_type = item;
	m_type_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::Invalidatetype()
{
	m_type_Exist = false;
}
Mp7JrstermReferencePtr Mp7JrsPersonGroupType_NameTerm_LocalType::Gethref() const
{
	return GetBase()->Gethref();
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonGroupType_NameTerm_LocalType::Sethref().");
	}
	GetBase()->Sethref(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsInlineTermDefinitionType_Name_CollectionPtr Mp7JrsPersonGroupType_NameTerm_LocalType::GetName() const
{
	return GetBase()->GetBase()->GetName();
}

Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr Mp7JrsPersonGroupType_NameTerm_LocalType::GetDefinition() const
{
	return GetBase()->GetBase()->GetDefinition();
}

Mp7JrsInlineTermDefinitionType_Term_CollectionPtr Mp7JrsPersonGroupType_NameTerm_LocalType::GetTerm() const
{
	return GetBase()->GetBase()->GetTerm();
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonGroupType_NameTerm_LocalType::SetName().");
	}
	GetBase()->GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonGroupType_NameTerm_LocalType::SetDefinition().");
	}
	GetBase()->GetBase()->SetDefinition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonGroupType_NameTerm_LocalType::SetTerm().");
	}
	GetBase()->GetBase()->SetTerm(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsPersonGroupType_NameTerm_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for PersonGroupType_NameTerm_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "PersonGroupType_NameTerm_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsPersonGroupType_NameTerm_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPersonGroupType_NameTerm_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsPersonGroupType_NameTerm_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsPersonGroupType_NameTerm_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsPersonGroupType_NameTerm_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PersonGroupType_NameTerm_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_type_Exist)
	{
	// Enumeration
	if(m_type != Mp7JrsPersonGroupType_NameTerm_type_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsPersonGroupType_NameTerm_type_LocalType::ToText(m_type);
		element->setAttributeNS(X(""), X("type"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsPersonGroupType_NameTerm_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("type")))
	{
        this->Settype(Mp7JrsPersonGroupType_NameTerm_type_LocalType::Parse(parent->getAttributeNS(X(""), X("type"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("type")))
	{
        this->Settype(Mp7JrsPersonGroupType_NameTerm_type_LocalType::Parse(parent->getAttribute(X("type"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsControlledTermUseType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPersonGroupType_NameTerm_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPersonGroupType_NameTerm_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetDefinition() != Mp7JrsNodePtr())
		result.Insert(GetDefinition());
	if (GetTerm() != Mp7JrsNodePtr())
		result.Insert(GetTerm());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPersonGroupType_NameTerm_LocalType_ExtMethodImpl.h


