 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtImplInclude.h



#include "Mp7JrsWordType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::IMp7JrsPhoneticTranscriptionLexiconType_Token_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtPropInit.h

}

IMp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::~IMp7JrsPhoneticTranscriptionLexiconType_Token_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtPropCleanup.h

}

Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::~Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType()
{
	Cleanup();
}

void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Init()
{
	// Init base
	m_Base = CreateWordType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_phoneticTranscription = Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionPtr(); // Collection
	m_lang = NULL; // String
	m_lang_Exist = false;



// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtMyPropInit.h

}

void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_phoneticTranscription);
	XMLString::release(&m_lang);
}

void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PhoneticTranscriptionLexiconType_Token_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPhoneticTranscriptionLexiconType_Token_LocalType
    const Mp7JrsPtr< Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsWordPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_phoneticTranscription);
		this->SetphoneticTranscription(Mp7JrsFactory::CloneObject(tmp->GetphoneticTranscription()));
	}
	{
	XMLString::release(&m_lang);
	if (tmp->Existlang())
	{
		this->Setlang(XMLString::replicate(tmp->Getlang()));
	}
	else
	{
		Invalidatelang();
	}
	}
}

Mp7JrsNodePtr Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsWordType > Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::GetBase() const
{
	return m_Base;
}

void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::SetContent(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::SetContent().");
	}
	GetBase()->SetContent(item);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::GetContent() const
{
	return GetBase()->GetContent();
}
Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionPtr Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::GetphoneticTranscription() const
{
	return m_phoneticTranscription;
}

void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::SetphoneticTranscription(const Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::SetphoneticTranscription().");
	}
    m_phoneticTranscription = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_phoneticTranscription) m_phoneticTranscription->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Getlang() const
{
	return m_lang;
}

bool Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Existlang() const
{
	return m_lang_Exist;
}
void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Setlang(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Setlang().");
	}
    m_lang = item;
	m_lang_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Invalidatelang()
{
	m_lang_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for PhoneticTranscriptionLexiconType_Token_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "PhoneticTranscriptionLexiconType_Token_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PhoneticTranscriptionLexiconType_Token_LocalType"));
    // Attribute Serialization:
	// Collection
	if(m_phoneticTranscription != Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionPtr())
	{
		XMLCh * tmp = m_phoneticTranscription->ToText();
		element->setAttributeNS(X(""), X("phoneticTranscription"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
		

	// Optional attriute
	if(m_lang_Exist)
	{
	// String
	if(m_lang != (XMLCh *)NULL)
	{
		element->setAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("xml:lang"), m_lang);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("phoneticTranscription")))
	{
        // Deserialize collection type
		Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionPtr tmp = CreatePhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType;
		tmp->Parse(parent->getAttributeNS(X(""), X("phoneticTranscription")));
        this->SetphoneticTranscription(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("phoneticTranscription")))
	{
     
		// Deserialize collection type
        Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionPtr tmp = CreatePhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType;
        tmp->Parse(parent->getAttribute(X("phoneticTranscription")));
        this->SetphoneticTranscription(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang")))
	{
        // Deserialize string type
        this->Setlang(Mp7JrsConvert::TextToString(parent->getAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("lang")))
	{
        // Deserialize string type
        this->Setlang(Mp7JrsConvert::TextToString(parent->getAttribute(X("lang"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsWordType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType_ExtMethodImpl.h


