 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType0_ExtImplInclude.h



#include "Mp7JrsSegmentCollectionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsSegmentCollectionType_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSegmentCollectionType_LocalType0::IMp7JrsSegmentCollectionType_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType0_ExtPropInit.h

}

IMp7JrsSegmentCollectionType_LocalType0::~IMp7JrsSegmentCollectionType_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType0_ExtPropCleanup.h

}

Mp7JrsSegmentCollectionType_LocalType0::Mp7JrsSegmentCollectionType_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSegmentCollectionType_LocalType0::~Mp7JrsSegmentCollectionType_LocalType0()
{
	Cleanup();
}

void Mp7JrsSegmentCollectionType_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_SegmentCollection = Mp7JrsSegmentCollectionPtr(); // Class
	m_SegmentCollectionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType0_ExtMyPropInit.h

}

void Mp7JrsSegmentCollectionType_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_SegmentCollection);
	// Mp7JrsFactory::DeleteObject(m_SegmentCollectionRef);
}

void Mp7JrsSegmentCollectionType_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SegmentCollectionType_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in ISegmentCollectionType_LocalType0
    const Mp7JrsPtr< Mp7JrsSegmentCollectionType_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_SegmentCollection);
		this->SetSegmentCollection(Mp7JrsFactory::CloneObject(tmp->GetSegmentCollection()));
		// Mp7JrsFactory::DeleteObject(m_SegmentCollectionRef);
		this->SetSegmentCollectionRef(Mp7JrsFactory::CloneObject(tmp->GetSegmentCollectionRef()));
}

Mp7JrsNodePtr Mp7JrsSegmentCollectionType_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSegmentCollectionType_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSegmentCollectionPtr Mp7JrsSegmentCollectionType_LocalType0::GetSegmentCollection() const
{
	return m_SegmentCollection;
}

Mp7JrsReferencePtr Mp7JrsSegmentCollectionType_LocalType0::GetSegmentCollectionRef() const
{
	return m_SegmentCollectionRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsSegmentCollectionType_LocalType0::SetSegmentCollection(const Mp7JrsSegmentCollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSegmentCollectionType_LocalType0::SetSegmentCollection().");
	}
	if (m_SegmentCollection != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SegmentCollection);
		m_SegmentCollection = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SegmentCollection) m_SegmentCollection->SetParent(m_myself.getPointer());
		if (m_SegmentCollection && m_SegmentCollection->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SegmentCollectionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SegmentCollection->UseTypeAttribute = true;
		}
		if(m_SegmentCollection != Mp7JrsSegmentCollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SegmentCollection->SetContentName(XMLString::transcode("SegmentCollection"));
		}
	// Mp7JrsFactory::DeleteObject(m_SegmentCollectionRef);
	m_SegmentCollectionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSegmentCollectionType_LocalType0::SetSegmentCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSegmentCollectionType_LocalType0::SetSegmentCollectionRef().");
	}
	if (m_SegmentCollectionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SegmentCollectionRef);
		m_SegmentCollectionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SegmentCollectionRef) m_SegmentCollectionRef->SetParent(m_myself.getPointer());
		if (m_SegmentCollectionRef && m_SegmentCollectionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SegmentCollectionRef->UseTypeAttribute = true;
		}
		if(m_SegmentCollectionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SegmentCollectionRef->SetContentName(XMLString::transcode("SegmentCollectionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_SegmentCollection);
	m_SegmentCollection = Mp7JrsSegmentCollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: SegmentCollectionType_LocalType0: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSegmentCollectionType_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSegmentCollectionType_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSegmentCollectionType_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSegmentCollectionType_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_SegmentCollection != Mp7JrsSegmentCollectionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SegmentCollection->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SegmentCollection"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SegmentCollection->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_SegmentCollectionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SegmentCollectionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SegmentCollectionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SegmentCollectionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSegmentCollectionType_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SegmentCollection"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SegmentCollection")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSegmentCollectionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSegmentCollection(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SegmentCollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SegmentCollectionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSegmentCollectionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSegmentCollectionType_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("SegmentCollection")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSegmentCollectionType;
    }
    this->SetSegmentCollection(child);
  }
  if (XMLString::compareString(elementname, X("SegmentCollectionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetSegmentCollectionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSegmentCollectionType_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSegmentCollection() != Mp7JrsNodePtr())
		result.Insert(GetSegmentCollection());
	if (GetSegmentCollectionRef() != Mp7JrsNodePtr())
		result.Insert(GetSegmentCollectionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType0_ExtMethodImpl.h


