 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtImplInclude.h



#include "Mp7JrsIntegerMatrixType.h"
#include "Mp7JrsFloatMatrixType.h"
#include "Mp7JrsTextualType.h"
#include "Mp7JrsTextAnnotationType.h"
#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrsDType.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSemanticStateType_AttributeValuePair_LocalType::IMp7JrsSemanticStateType_AttributeValuePair_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtPropInit.h

}

IMp7JrsSemanticStateType_AttributeValuePair_LocalType::~IMp7JrsSemanticStateType_AttributeValuePair_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtPropCleanup.h

}

Mp7JrsSemanticStateType_AttributeValuePair_LocalType::Mp7JrsSemanticStateType_AttributeValuePair_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSemanticStateType_AttributeValuePair_LocalType::~Mp7JrsSemanticStateType_AttributeValuePair_LocalType()
{
	Cleanup();
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_BooleanValue = (false); // Value

	m_IntegerValue = (0); // Value

	m_FloatValue = (0.0); // Value

	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr(); // Class
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr(); // Class
	m_TextValue = Mp7JrsTextualPtr(); // Class
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr(); // Class
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr(); // Class
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >(); // Class


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtMyPropInit.h

}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SemanticStateType_AttributeValuePair_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISemanticStateType_AttributeValuePair_LocalType
    const Mp7JrsPtr< Mp7JrsSemanticStateType_AttributeValuePair_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		this->SetBooleanValue(tmp->GetBooleanValue());
		this->SetIntegerValue(tmp->GetIntegerValue());
		this->SetFloatValue(tmp->GetFloatValue());
		// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
		this->SetIntegerMatrixValue(Mp7JrsFactory::CloneObject(tmp->GetIntegerMatrixValue()));
		// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
		this->SetFloatMatrixValue(Mp7JrsFactory::CloneObject(tmp->GetFloatMatrixValue()));
		// Mp7JrsFactory::DeleteObject(m_TextValue);
		this->SetTextValue(Mp7JrsFactory::CloneObject(tmp->GetTextValue()));
		// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
		this->SetTextAnnotationValue(Mp7JrsFactory::CloneObject(tmp->GetTextAnnotationValue()));
		// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
		this->SetControlledTermUseValue(Mp7JrsFactory::CloneObject(tmp->GetControlledTermUseValue()));
		// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
		this->SetDescriptorValue(Mp7JrsFactory::CloneObject(tmp->GetDescriptorValue()));
}

Mp7JrsNodePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


bool Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetBooleanValue() const
{
	return m_BooleanValue;
}

int Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetIntegerValue() const
{
	return m_IntegerValue;
}

float Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetFloatValue() const
{
	return m_FloatValue;
}

Mp7JrsIntegerMatrixPtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetIntegerMatrixValue() const
{
	return m_IntegerMatrixValue;
}

Mp7JrsFloatMatrixPtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetFloatMatrixValue() const
{
	return m_FloatMatrixValue;
}

Mp7JrsTextualPtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetTextValue() const
{
	return m_TextValue;
}

Mp7JrsTextAnnotationPtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetTextAnnotationValue() const
{
	return m_TextAnnotationValue;
}

Mp7JrsControlledTermUsePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetControlledTermUseValue() const
{
	return m_ControlledTermUseValue;
}

Mp7JrsPtr< Mp7JrsNode > Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetDescriptorValue() const
{
	return m_DescriptorValue;
}

// implementing setter for choice 
/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetBooleanValue(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetBooleanValue().");
	}
	if (m_BooleanValue != item)
	{
		m_BooleanValue = item;
		m_BooleanValue_Valid = true;
	
	m_IntegerValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetIntegerValue(int item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetIntegerValue().");
	}
	if (m_IntegerValue != item)
	{
		m_IntegerValue = item;
		m_IntegerValue_Valid = true;
	
	m_BooleanValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetFloatValue(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetFloatValue().");
	}
	if (m_FloatValue != item)
	{
		m_FloatValue = item;
		m_FloatValue_Valid = true;
	
	m_BooleanValue_Valid = false;
	
	m_IntegerValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetIntegerMatrixValue(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetIntegerMatrixValue().");
	}
	if (m_IntegerMatrixValue != item)
	{
		// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
		m_IntegerMatrixValue = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_IntegerMatrixValue) m_IntegerMatrixValue->SetParent(m_myself.getPointer());
		if (m_IntegerMatrixValue && m_IntegerMatrixValue->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:IntegerMatrixType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_IntegerMatrixValue->UseTypeAttribute = true;
		}
		if(m_IntegerMatrixValue != Mp7JrsIntegerMatrixPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_IntegerMatrixValue->SetContentName(XMLString::transcode("IntegerMatrixValue"));
		}
	
	m_BooleanValue_Valid = false;
	
	m_IntegerValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetFloatMatrixValue(const Mp7JrsFloatMatrixPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetFloatMatrixValue().");
	}
	if (m_FloatMatrixValue != item)
	{
		// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
		m_FloatMatrixValue = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_FloatMatrixValue) m_FloatMatrixValue->SetParent(m_myself.getPointer());
		if (m_FloatMatrixValue && m_FloatMatrixValue->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:FloatMatrixType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_FloatMatrixValue->UseTypeAttribute = true;
		}
		if(m_FloatMatrixValue != Mp7JrsFloatMatrixPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_FloatMatrixValue->SetContentName(XMLString::transcode("FloatMatrixValue"));
		}
	
	m_BooleanValue_Valid = false;
	
	m_IntegerValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetTextValue(const Mp7JrsTextualPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetTextValue().");
	}
	if (m_TextValue != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TextValue);
		m_TextValue = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TextValue) m_TextValue->SetParent(m_myself.getPointer());
		if (m_TextValue && m_TextValue->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TextValue->UseTypeAttribute = true;
		}
		if(m_TextValue != Mp7JrsTextualPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TextValue->SetContentName(XMLString::transcode("TextValue"));
		}
	
	m_BooleanValue_Valid = false;
	
	m_IntegerValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetTextAnnotationValue(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetTextAnnotationValue().");
	}
	if (m_TextAnnotationValue != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
		m_TextAnnotationValue = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TextAnnotationValue) m_TextAnnotationValue->SetParent(m_myself.getPointer());
		if (m_TextAnnotationValue && m_TextAnnotationValue->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextAnnotationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TextAnnotationValue->UseTypeAttribute = true;
		}
		if(m_TextAnnotationValue != Mp7JrsTextAnnotationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TextAnnotationValue->SetContentName(XMLString::transcode("TextAnnotationValue"));
		}
	
	m_BooleanValue_Valid = false;
	
	m_IntegerValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetControlledTermUseValue(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetControlledTermUseValue().");
	}
	if (m_ControlledTermUseValue != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
		m_ControlledTermUseValue = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ControlledTermUseValue) m_ControlledTermUseValue->SetParent(m_myself.getPointer());
		if (m_ControlledTermUseValue && m_ControlledTermUseValue->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ControlledTermUseValue->UseTypeAttribute = true;
		}
		if(m_ControlledTermUseValue != Mp7JrsControlledTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ControlledTermUseValue->SetContentName(XMLString::transcode("ControlledTermUseValue"));
		}
	
	m_BooleanValue_Valid = false;
	
	m_IntegerValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
	m_DescriptorValue = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetDescriptorValue(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType::SetDescriptorValue().");
	}
	if (m_DescriptorValue != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DescriptorValue);
		m_DescriptorValue = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DescriptorValue) m_DescriptorValue->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_DescriptorValue) m_DescriptorValue->UseTypeAttribute = true;
		if(m_DescriptorValue != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_DescriptorValue->SetContentName(XMLString::transcode("DescriptorValue"));
		}
	
	m_BooleanValue_Valid = false;
	
	m_IntegerValue_Valid = false;
	
	m_FloatValue_Valid = false;
	// Mp7JrsFactory::DeleteObject(m_IntegerMatrixValue);
	m_IntegerMatrixValue = Mp7JrsIntegerMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_FloatMatrixValue);
	m_FloatMatrixValue = Mp7JrsFloatMatrixPtr();
	// Mp7JrsFactory::DeleteObject(m_TextValue);
	m_TextValue = Mp7JrsTextualPtr();
	// Mp7JrsFactory::DeleteObject(m_TextAnnotationValue);
	m_TextAnnotationValue = Mp7JrsTextAnnotationPtr();
	// Mp7JrsFactory::DeleteObject(m_ControlledTermUseValue);
	m_ControlledTermUseValue = Mp7JrsControlledTermUsePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: SemanticStateType_AttributeValuePair_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSemanticStateType_AttributeValuePair_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSemanticStateType_AttributeValuePair_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSemanticStateType_AttributeValuePair_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	if(m_BooleanValue_Valid) // Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_BooleanValue);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("BooleanValue"), false);
		XMLString::release(&tmp);
	}
	if(m_IntegerValue_Valid) // Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_IntegerValue);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("IntegerValue"), false);
		XMLString::release(&tmp);
	}
	if(m_FloatValue_Valid) // Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_FloatValue);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("FloatValue"), false);
		XMLString::release(&tmp);
	}
	// Class
	
	if (m_IntegerMatrixValue != Mp7JrsIntegerMatrixPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_IntegerMatrixValue->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("IntegerMatrixValue"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_IntegerMatrixValue->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_FloatMatrixValue != Mp7JrsFloatMatrixPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_FloatMatrixValue->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("FloatMatrixValue"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_FloatMatrixValue->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_TextValue != Mp7JrsTextualPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TextValue->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TextValue"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TextValue->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_TextAnnotationValue != Mp7JrsTextAnnotationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TextAnnotationValue->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TextAnnotationValue"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TextAnnotationValue->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ControlledTermUseValue != Mp7JrsControlledTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ControlledTermUseValue->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ControlledTermUseValue"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ControlledTermUseValue->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_DescriptorValue != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_DescriptorValue->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("DescriptorValue"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_DescriptorValue->UseTypeAttribute = true;
		}
		m_DescriptorValue->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSemanticStateType_AttributeValuePair_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
	// Deserialize value element
	if(Mp7JrsUtil::HasNodeName(parent, X("BooleanValue"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		XMLCh * tmp = Mp7JrsUtil::GetElementText(parent);
		this->SetBooleanValue(Mp7JrsConvert::TextToBool(tmp));
		XMLString::release(&tmp);
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		continue;       // For choices
	}
	// Deserialize value element
	if(Mp7JrsUtil::HasNodeName(parent, X("IntegerValue"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		XMLCh * tmp = Mp7JrsUtil::GetElementText(parent);
		this->SetIntegerValue(Mp7JrsConvert::TextToInt(tmp));
		XMLString::release(&tmp);
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		continue;       // For choices
	}
	// Deserialize value element
	if(Mp7JrsUtil::HasNodeName(parent, X("FloatValue"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		XMLCh * tmp = Mp7JrsUtil::GetElementText(parent);
		this->SetFloatValue(Mp7JrsConvert::TextToFloat(tmp));
		XMLString::release(&tmp);
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		continue;       // For choices
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("IntegerMatrixValue"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("IntegerMatrixValue")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateIntegerMatrixType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetIntegerMatrixValue(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("FloatMatrixValue"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("FloatMatrixValue")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateFloatMatrixType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFloatMatrixValue(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TextValue"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TextValue")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTextualType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTextValue(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TextAnnotationValue"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TextAnnotationValue")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTextAnnotationType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTextAnnotationValue(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ControlledTermUseValue"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ControlledTermUseValue")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateControlledTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetControlledTermUseValue(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("DescriptorValue"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("DescriptorValue")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateDType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetDescriptorValue(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("IntegerMatrixValue")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateIntegerMatrixType;
    }
    this->SetIntegerMatrixValue(child);
  }
  if (XMLString::compareString(elementname, X("FloatMatrixValue")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateFloatMatrixType;
    }
    this->SetFloatMatrixValue(child);
  }
  if (XMLString::compareString(elementname, X("TextValue")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTextualType;
    }
    this->SetTextValue(child);
  }
  if (XMLString::compareString(elementname, X("TextAnnotationValue")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTextAnnotationType;
    }
    this->SetTextAnnotationValue(child);
  }
  if (XMLString::compareString(elementname, X("ControlledTermUseValue")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateControlledTermUseType;
    }
    this->SetControlledTermUseValue(child);
  }
  if (XMLString::compareString(elementname, X("DescriptorValue")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateDType;
    }
    this->SetDescriptorValue(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSemanticStateType_AttributeValuePair_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetIntegerMatrixValue() != Mp7JrsNodePtr())
		result.Insert(GetIntegerMatrixValue());
	if (GetFloatMatrixValue() != Mp7JrsNodePtr())
		result.Insert(GetFloatMatrixValue());
	if (GetTextValue() != Mp7JrsNodePtr())
		result.Insert(GetTextValue());
	if (GetTextAnnotationValue() != Mp7JrsNodePtr())
		result.Insert(GetTextAnnotationValue());
	if (GetControlledTermUseValue() != Mp7JrsNodePtr())
		result.Insert(GetControlledTermUseValue());
	if (GetDescriptorValue() != Mp7JrsNodePtr())
		result.Insert(GetDescriptorValue());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtMethodImpl.h


