 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtImplInclude.h



#include "Mp7JrsTermUseType.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_CollectionType.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalType.h" // Choice collection IntegerMatrixValue
#include "Mp7JrsIntegerMatrixType.h" // Choice collection element IntegerMatrixValue
#include "Mp7JrsFloatMatrixType.h" // Choice collection element FloatMatrixValue
#include "Mp7JrsTextualType.h" // Choice collection element TextValue
#include "Mp7JrsTextAnnotationType.h" // Choice collection element TextAnnotationValue
#include "Mp7JrsControlledTermUseType.h" // Choice collection element ControlledTermUseValue
#include "Mp7JrsDType.h" // Choice collection element DescriptorValue

#include <assert.h>
IMp7JrsSemanticStateType_AttributeValuePair_LocalType0::IMp7JrsSemanticStateType_AttributeValuePair_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtPropInit.h

}

IMp7JrsSemanticStateType_AttributeValuePair_LocalType0::~IMp7JrsSemanticStateType_AttributeValuePair_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtPropCleanup.h

}

Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::Mp7JrsSemanticStateType_AttributeValuePair_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::~Mp7JrsSemanticStateType_AttributeValuePair_LocalType0()
{
	Cleanup();
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Attribute = Mp7JrsTermUsePtr(); // Class
	m_Unit = Mp7JrsTermUsePtr(); // Class
	m_Unit_Exist = false;
	m_SemanticStateType_AttributeValuePair_LocalType = Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtMyPropInit.h

}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Attribute);
	// Mp7JrsFactory::DeleteObject(m_Unit);
	// Mp7JrsFactory::DeleteObject(m_SemanticStateType_AttributeValuePair_LocalType);
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SemanticStateType_AttributeValuePair_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in ISemanticStateType_AttributeValuePair_LocalType0
    const Mp7JrsPtr< Mp7JrsSemanticStateType_AttributeValuePair_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Attribute);
		this->SetAttribute(Mp7JrsFactory::CloneObject(tmp->GetAttribute()));
	if (tmp->IsValidUnit())
	{
		// Mp7JrsFactory::DeleteObject(m_Unit);
		this->SetUnit(Mp7JrsFactory::CloneObject(tmp->GetUnit()));
	}
	else
	{
		InvalidateUnit();
	}
		// Mp7JrsFactory::DeleteObject(m_SemanticStateType_AttributeValuePair_LocalType);
		this->SetSemanticStateType_AttributeValuePair_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSemanticStateType_AttributeValuePair_LocalType()));
}

Mp7JrsNodePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsTermUsePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::GetAttribute() const
{
	return m_Attribute;
}

Mp7JrsTermUsePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::GetUnit() const
{
	return m_Unit;
}

// Element is optional
bool Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::IsValidUnit() const
{
	return m_Unit_Exist;
}

Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::GetSemanticStateType_AttributeValuePair_LocalType() const
{
	return m_SemanticStateType_AttributeValuePair_LocalType;
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::SetAttribute(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::SetAttribute().");
	}
	if (m_Attribute != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Attribute);
		m_Attribute = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Attribute) m_Attribute->SetParent(m_myself.getPointer());
		if (m_Attribute && m_Attribute->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Attribute->UseTypeAttribute = true;
		}
		if(m_Attribute != Mp7JrsTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Attribute->SetContentName(XMLString::transcode("Attribute"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::SetUnit(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::SetUnit().");
	}
	if (m_Unit != item || m_Unit_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Unit);
		m_Unit = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Unit) m_Unit->SetParent(m_myself.getPointer());
		if (m_Unit && m_Unit->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Unit->UseTypeAttribute = true;
		}
		m_Unit_Exist = true;
		if(m_Unit != Mp7JrsTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Unit->SetContentName(XMLString::transcode("Unit"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::InvalidateUnit()
{
	m_Unit_Exist = false;
}
void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::SetSemanticStateType_AttributeValuePair_LocalType(const Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::SetSemanticStateType_AttributeValuePair_LocalType().");
	}
	if (m_SemanticStateType_AttributeValuePair_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SemanticStateType_AttributeValuePair_LocalType);
		m_SemanticStateType_AttributeValuePair_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SemanticStateType_AttributeValuePair_LocalType) m_SemanticStateType_AttributeValuePair_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Attribute")) == 0)
	{
		// Attribute is simple element TermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetAttribute()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetAttribute(p, client);
					if((p = GetAttribute()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Unit")) == 0)
	{
		// Unit is simple element TermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetUnit()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetUnit(p, client);
					if((p = GetUnit()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("IntegerMatrixValue")) == 0)
	{
		// IntegerMatrixValue is contained in itemtype SemanticStateType_AttributeValuePair_LocalType
		// in choice collection SemanticStateType_AttributeValuePair_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr coll = GetSemanticStateType_AttributeValuePair_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticStateType_AttributeValuePair_CollectionType;
				SetSemanticStateType_AttributeValuePair_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetIntegerMatrixValue()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr item = CreateSemanticStateType_AttributeValuePair_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:IntegerMatrixType")))) != empty)
			{
				// Is type allowed
				Mp7JrsIntegerMatrixPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->SetIntegerMatrixValue(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetIntegerMatrixValue()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("FloatMatrixValue")) == 0)
	{
		// FloatMatrixValue is contained in itemtype SemanticStateType_AttributeValuePair_LocalType
		// in choice collection SemanticStateType_AttributeValuePair_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr coll = GetSemanticStateType_AttributeValuePair_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticStateType_AttributeValuePair_CollectionType;
				SetSemanticStateType_AttributeValuePair_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetFloatMatrixValue()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr item = CreateSemanticStateType_AttributeValuePair_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:FloatMatrixType")))) != empty)
			{
				// Is type allowed
				Mp7JrsFloatMatrixPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->SetFloatMatrixValue(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetFloatMatrixValue()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TextValue")) == 0)
	{
		// TextValue is contained in itemtype SemanticStateType_AttributeValuePair_LocalType
		// in choice collection SemanticStateType_AttributeValuePair_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr coll = GetSemanticStateType_AttributeValuePair_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticStateType_AttributeValuePair_CollectionType;
				SetSemanticStateType_AttributeValuePair_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetTextValue()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr item = CreateSemanticStateType_AttributeValuePair_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextualPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->SetTextValue(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetTextValue()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TextAnnotationValue")) == 0)
	{
		// TextAnnotationValue is contained in itemtype SemanticStateType_AttributeValuePair_LocalType
		// in choice collection SemanticStateType_AttributeValuePair_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr coll = GetSemanticStateType_AttributeValuePair_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticStateType_AttributeValuePair_CollectionType;
				SetSemanticStateType_AttributeValuePair_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetTextAnnotationValue()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr item = CreateSemanticStateType_AttributeValuePair_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextAnnotationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextAnnotationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->SetTextAnnotationValue(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetTextAnnotationValue()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ControlledTermUseValue")) == 0)
	{
		// ControlledTermUseValue is contained in itemtype SemanticStateType_AttributeValuePair_LocalType
		// in choice collection SemanticStateType_AttributeValuePair_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr coll = GetSemanticStateType_AttributeValuePair_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticStateType_AttributeValuePair_CollectionType;
				SetSemanticStateType_AttributeValuePair_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetControlledTermUseValue()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr item = CreateSemanticStateType_AttributeValuePair_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsControlledTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->SetControlledTermUseValue(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetControlledTermUseValue()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("DescriptorValue")) == 0)
	{
		// DescriptorValue is contained in itemtype SemanticStateType_AttributeValuePair_LocalType
		// in choice collection SemanticStateType_AttributeValuePair_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr coll = GetSemanticStateType_AttributeValuePair_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticStateType_AttributeValuePair_CollectionType;
				SetSemanticStateType_AttributeValuePair_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetDescriptorValue()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr item = CreateSemanticStateType_AttributeValuePair_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsDPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->SetDescriptorValue(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr)coll->elementAt(i))->GetDescriptorValue()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SemanticStateType_AttributeValuePair_LocalType0
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SemanticStateType_AttributeValuePair_LocalType0");
	}		
	
	return result;
}

XMLCh * Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsSemanticStateType_AttributeValuePair_LocalType0 has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::ContentToString() const
{
	// Mp7JrsSemanticStateType_AttributeValuePair_LocalType0 has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SemanticStateType_AttributeValuePair_LocalType0"));
	// Element serialization:
	// Class
	
	if (m_Attribute != Mp7JrsTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Attribute->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Attribute"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Attribute->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Unit != Mp7JrsTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Unit->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Unit"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Unit->Serialize(doc, element, &elem);
	}
	if (m_SemanticStateType_AttributeValuePair_LocalType != Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SemanticStateType_AttributeValuePair_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Attribute"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Attribute")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAttribute(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Unit"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Unit")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetUnit(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:BooleanValue
            Mp7JrsUtil::HasNodeName(parent, X("BooleanValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:BooleanValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:IntegerValue
            Mp7JrsUtil::HasNodeName(parent, X("IntegerValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:IntegerValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:FloatValue
            Mp7JrsUtil::HasNodeName(parent, X("FloatValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:FloatValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:IntegerMatrixValue
            Mp7JrsUtil::HasNodeName(parent, X("IntegerMatrixValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:IntegerMatrixValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:FloatMatrixValue
            Mp7JrsUtil::HasNodeName(parent, X("FloatMatrixValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:FloatMatrixValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:TextValue
            Mp7JrsUtil::HasNodeName(parent, X("TextValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:TextValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:TextAnnotationValue
            Mp7JrsUtil::HasNodeName(parent, X("TextAnnotationValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:TextAnnotationValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:ControlledTermUseValue
            Mp7JrsUtil::HasNodeName(parent, X("ControlledTermUseValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseValue")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:DescriptorValue
            Mp7JrsUtil::HasNodeName(parent, X("DescriptorValue"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:DescriptorValue")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr tmp = CreateSemanticStateType_AttributeValuePair_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSemanticStateType_AttributeValuePair_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Attribute")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTermUseType;
    }
    this->SetAttribute(child);
  }
  if (XMLString::compareString(elementname, X("Unit")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTermUseType;
    }
    this->SetUnit(child);
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("BooleanValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("BooleanValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("IntegerValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("IntegerValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("FloatValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("FloatValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("IntegerMatrixValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("IntegerMatrixValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("FloatMatrixValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("FloatMatrixValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("TextValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("TextValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("TextAnnotationValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("TextAnnotationValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("ControlledTermUseValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("ControlledTermUseValue")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("DescriptorValue"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("DescriptorValue")) == 0)
    )
  {
    Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr tmp = CreateSemanticStateType_AttributeValuePair_CollectionType;
    this->SetSemanticStateType_AttributeValuePair_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSemanticStateType_AttributeValuePair_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetAttribute() != Mp7JrsNodePtr())
		result.Insert(GetAttribute());
	if (GetUnit() != Mp7JrsNodePtr())
		result.Insert(GetUnit());
	if (GetSemanticStateType_AttributeValuePair_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSemanticStateType_AttributeValuePair_LocalType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtMethodImpl.h


