 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtImplInclude.h



#include "Mp7JrsCompositionShotType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsCompositionTransitionType.h"
#include "Mp7JrsShotEditingTemporalDecompositionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsShotEditingTemporalDecompositionType_LocalType::IMp7JrsShotEditingTemporalDecompositionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtPropInit.h

}

IMp7JrsShotEditingTemporalDecompositionType_LocalType::~IMp7JrsShotEditingTemporalDecompositionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtPropCleanup.h

}

Mp7JrsShotEditingTemporalDecompositionType_LocalType::Mp7JrsShotEditingTemporalDecompositionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsShotEditingTemporalDecompositionType_LocalType::~Mp7JrsShotEditingTemporalDecompositionType_LocalType()
{
	Cleanup();
}

void Mp7JrsShotEditingTemporalDecompositionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_CompositionShot = Mp7JrsCompositionShotPtr(); // Class
	m_CompositionShotRef = Mp7JrsReferencePtr(); // Class
	m_CompositionTransition = Mp7JrsCompositionTransitionPtr(); // Class
	m_CompositionTransitionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsShotEditingTemporalDecompositionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_CompositionShot);
	// Mp7JrsFactory::DeleteObject(m_CompositionShotRef);
	// Mp7JrsFactory::DeleteObject(m_CompositionTransition);
	// Mp7JrsFactory::DeleteObject(m_CompositionTransitionRef);
}

void Mp7JrsShotEditingTemporalDecompositionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ShotEditingTemporalDecompositionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IShotEditingTemporalDecompositionType_LocalType
    const Mp7JrsPtr< Mp7JrsShotEditingTemporalDecompositionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_CompositionShot);
		this->SetCompositionShot(Mp7JrsFactory::CloneObject(tmp->GetCompositionShot()));
		// Mp7JrsFactory::DeleteObject(m_CompositionShotRef);
		this->SetCompositionShotRef(Mp7JrsFactory::CloneObject(tmp->GetCompositionShotRef()));
		// Mp7JrsFactory::DeleteObject(m_CompositionTransition);
		this->SetCompositionTransition(Mp7JrsFactory::CloneObject(tmp->GetCompositionTransition()));
		// Mp7JrsFactory::DeleteObject(m_CompositionTransitionRef);
		this->SetCompositionTransitionRef(Mp7JrsFactory::CloneObject(tmp->GetCompositionTransitionRef()));
}

Mp7JrsNodePtr Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsCompositionShotPtr Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetCompositionShot() const
{
	return m_CompositionShot;
}

Mp7JrsReferencePtr Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetCompositionShotRef() const
{
	return m_CompositionShotRef;
}

Mp7JrsCompositionTransitionPtr Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetCompositionTransition() const
{
	return m_CompositionTransition;
}

Mp7JrsReferencePtr Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetCompositionTransitionRef() const
{
	return m_CompositionTransitionRef;
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* choice */
// implementing setter for choice 
/* element */
void Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionShot(const Mp7JrsCompositionShotPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionShot().");
	}
	if (m_CompositionShot != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CompositionShot);
		m_CompositionShot = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CompositionShot) m_CompositionShot->SetParent(m_myself.getPointer());
		if (m_CompositionShot && m_CompositionShot->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CompositionShotType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CompositionShot->UseTypeAttribute = true;
		}
		if(m_CompositionShot != Mp7JrsCompositionShotPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CompositionShot->SetContentName(XMLString::transcode("CompositionShot"));
		}
	// Mp7JrsFactory::DeleteObject(m_CompositionShotRef);
	m_CompositionShotRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionTransition);
	m_CompositionTransition = Mp7JrsCompositionTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionTransitionRef);
	m_CompositionTransitionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionShotRef().");
	}
	if (m_CompositionShotRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CompositionShotRef);
		m_CompositionShotRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CompositionShotRef) m_CompositionShotRef->SetParent(m_myself.getPointer());
		if (m_CompositionShotRef && m_CompositionShotRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CompositionShotRef->UseTypeAttribute = true;
		}
		if(m_CompositionShotRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CompositionShotRef->SetContentName(XMLString::transcode("CompositionShotRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_CompositionShot);
	m_CompositionShot = Mp7JrsCompositionShotPtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionTransition);
	m_CompositionTransition = Mp7JrsCompositionTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionTransitionRef);
	m_CompositionTransitionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* choice */
// implementing setter for choice 
/* element */
void Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionTransition(const Mp7JrsCompositionTransitionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionTransition().");
	}
	if (m_CompositionTransition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CompositionTransition);
		m_CompositionTransition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CompositionTransition) m_CompositionTransition->SetParent(m_myself.getPointer());
		if (m_CompositionTransition && m_CompositionTransition->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CompositionTransitionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CompositionTransition->UseTypeAttribute = true;
		}
		if(m_CompositionTransition != Mp7JrsCompositionTransitionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CompositionTransition->SetContentName(XMLString::transcode("CompositionTransition"));
		}
	// Mp7JrsFactory::DeleteObject(m_CompositionTransitionRef);
	m_CompositionTransitionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionShot);
	m_CompositionShot = Mp7JrsCompositionShotPtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionShotRef);
	m_CompositionShotRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsShotEditingTemporalDecompositionType_LocalType::SetCompositionTransitionRef().");
	}
	if (m_CompositionTransitionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CompositionTransitionRef);
		m_CompositionTransitionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CompositionTransitionRef) m_CompositionTransitionRef->SetParent(m_myself.getPointer());
		if (m_CompositionTransitionRef && m_CompositionTransitionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CompositionTransitionRef->UseTypeAttribute = true;
		}
		if(m_CompositionTransitionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CompositionTransitionRef->SetContentName(XMLString::transcode("CompositionTransitionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_CompositionTransition);
	m_CompositionTransition = Mp7JrsCompositionTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionShot);
	m_CompositionShot = Mp7JrsCompositionShotPtr();
	// Mp7JrsFactory::DeleteObject(m_CompositionShotRef);
	m_CompositionShotRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: ShotEditingTemporalDecompositionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsShotEditingTemporalDecompositionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsShotEditingTemporalDecompositionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsShotEditingTemporalDecompositionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ShotEditingTemporalDecompositionType_LocalType"));
	// Element serialization:
	// Class
	
	if (m_CompositionShot != Mp7JrsCompositionShotPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CompositionShot->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CompositionShot"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CompositionShot->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CompositionShotRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CompositionShotRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CompositionShotRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CompositionShotRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CompositionTransition != Mp7JrsCompositionTransitionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CompositionTransition->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CompositionTransition"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CompositionTransition->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CompositionTransitionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CompositionTransitionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CompositionTransitionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CompositionTransitionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsShotEditingTemporalDecompositionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CompositionShot"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CompositionShot")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateCompositionShotType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCompositionShot(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CompositionShotRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CompositionShotRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCompositionShotRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CompositionTransition"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CompositionTransition")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateCompositionTransitionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCompositionTransition(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CompositionTransitionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CompositionTransitionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCompositionTransitionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
	} while(false);
// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsShotEditingTemporalDecompositionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("CompositionShot")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateCompositionShotType;
    }
    this->SetCompositionShot(child);
  }
  if (XMLString::compareString(elementname, X("CompositionShotRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetCompositionShotRef(child);
  }
  if (XMLString::compareString(elementname, X("CompositionTransition")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateCompositionTransitionType;
    }
    this->SetCompositionTransition(child);
  }
  if (XMLString::compareString(elementname, X("CompositionTransitionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetCompositionTransitionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsShotEditingTemporalDecompositionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCompositionShot() != Mp7JrsNodePtr())
		result.Insert(GetCompositionShot());
	if (GetCompositionShotRef() != Mp7JrsNodePtr())
		result.Insert(GetCompositionShotRef());
	if (GetCompositionTransition() != Mp7JrsNodePtr())
		result.Insert(GetCompositionTransition());
	if (GetCompositionTransitionRef() != Mp7JrsNodePtr())
		result.Insert(GetCompositionTransitionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtMethodImpl.h


