 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtImplInclude.h



#include "Mp7JrsPlaceType.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsPlaceType_Name_CollectionType.h"
#include "Mp7JrsPlaceType_NameTerm_CollectionType.h"
#include "Mp7JrsTermUseType.h"
#include "Mp7JrsPlaceType_GeographicPosition_LocalType.h"
#include "Mp7JrsPlaceType_AstronomicalBody_CollectionType.h"
#include "Mp7JrsPlaceType_Region_CollectionType.h"
#include "Mp7JrsPlaceType_AdministrativeUnit_CollectionType.h"
#include "Mp7JrsPlaceType_PostalAddress_LocalType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsControlledTermUseType.h" // Element collection urn:mpeg:mpeg7:schema:2004:NameTerm
#include "Mp7JrsregionCode.h" // Element collection urn:mpeg:mpeg7:schema:2004:Region
#include "Mp7JrsPlaceType_AdministrativeUnit_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:AdministrativeUnit

#include <assert.h>
IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType::IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtPropInit.h

}

IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType::~IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtPropCleanup.h

}

Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::~Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType()
{
	Cleanup();
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Init()
{
	// Init base
	m_Base = CreatePlaceType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;



// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtMyPropInit.h

}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SourcePreferencesType_DisseminationLocation_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISourcePreferencesType_DisseminationLocation_LocalType
    const Mp7JrsPtr< Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsPlacePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
}

Mp7JrsNodePtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsPlaceType > Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrspreferenceValuePtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetpreferenceValue().");
	}
    m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
XMLCh * Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Getlang() const
{
	return GetBase()->Getlang();
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Existlang() const
{
	return GetBase()->Existlang();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Setlang(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Setlang().");
	}
	GetBase()->Setlang(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Invalidatelang()
{
	GetBase()->Invalidatelang();
}
Mp7JrsPlaceType_Name_CollectionPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetName() const
{
	return GetBase()->GetName();
}

Mp7JrsPlaceType_NameTerm_CollectionPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetNameTerm() const
{
	return GetBase()->GetNameTerm();
}

Mp7JrsTermUsePtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetRole() const
{
	return GetBase()->GetRole();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::IsValidRole() const
{
	return GetBase()->IsValidRole();
}

Mp7JrsPlaceType_GeographicPosition_LocalPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetGeographicPosition() const
{
	return GetBase()->GetGeographicPosition();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::IsValidGeographicPosition() const
{
	return GetBase()->IsValidGeographicPosition();
}

Mp7JrsPlaceType_AstronomicalBody_CollectionPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetAstronomicalBody() const
{
	return GetBase()->GetAstronomicalBody();
}

Mp7JrsPlaceType_Region_CollectionPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetRegion() const
{
	return GetBase()->GetRegion();
}

Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetAdministrativeUnit() const
{
	return GetBase()->GetAdministrativeUnit();
}

Mp7JrsPlaceType_PostalAddress_LocalPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetPostalAddress() const
{
	return GetBase()->GetPostalAddress();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::IsValidPostalAddress() const
{
	return GetBase()->IsValidPostalAddress();
}

XMLCh * Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetInternalCoordinates() const
{
	return GetBase()->GetInternalCoordinates();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::IsValidInternalCoordinates() const
{
	return GetBase()->IsValidInternalCoordinates();
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetName(const Mp7JrsPlaceType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetName().");
	}
	GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetNameTerm(const Mp7JrsPlaceType_NameTerm_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetNameTerm().");
	}
	GetBase()->SetNameTerm(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetRole(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetRole().");
	}
	GetBase()->SetRole(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidateRole()
{
	GetBase()->InvalidateRole();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetGeographicPosition(const Mp7JrsPlaceType_GeographicPosition_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetGeographicPosition().");
	}
	GetBase()->SetGeographicPosition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidateGeographicPosition()
{
	GetBase()->InvalidateGeographicPosition();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetAstronomicalBody(const Mp7JrsPlaceType_AstronomicalBody_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetAstronomicalBody().");
	}
	GetBase()->SetAstronomicalBody(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetRegion(const Mp7JrsPlaceType_Region_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetRegion().");
	}
	GetBase()->SetRegion(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetAdministrativeUnit(const Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetAdministrativeUnit().");
	}
	GetBase()->SetAdministrativeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetPostalAddress(const Mp7JrsPlaceType_PostalAddress_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetPostalAddress().");
	}
	GetBase()->SetPostalAddress(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidatePostalAddress()
{
	GetBase()->InvalidatePostalAddress();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetInternalCoordinates(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetInternalCoordinates().");
	}
	GetBase()->SetInternalCoordinates(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidateInternalCoordinates()
{
	GetBase()->InvalidateInternalCoordinates();
}
XMLCh * Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Getid() const
{
	return GetBase()->GetBase()->Getid();
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Existid() const
{
	return GetBase()->GetBase()->Existid();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Setid().");
	}
	GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Invalidateid()
{
	GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GettimeBase() const
{
	return GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ExisttimeBase() const
{
	return GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SettimeBase().");
	}
	GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidatetimeBase()
{
	GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GettimeUnit() const
{
	return GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SettimeUnit().");
	}
	GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetHeader() const
{
	return GetBase()->GetBase()->GetHeader();
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::SetHeader().");
	}
	GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SourcePreferencesType_DisseminationLocation_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SourcePreferencesType_DisseminationLocation_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SourcePreferencesType_DisseminationLocation_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("preferenceValue")))
	{
        // Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttributeNS(X(""), X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
        Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
        tmp->Parse(parent->getAttribute(X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsPlaceType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetNameTerm() != Mp7JrsNodePtr())
		result.Insert(GetNameTerm());
	if (GetRole() != Mp7JrsNodePtr())
		result.Insert(GetRole());
	if (GetGeographicPosition() != Mp7JrsNodePtr())
		result.Insert(GetGeographicPosition());
	if (GetAstronomicalBody() != Mp7JrsNodePtr())
		result.Insert(GetAstronomicalBody());
	if (GetRegion() != Mp7JrsNodePtr())
		result.Insert(GetRegion());
	if (GetAdministrativeUnit() != Mp7JrsNodePtr())
		result.Insert(GetAdministrativeUnit());
	if (GetPostalAddress() != Mp7JrsNodePtr())
		result.Insert(GetPostalAddress());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtMethodImpl.h


