 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtImplInclude.h



#include "Mp7JrsFigureTrajectoryType.h"
#include "Mp7JrsParameterTrajectoryType.h"
#include "Mp7JrsMediaTimeType.h"
#include "Mp7JrsSpatioTemporalLocatorType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSpatioTemporalLocatorType_LocalType::IMp7JrsSpatioTemporalLocatorType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtPropInit.h

}

IMp7JrsSpatioTemporalLocatorType_LocalType::~IMp7JrsSpatioTemporalLocatorType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtPropCleanup.h

}

Mp7JrsSpatioTemporalLocatorType_LocalType::Mp7JrsSpatioTemporalLocatorType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpatioTemporalLocatorType_LocalType::~Mp7JrsSpatioTemporalLocatorType_LocalType()
{
	Cleanup();
}

void Mp7JrsSpatioTemporalLocatorType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_FigureTrajectory = Mp7JrsFigureTrajectoryPtr(); // Class
	m_ParameterTrajectory = Mp7JrsParameterTrajectoryPtr(); // Class
	m_MediaTime = Mp7JrsMediaTimePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtMyPropInit.h

}

void Mp7JrsSpatioTemporalLocatorType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_FigureTrajectory);
	// Mp7JrsFactory::DeleteObject(m_ParameterTrajectory);
	// Mp7JrsFactory::DeleteObject(m_MediaTime);
}

void Mp7JrsSpatioTemporalLocatorType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SpatioTemporalLocatorType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISpatioTemporalLocatorType_LocalType
    const Mp7JrsPtr< Mp7JrsSpatioTemporalLocatorType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_FigureTrajectory);
		this->SetFigureTrajectory(Mp7JrsFactory::CloneObject(tmp->GetFigureTrajectory()));
		// Mp7JrsFactory::DeleteObject(m_ParameterTrajectory);
		this->SetParameterTrajectory(Mp7JrsFactory::CloneObject(tmp->GetParameterTrajectory()));
		// Mp7JrsFactory::DeleteObject(m_MediaTime);
		this->SetMediaTime(Mp7JrsFactory::CloneObject(tmp->GetMediaTime()));
}

Mp7JrsNodePtr Mp7JrsSpatioTemporalLocatorType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpatioTemporalLocatorType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsFigureTrajectoryPtr Mp7JrsSpatioTemporalLocatorType_LocalType::GetFigureTrajectory() const
{
	return m_FigureTrajectory;
}

Mp7JrsParameterTrajectoryPtr Mp7JrsSpatioTemporalLocatorType_LocalType::GetParameterTrajectory() const
{
	return m_ParameterTrajectory;
}

Mp7JrsMediaTimePtr Mp7JrsSpatioTemporalLocatorType_LocalType::GetMediaTime() const
{
	return m_MediaTime;
}

// implementing setter for choice 
/* element */
void Mp7JrsSpatioTemporalLocatorType_LocalType::SetFigureTrajectory(const Mp7JrsFigureTrajectoryPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatioTemporalLocatorType_LocalType::SetFigureTrajectory().");
	}
	if (m_FigureTrajectory != item)
	{
		// Mp7JrsFactory::DeleteObject(m_FigureTrajectory);
		m_FigureTrajectory = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_FigureTrajectory) m_FigureTrajectory->SetParent(m_myself.getPointer());
		if (m_FigureTrajectory && m_FigureTrajectory->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:FigureTrajectoryType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_FigureTrajectory->UseTypeAttribute = true;
		}
		if(m_FigureTrajectory != Mp7JrsFigureTrajectoryPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_FigureTrajectory->SetContentName(XMLString::transcode("FigureTrajectory"));
		}
	// Mp7JrsFactory::DeleteObject(m_ParameterTrajectory);
	m_ParameterTrajectory = Mp7JrsParameterTrajectoryPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaTime);
	m_MediaTime = Mp7JrsMediaTimePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSpatioTemporalLocatorType_LocalType::SetParameterTrajectory(const Mp7JrsParameterTrajectoryPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatioTemporalLocatorType_LocalType::SetParameterTrajectory().");
	}
	if (m_ParameterTrajectory != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ParameterTrajectory);
		m_ParameterTrajectory = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ParameterTrajectory) m_ParameterTrajectory->SetParent(m_myself.getPointer());
		if (m_ParameterTrajectory && m_ParameterTrajectory->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ParameterTrajectoryType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ParameterTrajectory->UseTypeAttribute = true;
		}
		if(m_ParameterTrajectory != Mp7JrsParameterTrajectoryPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ParameterTrajectory->SetContentName(XMLString::transcode("ParameterTrajectory"));
		}
	// Mp7JrsFactory::DeleteObject(m_FigureTrajectory);
	m_FigureTrajectory = Mp7JrsFigureTrajectoryPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaTime);
	m_MediaTime = Mp7JrsMediaTimePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSpatioTemporalLocatorType_LocalType::SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatioTemporalLocatorType_LocalType::SetMediaTime().");
	}
	if (m_MediaTime != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaTime);
		m_MediaTime = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaTime) m_MediaTime->SetParent(m_myself.getPointer());
		if (m_MediaTime && m_MediaTime->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTimeType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaTime->UseTypeAttribute = true;
		}
		if(m_MediaTime != Mp7JrsMediaTimePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaTime->SetContentName(XMLString::transcode("MediaTime"));
		}
	// Mp7JrsFactory::DeleteObject(m_FigureTrajectory);
	m_FigureTrajectory = Mp7JrsFigureTrajectoryPtr();
	// Mp7JrsFactory::DeleteObject(m_ParameterTrajectory);
	m_ParameterTrajectory = Mp7JrsParameterTrajectoryPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: SpatioTemporalLocatorType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSpatioTemporalLocatorType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSpatioTemporalLocatorType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpatioTemporalLocatorType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpatioTemporalLocatorType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_FigureTrajectory != Mp7JrsFigureTrajectoryPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_FigureTrajectory->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("FigureTrajectory"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_FigureTrajectory->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ParameterTrajectory != Mp7JrsParameterTrajectoryPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ParameterTrajectory->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ParameterTrajectory"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ParameterTrajectory->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MediaTime != Mp7JrsMediaTimePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaTime->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaTime"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaTime->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSpatioTemporalLocatorType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("FigureTrajectory"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("FigureTrajectory")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateFigureTrajectoryType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFigureTrajectory(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ParameterTrajectory"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ParameterTrajectory")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateParameterTrajectoryType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetParameterTrajectory(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaTime"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaTime")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaTimeType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMediaTime(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpatioTemporalLocatorType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("FigureTrajectory")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateFigureTrajectoryType;
    }
    this->SetFigureTrajectory(child);
  }
  if (XMLString::compareString(elementname, X("ParameterTrajectory")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateParameterTrajectoryType;
    }
    this->SetParameterTrajectory(child);
  }
  if (XMLString::compareString(elementname, X("MediaTime")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaTimeType;
    }
    this->SetMediaTime(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpatioTemporalLocatorType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetFigureTrajectory() != Mp7JrsNodePtr())
		result.Insert(GetFigureTrajectory());
	if (GetParameterTrajectory() != Mp7JrsNodePtr())
		result.Insert(GetParameterTrajectory());
	if (GetMediaTime() != Mp7JrsNodePtr())
		result.Insert(GetMediaTime());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtMethodImpl.h


