 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtImplInclude.h



#include "Mp7Jrsunsigned16.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:WordLink
#include "Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:PhoneLink

#include <assert.h>
IMp7JrsSpokenContentLatticeType_Block_Node_LocalType::IMp7JrsSpokenContentLatticeType_Block_Node_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtPropInit.h

}

IMp7JrsSpokenContentLatticeType_Block_Node_LocalType::~IMp7JrsSpokenContentLatticeType_Block_Node_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtPropCleanup.h

}

Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Mp7JrsSpokenContentLatticeType_Block_Node_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::~Mp7JrsSpokenContentLatticeType_Block_Node_LocalType()
{
	Cleanup();
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Init()
{

	// Init attributes
	m_num = Createunsigned16; // Create a valid class
	m_num->SetContent(0); // Use Value initialiser (xxx2)
	m_timeOffset = Createunsigned16; // Create a valid class
	m_timeOffset->SetContent(0); // Use Value initialiser (xxx2)
	m_speakerInfoRef = NULL; // String
	m_speakerInfoRef_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_WordLink = Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr(); // Collection
	m_PhoneLink = Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtMyPropInit.h

}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_num);
	// Mp7JrsFactory::DeleteObject(m_timeOffset);
	XMLString::release(&m_speakerInfoRef);
	// Mp7JrsFactory::DeleteObject(m_WordLink);
	// Mp7JrsFactory::DeleteObject(m_PhoneLink);
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SpokenContentLatticeType_Block_Node_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISpokenContentLatticeType_Block_Node_LocalType
    const Mp7JrsPtr< Mp7JrsSpokenContentLatticeType_Block_Node_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_num);
		this->Setnum(Mp7JrsFactory::CloneObject(tmp->Getnum()));
	}
	{
	// Mp7JrsFactory::DeleteObject(m_timeOffset);
		this->SettimeOffset(Mp7JrsFactory::CloneObject(tmp->GettimeOffset()));
	}
	{
	XMLString::release(&m_speakerInfoRef);
	if (tmp->ExistspeakerInfoRef())
	{
		this->SetspeakerInfoRef(XMLString::replicate(tmp->GetspeakerInfoRef()));
	}
	else
	{
		InvalidatespeakerInfoRef();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_WordLink);
		this->SetWordLink(Mp7JrsFactory::CloneObject(tmp->GetWordLink()));
		// Mp7JrsFactory::DeleteObject(m_PhoneLink);
		this->SetPhoneLink(Mp7JrsFactory::CloneObject(tmp->GetPhoneLink()));
}

Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7Jrsunsigned16Ptr Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Getnum() const
{
	return m_num;
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Setnum(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Setnum().");
	}
    m_num = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_num) m_num->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7Jrsunsigned16Ptr Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GettimeOffset() const
{
	return m_timeOffset;
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SettimeOffset(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SettimeOffset().");
	}
    m_timeOffset = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_timeOffset) m_timeOffset->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GetspeakerInfoRef() const
{
	return m_speakerInfoRef;
}

bool Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::ExistspeakerInfoRef() const
{
	return m_speakerInfoRef_Exist;
}
void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SetspeakerInfoRef(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SetspeakerInfoRef().");
	}
    m_speakerInfoRef = item;
	m_speakerInfoRef_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::InvalidatespeakerInfoRef()
{
	m_speakerInfoRef_Exist = false;
}
Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GetWordLink() const
{
	return m_WordLink;
}

Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GetPhoneLink() const
{
	return m_PhoneLink;
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SetWordLink(const Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SetWordLink().");
	}
	if (m_WordLink != item)
	{
		// Mp7JrsFactory::DeleteObject(m_WordLink);
		m_WordLink = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_WordLink) m_WordLink->SetParent(m_myself.getPointer());
		if(m_WordLink != Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_WordLink->SetContentName(XMLString::transcode("WordLink"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SetPhoneLink(const Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::SetPhoneLink().");
	}
	if (m_PhoneLink != item)
	{
		// Mp7JrsFactory::DeleteObject(m_PhoneLink);
		m_PhoneLink = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PhoneLink) m_PhoneLink->SetParent(m_myself.getPointer());
		if(m_PhoneLink != Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PhoneLink->SetContentName(XMLString::transcode("PhoneLink"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("WordLink")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:WordLink is item of type SpokenContentLatticeType_Block_Node_WordLink_LocalType
		// in element collection SpokenContentLatticeType_Block_Node_WordLink_CollectionType
		
		context->Found = true;
		Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr coll = GetWordLink();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpokenContentLatticeType_Block_Node_WordLink_CollectionType;
				SetWordLink(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 127))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SpokenContentLatticeType_Block_Node_WordLink_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PhoneLink")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:PhoneLink is item of type SpokenContentLatticeType_Block_Node_PhoneLink_LocalType
		// in element collection SpokenContentLatticeType_Block_Node_PhoneLink_CollectionType
		
		context->Found = true;
		Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr coll = GetPhoneLink();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType;
				SetPhoneLink(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 127))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SpokenContentLatticeType_Block_Node_PhoneLink_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SpokenContentLatticeType_Block_Node_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SpokenContentLatticeType_Block_Node_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsSpokenContentLatticeType_Block_Node_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::ContentToString() const
{
	// Mp7JrsSpokenContentLatticeType_Block_Node_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SpokenContentLatticeType_Block_Node_LocalType"));
    // Attribute Serialization:
	// Class
	if (m_num != Mp7Jrsunsigned16Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_num->ToText();
		element->setAttributeNS(X(""), X("num"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Class
	if (m_timeOffset != Mp7Jrsunsigned16Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_timeOffset->ToText();
		element->setAttributeNS(X(""), X("timeOffset"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
		

	// Optional attriute
	if(m_speakerInfoRef_Exist)
	{
	// String
	if(m_speakerInfoRef != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("speakerInfoRef"), m_speakerInfoRef);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_WordLink != Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_WordLink->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_PhoneLink != Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_PhoneLink->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("num")))
	{
        // Deserialize class type
		Mp7Jrsunsigned16Ptr tmp = Createunsigned16;
		tmp->Parse(parent->getAttributeNS(X(""), X("num")));
        this->Setnum(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("num")))
	{
		// Deserialize class type
        Mp7Jrsunsigned16Ptr tmp = Createunsigned16;
        tmp->Parse(parent->getAttribute(X("num")));
        this->Setnum(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("timeOffset")))
	{
        // Deserialize class type
		Mp7Jrsunsigned16Ptr tmp = Createunsigned16;
		tmp->Parse(parent->getAttributeNS(X(""), X("timeOffset")));
        this->SettimeOffset(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("timeOffset")))
	{
		// Deserialize class type
        Mp7Jrsunsigned16Ptr tmp = Createunsigned16;
        tmp->Parse(parent->getAttribute(X("timeOffset")));
        this->SettimeOffset(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("speakerInfoRef")))
	{
        // Deserialize string type
        this->SetspeakerInfoRef(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("speakerInfoRef"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("speakerInfoRef")))
	{
        // Deserialize string type
        this->SetspeakerInfoRef(Mp7JrsConvert::TextToString(parent->getAttribute(X("speakerInfoRef"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("WordLink"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("WordLink")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr tmp = CreateSpokenContentLatticeType_Block_Node_WordLink_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetWordLink(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("PhoneLink"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("PhoneLink")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr tmp = CreateSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetPhoneLink(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("WordLink")) == 0))
  {
    Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr tmp = CreateSpokenContentLatticeType_Block_Node_WordLink_CollectionType;
    this->SetWordLink(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("PhoneLink")) == 0))
  {
    Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr tmp = CreateSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType;
    this->SetPhoneLink(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpokenContentLatticeType_Block_Node_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetWordLink() != Mp7JrsNodePtr())
		result.Insert(GetWordLink());
	if (GetPhoneLink() != Mp7JrsNodePtr())
		result.Insert(GetPhoneLink());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtMethodImpl.h


