 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtImplInclude.h



#include "Mp7JrsSubjectTermDefinitionType_Classification_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Note_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSubjectTermDefinitionType_LocalType::IMp7JrsSubjectTermDefinitionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtPropInit.h

}

IMp7JrsSubjectTermDefinitionType_LocalType::~IMp7JrsSubjectTermDefinitionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtPropCleanup.h

}

Mp7JrsSubjectTermDefinitionType_LocalType::Mp7JrsSubjectTermDefinitionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSubjectTermDefinitionType_LocalType::~Mp7JrsSubjectTermDefinitionType_LocalType()
{
	Cleanup();
}

void Mp7JrsSubjectTermDefinitionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Classification = Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr(); // Collection
	m_Subdivision = Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr(); // Collection
	m_Note = Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr(); // Collection
	m_Term = Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsSubjectTermDefinitionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Classification);
	// Mp7JrsFactory::DeleteObject(m_Subdivision);
	// Mp7JrsFactory::DeleteObject(m_Note);
	// Mp7JrsFactory::DeleteObject(m_Term);
}

void Mp7JrsSubjectTermDefinitionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SubjectTermDefinitionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISubjectTermDefinitionType_LocalType
    const Mp7JrsPtr< Mp7JrsSubjectTermDefinitionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Classification);
		this->SetClassification(Mp7JrsFactory::CloneObject(tmp->GetClassification()));
		// Mp7JrsFactory::DeleteObject(m_Subdivision);
		this->SetSubdivision(Mp7JrsFactory::CloneObject(tmp->GetSubdivision()));
		// Mp7JrsFactory::DeleteObject(m_Note);
		this->SetNote(Mp7JrsFactory::CloneObject(tmp->GetNote()));
		// Mp7JrsFactory::DeleteObject(m_Term);
		this->SetTerm(Mp7JrsFactory::CloneObject(tmp->GetTerm()));
}

Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr Mp7JrsSubjectTermDefinitionType_LocalType::GetClassification() const
{
	return m_Classification;
}

Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr Mp7JrsSubjectTermDefinitionType_LocalType::GetSubdivision() const
{
	return m_Subdivision;
}

Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr Mp7JrsSubjectTermDefinitionType_LocalType::GetNote() const
{
	return m_Note;
}

Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr Mp7JrsSubjectTermDefinitionType_LocalType::GetTerm() const
{
	return m_Term;
}

// implementing setter for choice 
/* element */
void Mp7JrsSubjectTermDefinitionType_LocalType::SetClassification(const Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_LocalType::SetClassification().");
	}
	if (m_Classification != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Classification);
		m_Classification = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Classification) m_Classification->SetParent(m_myself.getPointer());
		if(m_Classification != Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Classification->SetContentName(XMLString::transcode("Classification"));
		}
	// Mp7JrsFactory::DeleteObject(m_Subdivision);
	m_Subdivision = Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Note);
	m_Note = Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Term);
	m_Term = Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSubjectTermDefinitionType_LocalType::SetSubdivision(const Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_LocalType::SetSubdivision().");
	}
	if (m_Subdivision != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Subdivision);
		m_Subdivision = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Subdivision) m_Subdivision->SetParent(m_myself.getPointer());
		if(m_Subdivision != Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Subdivision->SetContentName(XMLString::transcode("Subdivision"));
		}
	// Mp7JrsFactory::DeleteObject(m_Classification);
	m_Classification = Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Note);
	m_Note = Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Term);
	m_Term = Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSubjectTermDefinitionType_LocalType::SetNote(const Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_LocalType::SetNote().");
	}
	if (m_Note != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Note);
		m_Note = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Note) m_Note->SetParent(m_myself.getPointer());
		if(m_Note != Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Note->SetContentName(XMLString::transcode("Note"));
		}
	// Mp7JrsFactory::DeleteObject(m_Classification);
	m_Classification = Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Subdivision);
	m_Subdivision = Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Term);
	m_Term = Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSubjectTermDefinitionType_LocalType::SetTerm(const Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_LocalType::SetTerm().");
	}
	if (m_Term != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Term);
		m_Term = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Term) m_Term->SetParent(m_myself.getPointer());
		if(m_Term != Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Term->SetContentName(XMLString::transcode("Term"));
		}
	// Mp7JrsFactory::DeleteObject(m_Classification);
	m_Classification = Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Subdivision);
	m_Subdivision = Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_Note);
	m_Note = Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: SubjectTermDefinitionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSubjectTermDefinitionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSubjectTermDefinitionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSubjectTermDefinitionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSubjectTermDefinitionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	if (m_Classification != Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Classification->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Subdivision != Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Subdivision->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Note != Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Note->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Term != Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Term->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSubjectTermDefinitionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Classification"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Classification")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr tmp = CreateSubjectTermDefinitionType_Classification_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetClassification(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Subdivision"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Subdivision")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr tmp = CreateSubjectTermDefinitionType_Subdivision_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSubdivision(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Note"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Note")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr tmp = CreateSubjectTermDefinitionType_Note_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetNote(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Term"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Term")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr tmp = CreateSubjectTermDefinitionType_Term_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetTerm(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Classification")) == 0))
  {
    Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr tmp = CreateSubjectTermDefinitionType_Classification_CollectionType;
    this->SetClassification(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Subdivision")) == 0))
  {
    Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr tmp = CreateSubjectTermDefinitionType_Subdivision_CollectionType;
    this->SetSubdivision(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Note")) == 0))
  {
    Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr tmp = CreateSubjectTermDefinitionType_Note_CollectionType;
    this->SetNote(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Term")) == 0))
  {
    Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr tmp = CreateSubjectTermDefinitionType_Term_CollectionType;
    this->SetTerm(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSubjectTermDefinitionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetClassification() != Mp7JrsNodePtr())
		result.Insert(GetClassification());
	if (GetSubdivision() != Mp7JrsNodePtr())
		result.Insert(GetSubdivision());
	if (GetNote() != Mp7JrsNodePtr())
		result.Insert(GetNote());
	if (GetTerm() != Mp7JrsNodePtr())
		result.Insert(GetTerm());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtMethodImpl.h


