 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtImplInclude.h



#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsmediaTimePointType.h" // Element collection urn:mpeg:mpeg7:schema:2004:MediaTimePoint
#include "Mp7JrsMediaRelTimePointType.h" // Element collection urn:mpeg:mpeg7:schema:2004:MediaRelTimePoint
#include "Mp7JrsMediaRelIncrTimePointType.h" // Element collection urn:mpeg:mpeg7:schema:2004:MediaRelIncrTimePoint

#include <assert.h>
IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtPropInit.h

}

IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::~IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtPropCleanup.h

}

Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::~Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType()
{
	Cleanup();
}

void Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_MediaTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr(); // Collection
	m_MediaRelTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr(); // Collection
	m_MediaRelIncrTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtMyPropInit.h

}

void Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_MediaTimePoint);
	// Mp7JrsFactory::DeleteObject(m_MediaRelTimePoint);
	// Mp7JrsFactory::DeleteObject(m_MediaRelIncrTimePoint);
}

void Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use TemporalInterpolationType_KeyTimePoint_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ITemporalInterpolationType_KeyTimePoint_LocalType
    const Mp7JrsPtr< Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_MediaTimePoint);
		this->SetMediaTimePoint(Mp7JrsFactory::CloneObject(tmp->GetMediaTimePoint()));
		// Mp7JrsFactory::DeleteObject(m_MediaRelTimePoint);
		this->SetMediaRelTimePoint(Mp7JrsFactory::CloneObject(tmp->GetMediaRelTimePoint()));
		// Mp7JrsFactory::DeleteObject(m_MediaRelIncrTimePoint);
		this->SetMediaRelIncrTimePoint(Mp7JrsFactory::CloneObject(tmp->GetMediaRelIncrTimePoint()));
}

Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::GetMediaTimePoint() const
{
	return m_MediaTimePoint;
}

Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::GetMediaRelTimePoint() const
{
	return m_MediaRelTimePoint;
}

Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::GetMediaRelIncrTimePoint() const
{
	return m_MediaRelIncrTimePoint;
}

// implementing setter for choice 
/* element */
void Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::SetMediaTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::SetMediaTimePoint().");
	}
	if (m_MediaTimePoint != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaTimePoint);
		m_MediaTimePoint = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaTimePoint) m_MediaTimePoint->SetParent(m_myself.getPointer());
		if(m_MediaTimePoint != Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaTimePoint->SetContentName(XMLString::transcode("MediaTimePoint"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaRelTimePoint);
	m_MediaRelTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaRelIncrTimePoint);
	m_MediaRelIncrTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::SetMediaRelTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::SetMediaRelTimePoint().");
	}
	if (m_MediaRelTimePoint != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaRelTimePoint);
		m_MediaRelTimePoint = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaRelTimePoint) m_MediaRelTimePoint->SetParent(m_myself.getPointer());
		if(m_MediaRelTimePoint != Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaRelTimePoint->SetContentName(XMLString::transcode("MediaRelTimePoint"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaTimePoint);
	m_MediaTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaRelIncrTimePoint);
	m_MediaRelIncrTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::SetMediaRelIncrTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::SetMediaRelIncrTimePoint().");
	}
	if (m_MediaRelIncrTimePoint != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaRelIncrTimePoint);
		m_MediaRelIncrTimePoint = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaRelIncrTimePoint) m_MediaRelIncrTimePoint->SetParent(m_myself.getPointer());
		if(m_MediaRelIncrTimePoint != Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaRelIncrTimePoint->SetContentName(XMLString::transcode("MediaRelIncrTimePoint"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaTimePoint);
	m_MediaTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaRelTimePoint);
	m_MediaRelTimePoint = Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("MediaTimePoint")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:MediaTimePoint is item of type mediaTimePointType
		// in element collection TemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType
		
		context->Found = true;
		Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr coll = GetMediaTimePoint();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType;
				SetMediaTimePoint(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 65535))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:mediaTimePointType")))) != empty)
			{
				// Is type allowed
				Mp7JrsmediaTimePointPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaRelTimePoint")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:MediaRelTimePoint is item of type MediaRelTimePointType
		// in element collection TemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType
		
		context->Found = true;
		Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr coll = GetMediaRelTimePoint();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType;
				SetMediaRelTimePoint(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 65535))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaRelTimePointType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaRelTimePointPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaRelIncrTimePoint")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:MediaRelIncrTimePoint is item of type MediaRelIncrTimePointType
		// in element collection TemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType
		
		context->Found = true;
		Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr coll = GetMediaRelIncrTimePoint();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType;
				SetMediaRelIncrTimePoint(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 65535))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaRelIncrTimePointType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaRelIncrTimePointPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for TemporalInterpolationType_KeyTimePoint_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "TemporalInterpolationType_KeyTimePoint_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}

bool Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::ContentToString() const
{
	// Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("TemporalInterpolationType_KeyTimePoint_LocalType"));
	// Element serialization:
	if (m_MediaTimePoint != Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MediaTimePoint->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_MediaRelTimePoint != Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MediaRelTimePoint->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_MediaRelIncrTimePoint != Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MediaRelIncrTimePoint->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
    {
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("MediaTimePoint"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("MediaTimePoint")) == 0))
        {
            // Deserialize factory type
            Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr tmp = CreateTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMediaTimePoint(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("MediaRelTimePoint"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("MediaRelTimePoint")) == 0))
        {
            // Deserialize factory type
            Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr tmp = CreateTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMediaRelTimePoint(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("MediaRelIncrTimePoint"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("MediaRelIncrTimePoint")) == 0))
        {
            // Deserialize factory type
            Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr tmp = CreateTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMediaRelIncrTimePoint(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("MediaTimePoint")) == 0))
  {
    Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr tmp = CreateTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType;
    this->SetMediaTimePoint(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("MediaRelTimePoint")) == 0))
  {
    Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr tmp = CreateTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType;
    this->SetMediaRelTimePoint(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("MediaRelIncrTimePoint")) == 0))
  {
    Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr tmp = CreateTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType;
    this->SetMediaRelIncrTimePoint(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMediaTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetMediaTimePoint());
	if (GetMediaRelTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetMediaRelTimePoint());
	if (GetMediaRelIncrTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetMediaRelIncrTimePoint());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtMethodImpl.h


