
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType_ExtImplInclude.h


#include "Mp7JrsTitleType_type_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsTitleType_type_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsTitleType_type_LocalType::ToText(Mp7JrsTitleType_type_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/main:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("main");
			break;
		case /*Enumeration::*/secondary:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("secondary");
			break;
		case /*Enumeration::*/alternative:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("alternative");
			break;
		case /*Enumeration::*/original:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("original");
			break;
		case /*Enumeration::*/popular:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("popular");
			break;
		case /*Enumeration::*/opusNumber:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("opusNumber");
			break;
		case /*Enumeration::*/songTitle:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("songTitle");
			break;
		case /*Enumeration::*/albumTitle:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("albumTitle");
			break;
		case /*Enumeration::*/seriesTitle:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("seriesTitle");
			break;
		case /*Enumeration::*/episodeTitle:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("episodeTitle");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsTitleType_type_LocalType::Enumeration Mp7JrsTitleType_type_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsTitleType_type_LocalType::Enumeration result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "main") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/main;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "secondary") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/secondary;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "alternative") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/alternative;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "original") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/original;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "popular") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/popular;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "opusNumber") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/opusNumber;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "songTitle") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/songTitle;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "albumTitle") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/albumTitle;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "seriesTitle") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/seriesTitle;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "episodeTitle") == 0)
	{
		result = Mp7JrsTitleType_type_LocalType::/*Enumeration::*/episodeTitle;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
