/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// Based on Factory_CPP.template

#include <stdio.h>
#include "Mp7JrsVisualDTypeFactory.h"
#include "Mp7JrsVisualDType.h"

Mp7JrsVisualDTypeFactory::Mp7JrsVisualDTypeFactory()
    : Mp7JrsFactory("urn:mpeg:mpeg7:schema:2004:VisualDType", "urn:mpeg:mpeg7:schema:2004:VisualDType")
{
}

Mp7JrsVisualDTypeFactory::~Mp7JrsVisualDTypeFactory()
{
}

const char * Mp7JrsVisualDTypeFactory::GetTypeName() const
{
	// Note: This is slow
	// return Mp7JrsVisualDType().GetTypeName();
	
	// FTT Easier but needs more memory in debug mode (no string pooling)
	return "urn:mpeg:mpeg7:schema:2004:VisualDType";
}

Mp7JrsNodePtr Mp7JrsVisualDTypeFactory::CreateObject()
{
	return Mp7JrsNodePtr(new Mp7JrsVisualDType);
}
