
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsauxiliaryLanguageType_LocalType_ExtImplInclude.h


#include "Mp7JrsauxiliaryLanguageType_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsauxiliaryLanguageType_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsauxiliaryLanguageType_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsauxiliaryLanguageType_LocalType::ToText(Mp7JrsauxiliaryLanguageType_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/dubbed:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("dubbed");
			break;
		case /*Enumeration::*/closedCaptions:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("closedCaptions");
			break;
		case /*Enumeration::*/subTitles:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("subTitles");
			break;
		case /*Enumeration::*/signLanguage:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("signLanguage");
			break;
		case /*Enumeration::*/audioDescription:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("audioDescription");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsauxiliaryLanguageType_LocalType::Enumeration Mp7JrsauxiliaryLanguageType_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsauxiliaryLanguageType_LocalType::Enumeration result = Mp7JrsauxiliaryLanguageType_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "dubbed") == 0)
	{
		result = Mp7JrsauxiliaryLanguageType_LocalType::/*Enumeration::*/dubbed;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "closedCaptions") == 0)
	{
		result = Mp7JrsauxiliaryLanguageType_LocalType::/*Enumeration::*/closedCaptions;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "subTitles") == 0)
	{
		result = Mp7JrsauxiliaryLanguageType_LocalType::/*Enumeration::*/subTitles;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "signLanguage") == 0)
	{
		result = Mp7JrsauxiliaryLanguageType_LocalType::/*Enumeration::*/signLanguage;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "audioDescription") == 0)
	{
		result = Mp7JrsauxiliaryLanguageType_LocalType::/*Enumeration::*/audioDescription;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
