 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtImplInclude.h



#include "Mp7JrsdependencyOperatorType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsdependencyOperatorType::IMp7JrsdependencyOperatorType()
{

// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtPropInit.h

}

IMp7JrsdependencyOperatorType::~IMp7JrsdependencyOperatorType()
{
// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtPropCleanup.h

}

Mp7JrsdependencyOperatorType::Mp7JrsdependencyOperatorType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsdependencyOperatorType::~Mp7JrsdependencyOperatorType()
{
	Cleanup();
}

void Mp7JrsdependencyOperatorType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_dependencyOperatorType_LocalType = Mp7JrsdependencyOperatorType_LocalType::UninitializedEnumeration; // Enumeration


// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtMyPropInit.h

}

void Mp7JrsdependencyOperatorType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtMyPropCleanup.h


}

void Mp7JrsdependencyOperatorType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use dependencyOperatorTypePtr, since we
	// might need GetBase(), which isn't defined in IdependencyOperatorType
    const Mp7JrsPtr< Mp7JrsdependencyOperatorType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if(tmp->GetdependencyOperatorType_LocalType() != Mp7JrsdependencyOperatorType_LocalType::UninitializedEnumeration)
	{
		this->SetdependencyOperatorType_LocalType(tmp->GetdependencyOperatorType_LocalType());
		return;
	}
	}
}

Mp7JrsNodePtr Mp7JrsdependencyOperatorType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsdependencyOperatorType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsdependencyOperatorType_LocalType::Enumeration Mp7JrsdependencyOperatorType::GetdependencyOperatorType_LocalType() const
{
	return m_dependencyOperatorType_LocalType;
}

void Mp7JrsdependencyOperatorType::SetdependencyOperatorType_LocalType(Mp7JrsdependencyOperatorType_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsdependencyOperatorType::SetdependencyOperatorType_LocalType().");
	}
	if (m_dependencyOperatorType_LocalType != item)
	{
		// nothing to free here, hopefully
		m_dependencyOperatorType_LocalType = item;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsdependencyOperatorType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsdependencyOperatorType::ToText() const
{
	if(m_dependencyOperatorType_LocalType != Mp7JrsdependencyOperatorType_LocalType::UninitializedEnumeration)
	{
		return Mp7JrsdependencyOperatorType_LocalType::ToText(m_dependencyOperatorType_LocalType);
	}
	return XMLString::transcode("");
}


bool Mp7JrsdependencyOperatorType::Parse(const XMLCh * const txt)
{
	// Parse stu enumeration
	{
		Mp7JrsdependencyOperatorType_LocalType::Enumeration tmp = Mp7JrsdependencyOperatorType_LocalType::Parse(txt);
		if(tmp != Mp7JrsdependencyOperatorType_LocalType::UninitializedEnumeration)
		{
			this->SetdependencyOperatorType_LocalType(tmp);
			return true;
		}
	}
	return false;
}

bool Mp7JrsdependencyOperatorType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsdependencyOperatorType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsdependencyOperatorType::ContentToString() const
{
	// Mp7JrsdependencyOperatorType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsdependencyOperatorType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("dependencyOperatorType"));
	// Element serialization:
	if(m_dependencyOperatorType_LocalType != Mp7JrsdependencyOperatorType_LocalType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsdependencyOperatorType_LocalType::ToText(m_dependencyOperatorType_LocalType);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("dependencyOperatorType_LocalType"), false);
		XMLString::release(&tmp);
	}

}

bool Mp7JrsdependencyOperatorType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("dependencyOperatorType_LocalType"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("dependencyOperatorType_LocalType")) == 0))
        {
            Mp7JrsdependencyOperatorType_LocalType::Enumeration tmp = Mp7JrsdependencyOperatorType_LocalType::Parse(Mp7JrsUtil::GetElementText(parent));
            if(tmp == Mp7JrsdependencyOperatorType_LocalType::UninitializedEnumeration)
            {
                    return false;
            }
            this->SetdependencyOperatorType_LocalType(tmp);
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsdependencyOperatorType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsdependencyOperatorType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtMethodImpl.h


