
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_LocalType_ExtImplInclude.h


#include "Mp7JrsdependencyOperatorType_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsdependencyOperatorType_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsdependencyOperatorType_LocalType::ToText(Mp7JrsdependencyOperatorType_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/subject:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("subject");
			break;
		case /*Enumeration::*/object:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("object");
			break;
		case /*Enumeration::*/indirectObject:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("indirectObject");
			break;
		case /*Enumeration::*/predicate:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("predicate");
			break;
		case /*Enumeration::*/expletive:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("expletive");
			break;
		case /*Enumeration::*/nonRestrictive:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("nonRestrictive");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsdependencyOperatorType_LocalType::Enumeration Mp7JrsdependencyOperatorType_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsdependencyOperatorType_LocalType::Enumeration result = Mp7JrsdependencyOperatorType_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "subject") == 0)
	{
		result = Mp7JrsdependencyOperatorType_LocalType::/*Enumeration::*/subject;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "object") == 0)
	{
		result = Mp7JrsdependencyOperatorType_LocalType::/*Enumeration::*/object;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "indirectObject") == 0)
	{
		result = Mp7JrsdependencyOperatorType_LocalType::/*Enumeration::*/indirectObject;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "predicate") == 0)
	{
		result = Mp7JrsdependencyOperatorType_LocalType::/*Enumeration::*/predicate;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "expletive") == 0)
	{
		result = Mp7JrsdependencyOperatorType_LocalType::/*Enumeration::*/expletive;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "nonRestrictive") == 0)
	{
		result = Mp7JrsdependencyOperatorType_LocalType::/*Enumeration::*/nonRestrictive;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
