
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsphoneticAlphabetType_ExtImplInclude.h


#include "Mp7JrsphoneticAlphabetType.h"

// no includefile for extension defined 
// file Mp7JrsphoneticAlphabetType_ExtMethodImpl.h


const XMLCh * Mp7JrsphoneticAlphabetType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsphoneticAlphabetType::ToText(Mp7JrsphoneticAlphabetType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/sampa:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("sampa");
			break;
		case /*Enumeration::*/ipaSymbol:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("ipaSymbol");
			break;
		case /*Enumeration::*/ipaNumber:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("ipaNumber");
			break;
		case /*Enumeration::*/other:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("other");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsphoneticAlphabetType::Enumeration Mp7JrsphoneticAlphabetType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsphoneticAlphabetType::Enumeration result = Mp7JrsphoneticAlphabetType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "sampa") == 0)
	{
		result = Mp7JrsphoneticAlphabetType::/*Enumeration::*/sampa;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "ipaSymbol") == 0)
	{
		result = Mp7JrsphoneticAlphabetType::/*Enumeration::*/ipaSymbol;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "ipaNumber") == 0)
	{
		result = Mp7JrsphoneticAlphabetType::/*Enumeration::*/ipaNumber;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "other") == 0)
	{
		result = Mp7JrsphoneticAlphabetType::/*Enumeration::*/other;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
