
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2010, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsuserChoiceType_ExtImplInclude.h


#include "Mp7JrsuserChoiceType.h"

// no includefile for extension defined 
// file Mp7JrsuserChoiceType_ExtMethodImpl.h


const XMLCh * Mp7JrsuserChoiceType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsuserChoiceType::ToText(Mp7JrsuserChoiceType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/_true:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("true");
			break;
		case /*Enumeration::*/_false:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("false");
			break;
		case /*Enumeration::*/user:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("user");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsuserChoiceType::Enumeration Mp7JrsuserChoiceType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsuserChoiceType::Enumeration result = Mp7JrsuserChoiceType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "true") == 0)
	{
		result = Mp7JrsuserChoiceType::/*Enumeration::*/_true;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "false") == 0)
	{
		result = Mp7JrsuserChoiceType::/*Enumeration::*/_false;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "user") == 0)
	{
		result = Mp7JrsuserChoiceType::/*Enumeration::*/user;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
